!
! File is DailyDesignations.f90
!
! this file determines the provider specific normal flow designations from daily runoff estimates
!
! created on 01.09.12
!
! david arthur sampson
! last write was: 02.10.12
! =================================================================================================
!
! ============================
Module lm_DesignationsDaily_A
 use gm_ModelControl
  use gm_GlobalData

    implicit none
    ! -----------
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
 contains
    subroutine initAdesignationsDaily()
      call openFiles_AdesignationsD()
      call readFiles_AdesignationsD()
    end subroutine initAdesignationsDaily
    !
      subroutine openFiles_AdesignationsD()

          character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
          if(gpl_release)lvc_dataPath=trim(gvc_DPath)
          !
           LU=45
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Designations_Daily.txt'),exist=lexist)
          if(lexist)then
            open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Designations_Daily.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Designations_A missing(or corrupted): SVT_Designations_Daily.txt", "Logical Unit = ", LU 
            endif
          endif
           !
           LU=46
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Threshold_Daily.txt'),exist=lexist)
          if(lexist)then
            open(LU,FILE=trim(trim(lvc_dataPath) &
            //'App_Data\Parameters\SVT_Threshold_Daily.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Designations_A missing(or corrupted): SVT_Threshold_Daily.txt", "Logical Unit = ", LU 
            endif
          endif
        return
       end subroutine openFiles_AdesignationsD
      ! --------------------------------------

      ! -----------------------------------
      subroutine readFiles_AdesignationsD()
           integer :: LU
            integer :: i,j,ios
!            real, parameter :: lvf_trottConstant=5.282934211 ! this is the AF per acre entitled on an annual basis
            real(8) :: lvd_dailyDesignationsSVT(42,10)
            real(8) :: lvd_dailyThresholdSVT(42,2)
            !
            !--------------------------------------------------------------------------
            !
            read(45,*,err=5,iostat=ios)((lvd_dailyDesignationsSVT(i,j),j=1,10),i=1,42)
            read(46,*,err=6,iostat=ios)((lvd_dailyThresholdSVT(i,j),j=1,2),i=1,42)
            !
            lid_dailyDesignationsSVT=lvd_dailyDesignationsSVT
            lid_dailyThresholdSVT=lvd_dailyThresholdSVT
            !
5          continue
            if(ios >0)then
             LU=45
             goto 1000
            endif
6          continue
            if(ios >0)then
             LU=46
             goto 1000
            endif
            ! NOTE: not closed if an err is returned
            do i = 45,46,1
             close(i)
            end do
            !
          return
1000     continue
           if(gvl_WriteToDisk)&
            write(7,*)'DailyDesignations.f90 line 101: Error in file read, logical unit is', LU
      end subroutine readFiles_AdesignationsD
      ! -------------------------------------
End Module lm_DesignationsDaily_A

Module lms_DesignationsDaily_A
 use gm_ModelControl
  use gm_GlobalData
   use gm_Global
    use gm_TypeControl

    implicit none
    ! -----------
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
    integer, private :: yr,doy,iRecStart
    real,private  :: SVTflow(gpi_dailySVT)
 contains
  !
    subroutine extract(T)
        integer :: i
        real :: lvf_modClimateDrought
        logical :: lvl_pass=.true.
            !
        type(runTime)T
            !  This will have to be incremented each year
            !  flow in units cfs
            lvl_pass=.true.
            if(T%year == T%Startyear)gvi_countYearsSVT=0
                 do i = 1,gpi_dailySVTrec,1
                    if(gvf_flowSVT(i,1) == gv_indexyearSVT+gvi_countYearsSVT)then
                        if(lvl_pass)iRecStart=i
                        lvf_modClimateDrought=fmodFlowSVTdaily(T)
                        SVTflow(i)=gvf_flowSVT(i,3)*lvf_modClimateDrought
                        lvl_pass=.false.
                    endif
                end do
            !
        return
     end subroutine extract
     ! --------------------

    ! --------------------------
    function fmodFlowSVTdaily(T)
        real :: fmodFlowSVTdaily
        real :: lvf_droughtFactor
        type(runTime)T
        ! ============
        !
           lvf_droughtFactor=1.0
         if(T%year >= gv_droughtyearSVT)then
          if(T%year <  gv_droughtyearendSVT)then
            lvf_droughtFactor=gv_droughtfactorSVT
          endif
         endif
            !
             fmodFlowSVTdaily= lvf_droughtFactor*gv_climatefactorSVT
            !
    end function fmodFlowSVTdaily
    ! ---------------------------

    ! --------------------------------------
    subroutine designations(T,gvd_ClassAarray)
        integer :: i,j,k,h !,count
        integer(1) :: lvi_vList(42)
        integer :: lvi_addDays,lvi_countDays
        integer :: lvi_normalFlowAvailable(10)

        logical :: lvl_start=.true.
        real(8) :: gvd_ClassAarray(10)
        !
!        real, parameter :: lvf_constantTrott=0.01487629 ! convert AF yr-1 to AF day-1
        real(8),parameter :: lvd_convert=1.983471074380165 != (3600*24)/43560 to convert cfs to acre-feet
        !
        real ::  lvf_targetDesignationsD(10),lvf_flowDifference(42)
        real :: lvf_rightsNextTrott(10),lvf_addDailyDesignations(10),lvf_addThresholdDiff(10)
        real :: lvf_trottDifference,lvf_differenceToThreshold, lvf_flow
        real :: lvf_sumTrott,lvf_sumTrottPlus1
        real :: fModifyNormalFlow
        real :: lvf_modifyNormalFlow(10)
        real :: lvf_normalFlow(10)

        !--- TYPE constructs ---
        type(runTime)T
        ! ======================

            !
        do i = 1,42,1
         lvi_vList(i)=1
        end do
        do j = 1,10,1
         lvf_addDailyDesignations(j)=0.
         lvi_normalFlowAvailable(j)=0.
         lvf_modifyNormalFlow(j)=0
        end do
!        if(T%year == T%Startyear)then
!         iRecStart=1
            lvf_normalFlow=gvf_modifyNormalFlow
               if(gpl_validate)then
                  ! This variable -lvf_modifyNormalFlow(10) - gets written into memory
                  ! for use when T%year > T%Startyear
                  do j = 1,10,1
                     lvf_modifyNormalFlow(j)=0
                    lvf_modifyNormalFlow(j)=fModifyNormalFlow(lvf_normalFlow(j))
                  end do
               endif
!        endif
         ! Find the number of days in the year; Run the loop for one year each day
         lvi_addDays=leapYear(gvf_flowSVT(iRecStart,1))
         lvi_countDays=0
        do h = iRecStart,iRecStart+lvi_addDays-1,1
            lvi_countDays=lvi_countDays+1
            yr =gvf_flowSVT(h,1)
            doy=gvf_flowSVT(h,2)
            lvf_flow=SVTflow(h)
                 ! If flow is greater than max, set the threshold designations
                if(lvf_flow > lid_dailyThresholdSVT(42,1))then
                    do k = 1,10,1
                         lvf_targetDesignationsD(k)=0
                        lvf_targetDesignationsD(k)= lid_dailyDesignationsSVT(42,k)
                        !
                        lvf_addDailyDesignations(k)=lvf_addDailyDesignations(k)+ lvf_targetDesignationsD(k)
                        !
                        lvf_addThresholdDiff(k)=0
                            !
                                if(gpl_validate)then
                                ! output for the interface- hav not tried this type of model-interface passing.
                                ! 02.07.12,02.08.12 DAS
                                  if(0 < lvf_modifyNormalFlow(k))then
                                    lvi_normalFlowAvailable(k)=nint(((lvf_targetDesignationsD(k)+lvf_addThresholdDiff(k))*(1./ lvf_modifyNormalFlow(k)))*lvd_convert)
                                  endif
                                !
                                  if(.not. gpl_release)gvl_WriteToMyDisk=.true.
                                    if(gvl_WriteToMyDisk)then
                                      if(lvl_start)then
                                        write(5,*)" Year "," Provider "," Normal Flow: AF day-1"
                                        write(5,*)T%year,k,lvi_normalFlowAvailable(k)
                                      else
                                        write(5,*)T%year,k,lvi_normalFlowAvailable(k)
                                      endif
                                     lvl_start=.false.
                                    endif
                                endif
                            !
                    end do  
                 else
                    ! Find the threshold flow limits and designations
                    ! 03.05.12 changed this from j=1,42,1 to j = 2,42,1
                    do j=2,42,1   
                        if(lvf_flow <= lid_dailyThresholdSVT(j,1))lvi_vList(j)= -1
                        if(lvi_vList(j) < 1)then
                            lvf_flowDifference(j)=0
                            
                            if(lid_dailyThresholdSVT(j-1,1) < lvf_flow)then
                                lvf_flowDifference(j)=lvf_flow-lid_dailyThresholdSVT(j-1,1)
                            endif
                            !
                            lvf_sumTrott=0. ;lvf_sumTrottPlus1=0.
                            do i = 1,10,1
                                lvf_sumTrott=lvf_sumTrott+lid_dailyDesignationsSVT(j-1,i)
                                lvf_sumTrottPlus1=lvf_sumTrottPlus1+lid_dailyDesignationsSVT(j,i)
                            end do
                            !
                             lvf_trottDifference=0
                            lvf_trottDifference=lid_dailyThresholdSVT(j,1)-lid_dailyThresholdSVT(j-1,1)
                             lvf_differenceToThreshold=0
                            if(0 < lvf_trottDifference)lvf_differenceToThreshold=lvf_flowDifference(j)/lvf_trottDifference
                            !
                            do k = 1,10,1
                                lvf_targetDesignationsD(k)=0.
                                lvf_rightsNextTrott(k)=0.
                                !
                                ! Set the normal flow designation (cfs day-1)
                                lvf_targetDesignationsD(k)=lid_dailyDesignationsSVT(j-1,k)
                                ! providerTrott() found in Designations_SVT.f90 [listed in the include file]
                                lvf_rightsNextTrott(k)=li_providerTrott(j-1,k)  
                                !
                                 lvf_addThresholdDiff(k)=0.
                                lvf_addThresholdDiff(k)=lvf_rightsNextTrott(k)*(lid_dailyThresholdSVT(j,2)*lvf_differenceToThreshold) &
                                    *(lvf_sumTrottPlus1-lvf_sumTrott)
                                !
                                lvf_addDailyDesignations(k)=lvf_addDailyDesignations(k)+ lvf_targetDesignationsD(k)+lvf_addThresholdDiff(k)
                                !
                                if(gpl_validate)then
                                ! output for the interface- hav not tried this type of model-interface passing.
                                ! 02.07.12,02.08.12 DAS
                                  if(0 < lvf_modifyNormalFlow(k))then
                                    lvi_normalFlowAvailable(k)=nint(((lvf_targetDesignationsD(k)+lvf_addThresholdDiff(k))*(1./ lvf_modifyNormalFlow(k)))*lvd_convert)
                                  endif
                                !
                                  if(.not. gpl_release)gvl_WriteToMyDisk=.true.
                                    if(gvl_WriteToMyDisk)then
                                      if(lvl_start)then
                                        write(5,*)" Year "," Provider ","Water Year"," Normal Flow: AF day-1"
                                        write(5,*)T%year,k,yr,lvi_normalFlowAvailable(k)
                                      else
                                        write(5,*)T%year,k,yr,lvi_normalFlowAvailable(k)
                                      endif
                                     lvl_start=.false.
                                    endif
                                endif

                            end do ! k = 1,10 of the SRP members
                        endif ! lvi_vList < 1
                            if(lvi_vList(j)< 1)exit
                    end do ! 1 to 42 of threshold
                endif !  flow > thresholddesig(42)
            do i = 1,42,1
                lvi_vList(j)= 1
            end do
        end do ! file record loop (individual days)
        !
            do i = 1,10,1
               gvd_ClassAarray(i)=0
              gvd_ClassAarray(i)=(lvf_addDailyDesignations(i)*lvd_convert)*gpd_acftTomaf
            end do
        !
      return
    end subroutine designations
    ! -------------------------
    ! DAS
    ! -------------------
    function leapYear(yr)
     integer :: year
     real :: leapYear,yr
        !
        year = yr
        leapYear=365
	    if(year == 1948 .OR. year == 1952 .OR. year == 1956 .OR. year == 1960 .OR. year == 1964 & 
            .OR. year == 1968 .OR. year == 1972 .OR. year == 1976 .OR. year == 1980 .OR. year == 1984 &
            .OR. year == 1988 .OR. year == 1992 .OR. year == 1996 .OR. year == 2000 .OR. year == 2004 &
	        .OR. year == 2008 .OR. year == 2012)then;
            leapYear=366
        endif
        !
    end function leapYear
    ! -------------------

!http://aa.usno.navy.mil/faq/docs/JD_Formula.php
End Module lms_DesignationsDaily_A

! ----------------------------------------
subroutine extractDaily(T,gvd_ClassAarray)
 use lms_DesignationsDaily_A
    real(8) :: gvd_ClassAarray(10)
    type(runTime)T
    ! =============
        !
        call extract(T)
        call designations(T,gvd_ClassAarray) ! maf
        !
    return
end subroutine extractDaily
! -------------------------
!
! =================================================================================================
! E.O.F.