!
! File is Designations_CO.f90
!
! This file contains the calculations of surface water designations for Coloroado River 
! Water. CAP designations and CAP additions (for now)
!
! Global OUTPUTS: 
!                 
!
! Local OUTPUTS: 
!                 
!                                         
!              
! Local INPUTS:             
!
!------------------------------------------------------------------------------------
!
! created on 06.08.10
!
! david arthur sampson
! last write was: 03.05.12
! =================================================================================================
!
Module lm_Designations_B
use gm_ModelControl
  use gm_GlobalData

    implicit none
    ! -----------
    include "C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt"
    !
 contains
    subroutine initBdesignations()
      call openFiles_Bdesignations()
      call readParms_pvD()
      call readFiles_Bdesignations()
    end subroutine initBdesignations
    ! ------------------------------

    ! ----------------------------------
    subroutine openFiles_Bdesignations()
 
          character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
          if(gpl_release)lvc_dataPath=trim(gvc_DPath)
          !
           LU=35
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_PV.dat'),exist=lexist)
          if(lexist)then
            open(35,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_PV.dat'))
          else
             if(gvl_WriteToDisk)then
              write(7,*)"Data in module lm_Designations_B missing(or corrupted): parm_PV.dat", "Logical Unit = ", LU 
             endif
          endif

            LU=36
          if(lexist)then
            open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SurfaceWaterDesignations.txt'))
          else
             if(gvl_WriteToDisk)then
              write(7,*)"Data in module lm_Designations_B missing(or corrupted):SurfaceWaterDesignations.txt", "Logical Unit = ", LU 
             endif
          endif

          LU=43
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\CAPdesignations.txt'),exist=lexist)
          if(lexist)then
            open(43,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\CAPdesignations.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
              write(7,*)"Data in module lm_Designations_B missing (or corrupted): CAPdesignations.txt", "Logical Unit = ", LU 
             endif
          endif
        return
    end subroutine openFiles_Bdesignations
    ! ------------------------------------

       ! -----------------------
      subroutine readParms_pvD()
         !
         read(35,*)li_capIndianPercents(1)
         read(35,*)li_capIndianPercents(2)
         read(35,*)li_capIndianPercents(3)
         read(35,*)li_capEquationparms(1)
         read(35,*)li_capEquationparms(2)
         read(35,*)li_capEquationparms(3)
         read(35,*)li_capacftthresholds(1)
         read(35,*)li_capacftthresholds(2)
         read(35,*)li_capacftthresholds(3)
         read(35,*)li_capacftthresholds(4)
         read(35,*)li_capacftthresholds(5)
         read(35,*)li_capminIPW
         close(35)
         !
         return
        end subroutine readParms_pvD
       ! ---------------------------
      ! ----------------------------------
      subroutine readFiles_Bdesignations()
      integer :: LU
      integer :: j,k,ios
!      real :: lv_designationsCAPandSRP(gvi_maxProV,3)
       !
       !----------------------------------------------------------------------------
       ! 12.20.11 DAS
       read(43,*,err=34,iostat=ios)((li_designationsCAP(j,k),k=1,2),j=1,gvi_maxProV)
34     continue
       if(ios >0)then
        LU=43
        goto 1000
       endif
       close(43) ! added on 08.27.10
       !
       read(36,*,err=36,iostat=ios)(( gvf_designationsCAPandSRP(j,k),k=1,3),j=1,gvi_maxProV)
36     continue
       if(ios >0)then
        LU=43
        goto 1000
       endif
       close(36) ! added on 03.05.12
        ! Surface water from the ADWR AWS documents for threshold drought analysis of
        ! groundwater use (see Groundwater.f90) .  Three columns, one = CAP,2=SRP, 3=Other
            !
           
            !
      return
1000     continue
      if(gvl_WriteToDisk) &
       write(7,*)'Designations_CO.f90 line 106: Error in file read, logical unit is', LU
    end subroutine readFiles_Bdesignations
    ! ------------------------------------
End Module lm_Designations_B

Module lms_Designations_B
 use gm_ModelControl
  use gm_GlobalData
   use gm_TypeControl

    implicit none
    ! -----------
     include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
    type Designations_B
     real(8) :: lv_capMandItiers_acft(5,2),lv_CAPIIexcess_acft
     real(8) :: lv_realizedDesignation_B_acft(gpi_lBY:gpi_uBY,gvi_maxProV),lv_CAPMandI_II(gpi_lBY:gpi_uBY)
     real :: lvf_indianII(gpi_lBY:gpi_uBY),lvf_indianIII(gpi_lBY:gpi_uBY),lvf_CAPdifference(gpi_lBY:gpi_uBY),lvf_holdD2
    end type Designations_B
    !
  contains
  !
       !----------------------------------------
       subroutine aPartition_B(T,conveyance,vDb)

           integer :: i,j
           real(8), intent(in) :: conveyance
           real(8) :: CAPw
           real(8) :: lv_threshTiers(5),lv_CAPmandiTiers_acft(5,2),lv_CAPindianTiers_acft(5,2)
           real(8), parameter :: Indian2=93302.729
           real(8), parameter :: lv_capIndianPercents_1=30.555555555555555556
           real(8), parameter :: lv_capIndianPercents_2=63.62482
           real(8), parameter :: lv_capIndianPercents_3=40.7454935316344
!           real(8), parameter :: lvd_MandI=620678

           type(Designations_B)vDb
           type(runTime)T
           ! ===============
            !
            ! as of 24 May, 2010 this is total CAP water
            CAPw=0
            CAPw = dnint(conveyance* (1./gpd_acftTomaf))     ! maf a-1 to acft a-1  
            !
!               if(gpl_Testing)CAPw = 853079
            do i = 1,5,1
               lv_threshTiers(i)=0.
              do j = 1,2
               lv_CAPmandiTiers_acft(i,j)=0.
               lv_CAPindianTiers_acft(i,j)=0.
               vDb%lv_capMandItiers_acft(i,j)=0.
              end do
            end do
            !
            ! CAPw <= 68400 acft - CAP 1
            if(CAPw <= li_capacftthresholds(1))then
              lv_CAPindianTiers_acft(1,1)=CAPw*(lv_capIndianPercents_1/100.)
              lv_CAPindianTiers_acft(1,2)=CAPw-lv_CAPindianTiers_acft(1,1)
            else
            ! CAP 1 satisfied
            ! ----------------
            lv_CAPindianTiers_acft(1,1)=li_capacftthresholds(1)*(lv_capIndianPercents_1/100.)
            lv_CAPmandiTiers_acft(1,2)=li_capacftthresholds(1)-lv_CAPindianTiers_acft(1,1)
            ! ----
            !
            ! // Equation criteria satisfied CAPw > 68400 and <=853,079 AcF  - CAP 2
            ! 
                 lv_threshTiers(1)=CAPw- li_capacftthresholds(1)
               if(CAPw <=li_capEquationparms(2))then         
               !
               lv_CAPindianTiers_acft(2,1)=anint((1.-(lv_capIndianPercents_2/100.))*lv_threshTiers(1))
               lv_CAPmandiTiers_acft(2,1) =lv_threshTiers(1)-lv_CAPindianTiers_acft(2,1) !-li_capacftthresholds(1)
               !     
               else
               !
                lv_CAPindianTiers_acft(2,1)=anint((1.-(lv_capIndianPercents_2/100.))*li_capEquationparms(2))
                lv_CAPmandiTiers_acft(2,1) =li_capEquationparms(2)-lv_CAPindianTiers_acft(2,1)-li_capacftthresholds(1)
                !
                !
                   !
                   !  Equation kicks in: I = {[32,770  (E - 853,079)] x W} + (343,079  {[32,770  (E - 853,079)] x E})
                   !  (simplified here)
                   !  CAPw is between 853,079 and 1,050,302 AcF 
                   ! -------------------------------------------
                    lv_threshTiers(2)=CAPw -li_capacftthresholds(1)
                 if(CAPw <=li_capacftthresholds(2))then
                  !
                   lv_CAPindianTiers_acft(2,2)=(Indian2+((li_capminIPW * (1./100.))*lv_threshTiers(2)))
                   lv_CAPmandiTiers_acft(2,2) =lv_threshTiers(2) -  lv_CAPindianTiers_acft(2,2)            
                   !
                     lv_CAPindianTiers_acft(2,2)=anint(lv_CAPindianTiers_acft(2,2))
                     lv_CAPmandiTiers_acft(2,2)=anint(lv_CAPmandiTiers_acft(2,2))
                   !
                   lv_CAPindianTiers_acft(2,1)=0.
                   lv_CAPmandiTiers_acft(2,1)=0.
                   !  
                 else
                      lv_threshTiers(2)=li_capacftthresholds(2)-li_capacftthresholds(1)
                      !
                      lv_CAPindianTiers_acft(2,2)=(Indian2+((li_capminIPW * (1./100.))*lv_threshTiers(2)))
                      lv_CAPmandiTiers_acft(2,2) =li_capacftthresholds(2) &
                        - lv_CAPindianTiers_acft(2,2)-li_capacftthresholds(1)                        
                     !
                       lv_CAPindianTiers_acft(2,2)=anint(lv_CAPindianTiers_acft(2,2))
                       lv_CAPmandiTiers_acft(2,2)=anint(lv_CAPmandiTiers_acft(2,2))
                      !
                     lv_CAPindianTiers_acft(2,1)=0.
                     lv_CAPmandiTiers_acft(2,1)=0.
                     !
                     !
                     ! ------- CAP conveyance > 1,050,302 AcF -----
                    lv_threshTiers(3)=CAPw -li_capacftthresholds(2)
                   if(CAPw <= li_capacftthresholds(3))then
                    !
                    lv_CAPindianTiers_acft(3,1)=anint(lv_threshTiers(3)*(1.-(lv_capIndianPercents_3/100.)))
                    lv_CAPmandiTiers_acft(3,1) =lv_threshTiers(3)-lv_CAPindianTiers_acft(3,1)
                    !
                   else
                       ! ------- CAPw 3 fulfilled --
                       !
                       lv_threshTiers(3)=li_capacftthresholds(3)-li_capacftthresholds(2)
                       !
                       lv_CAPindianTiers_acft(3,1)=anint(lv_threshTiers(3)*(1-lv_capIndianPercents_3/100.))
                       lv_CAPmandiTiers_acft(3,1) =lv_threshTiers(3)-lv_CAPindianTiers_acft(3,1)
                       !
                     if(CAPw <= li_capacftthresholds(4))then
                       lv_CAPmandiTiers_acft(4,1) =anint(CAPw-li_capacftthresholds(3))
                     else
                        ! ------- CAPw 4 fulfilled --
                        !
                         lv_CAPmandiTiers_acft(4,1) =anint(li_capacftthresholds(4)-li_capacftthresholds(3))
                        if(CAPw <= li_capacftthresholds(5))then
                         lv_CAPmandiTiers_acft(5,1)=CAPw-li_capacftthresholds(4)
                        else
                         lv_CAPmandiTiers_acft(5,1)=anint(li_capacftthresholds(5)-li_capacftthresholds(4))
                        endif
                     endif
                   endif
                 endif
               endif
            endif
            !
            !
           ! When we want to also use indian water
            ! DAS 01.09.12
            vDb%lvf_indianII(T%year)= lv_CAPindianTiers_acft(2,1)+lv_CAPindianTiers_acft(2,2)
            vDb%lvf_indianIII(T%year)= lv_CAPindianTiers_acft(3,1)+lv_CAPindianTiers_acft(3,2)
            vDb%lv_capMandItiers_acft=lv_CAPmandiTiers_acft
            ! the famous "E" equation estimates more M&I than accounted for (the 33 total) by 18145 AF (non-ag and non indian)
            vDb%lv_CAPMandI_II(T%year)=vDb%lv_capMandItiers_acft(2,1)+vDb%lv_capMandItiers_acft(2,2)
            !
        return
       end subroutine aPartition_B
       !--------------------------

       ! -------------------------------------
       subroutine aAllocate_B(T,gvi_order,vDb) 

         integer :: i,j
         integer(1) :: gvi_order
         real :: lv_capMandI
         real :: lv_capAvailable,lvf_capDifference !,lvf_capAdded(gvi_maxProV)
         real :: lvf_Demand(gvi_maxProV),lvf_CAP_needed(gvi_maxProV)
         real :: lv_sumdesignationsTierII,lv_sumdesignationsTierIV,vReductionII,vReductionIV
         real :: lvf_checkDesignations,lvf_checkAvailableWater
         real :: lvf_CAP_MandI
         ! 5 October 2009 CAP M&I sub-contracts
         !
         type(Designations_B)vDb
         type(runTime)T
         ! ===============
          !

            lvf_checkDesignations=0
            lvf_checkAvailableWater=0
           ! Tiers I amd II
           lv_capMandI=0
          lv_capMandI=vDb%lv_capMandItiers_acft(2,1)+vDb%lv_capMandItiers_acft(2,2)
          !
           ! Tiers III and IV
           lv_capAvailable=0
          lv_capAvailable=(vDb%lv_capMandItiers_acft(3,1)+vDb%lv_capMandItiers_acft(3,2) ) &
            + (vDb%lv_capMandItiers_acft(4,1)+vDb%lv_capMandItiers_acft(4,2))
          !
!write(2,*)"allocate",T%year,vDb%lv_capMandItiers_acft(2,1),vDb%lv_capMandItiers_acft(2,2),lv_capAvailable
!write(2,*)" "

          ! 04.05.12 DAS
            ! to the Interface
            go_deliveriesCO=nint(lv_capMandI)
            !

             ! Total designations, M&I contracts (array 1) and those purchased (array 2)
             lv_sumdesignationsTierII=0
             lv_sumdesignationsTierIV=0
            do i = 1,gvi_Providers
             lv_sumdesignationsTierII=lv_sumdesignationsTierII+li_designationsCAP(i,1)
             lv_sumdesignationsTierIV=lv_sumdesignationsTierIV+li_designationsCAP(i,2)
            end do
           !
            lvf_checkAvailableWater=lv_sumdesignationsTierII+lv_sumdesignationsTierIV
           !
           vReductionII=1.
           vReductionIV=1.
           lvf_capDifference=0.
             vDB%lvf_CAPdifference(T%year)=0
            !
          if(lv_capMandI >= lv_sumdesignationsTierII)then
             vReductionII=1.
            if(lv_sumdesignationsTierIV <=lv_capAvailable)then
             vReductionIV=1.
             ! What would be available to send on down the line.......
             lvf_capDifference=(lv_capMandI+lv_capAvailable)-(lv_sumdesignationsTierII+lv_sumdesignationsTierIV)
            else
             ! water above and beyond the 33 but not up to the top of Teir II
             ! calculated below
             if(0 < lv_sumdesignationsTierIV)vReductionIV=lv_capAvailable/lv_sumdesignationsTierIV
               if(0 < lv_sumdesignationsTierIV)vReductionIV=(lv_capMandI-lv_sumdesignationsTierII)/lv_sumdesignationsTierIV

            endif
            !
            ! CAP water that can be used on down the aqueduct
            ! 02.07.12 DAS
            vDB%lvf_CAPdifference(T%year)=lvf_capDifference
            ! CAP above and beyond the CAP M&I contracts for the 22 M&I contracts
            ! 12.20.11 DAS
!
          else
              vReductionIV=0
            if(0 < lv_sumdesignationsTierII)then
                ! For the 18,145 not committed
                if(lv_sumdesignationsTierII < lv_capMandI)then
                 if(0 < lv_sumdesignationsTierIV)vReductionIV=(lv_capMandI-lv_sumdesignationsTierII) * (1./lv_sumdesignationsTierIV)
                else
                 if(0 < lv_sumdesignationsTierII)vReductionII=lv_capMandI * (1./lv_sumdesignationsTierII)
                endif
            endif
          endif
          !
          do i = 1,gvi_Providers,1
           vDb%lv_realizedDesignation_B_acft(T%year,i)= &
                nint(li_designationsCAP(i,1)*vReductionII) +  nint(li_designationsCAP(i,2)*vReductionIV) 
            !
            lvf_checkDesignations= nint( lvf_checkDesignations+ vDb%lv_realizedDesignation_B_acft(T%year,i))
            !

            if(gpl_test)then
            if(i == 25)then
            endif
            endif
            !
          end do

           if(lvf_checkAvailableWater < lvf_checkDesignations)then
            if(gvl_WriteToDisk)then
                write(7,*)"Designation_CO error, line 348: designating more water than available"
            endif
           endif
          !
          ! 05.17.11 das
          ! Take from WB if surface water supplies become limitted (This will nee parameterization)
          ! Revisit this 12.20.11 DAS
          ! -------------------------
            do i = 1,gvi_Providers,1
              gvf_parm_WBtoSW(i)=0
                if(0 < vReductionII)then
                 if(vReductionII < 1)gvf_parm_WBtoSW(i)=min(1.25,1./vReductionII)
                endif
            end do
         !
         ! New Code 04.27.11
         ! =================================
         ! Create a variable to handle added CAP purchased from Tier III and IV supplies
         ! Add to WaterSimDCDC.txt (I suppose) Think about reducing that file.....
         ! Would ultimately be reflected in " gvf_Used_CO_AF(j)"  - use type convert?
         ! 12.14.11 DAS
         if(gpl_DemandDriven)then
          !
          do j = 1,gvi_Providers,1
            gvf_Used_CO_AF(j)=0
            gvf_Unused_CO_AF(j)=0
            gvf_UnmetDemand_AF(j)=0
            gvf_UnmetDemand_CO(j)=0
            ! Set water demand variable
            lvf_Demand(j)=(gvf_WaterDemand_AF(j,gvi_order,1))
            !
            if(0 < lvf_Demand(j))then
               lvf_CAP_needed(j)=lvf_Demand(j)
            else
              lvf_CAP_needed(j)=0
            endif
           ! Come back to this DAS
           if(0 < li_designationsCAP(j,1) .or. 0 < li_designationsCAP(j,2) )then
            else
              lvf_CAP_needed(j)=0
            endif
            !
            If(0 < lvf_CAP_needed(j))then
              ! Is there CAP water available? 
              if(0 < vDb%lv_realizedDesignation_B_acft(T%year,j))then
                if(lvf_CAP_needed(j) < vDb%lv_realizedDesignation_B_acft(T%year,j))then
                  gvf_Unused_CO_AF(j)=nint(vDb%lv_realizedDesignation_B_acft(T%year,j)-lvf_CAP_needed(j))
                  gvf_Used_CO_AF(j)=lvf_CAP_needed(j)
                else
                    gvf_Unused_CO_AF(j)=0
                    gvf_UnmetDemand_AF(j)=nint(lvf_CAP_needed(j)-vDb%lv_realizedDesignation_B_acft(T%year,j))
                    gvf_UnmetDemand_CO(j)=gvf_UnmetDemand_AF(j)
                    !
                    gvf_Used_CO_AF(j)=vDb%lv_realizedDesignation_B_acft(T%year,j)            
                    !
                endif
              !
              else
              ! No CAP water available
              gvf_Used_CO_AF(j)=0
              !
              endif

            endif
          end do
          !
          !
         endif
          !
         ! ==============================
         !
5         format(I4,2x,I2,2x,1(F9.0,1x))
         ! 
        return
       end subroutine aAllocate_B
       !-------------------------
 
       !--------------------------------
       subroutine aTypeConvert(T,vDb,vD)
          integer :: i

         type(Designations_B)vDb
         type(Provider)vD
         type(runTime)T
         ! ===============
          !
          do i = 1,gvi_Providers,1
            vD%gRealizedDesignationCAP_acft(T%year,i)=vDb%lv_realizedDesignation_B_acft(T%year,i)
          end do
          !
          vD%gCAPMandI_II(T%year)=vDb%lv_CAPMandI_II(T%year)
          !
       end subroutine aTypeConvert
       !----------------------------------
       !
    ! 
End Module lms_Designations_B
! --
 !
 !  Called from within Kernel.f90
 !   subroutine RunOneYearKernel()
 ! ----------------------------------------------
  subroutine sCAP_water(T,gvi_order,conveyance,vD)
    use lms_Designations_B
     use gm_ModelControl
        !
        integer :: i
        integer(1) :: gvi_order
        real(8) :: conveyance
        !
        real :: lvf_CAP(gvi_maxProV),lvf_on(gvi_maxProV),lvf_off(gvi_maxProV)
        real :: code=8

        type(runTime)T
        type(Designations_B)vDb
        type(Provider)vD
        ! ===============
        !
        call aPartition_B(T,conveyance,vDb)
        call aAllocate_B(T,gvi_order,vDb) 
        call aTypeConvert(T,vDb,vD)
        !
        ! Assign demand to Off first- sCWaccounting will track use
        ! ---------------------------------------------------------
        do i = 1,gvi_Providers,1
           lvf_CAP(i)=0
          lvf_CAP(i)=gvf_Used_CO_AF(i)
          !
          if(0 < gvf_WaterDemand_AF(i,gvi_order,2))then
            if(lvf_CAP(i) < gvf_WaterDemand_AF(i,gvi_order,2))then
              lvf_off(i)=lvf_CAP(i)
              lvf_on(i)=0
            else
              lvf_off(i)= gvf_WaterDemand_AF(i,gvi_order,2)
              lvf_on(i)=lvf_CAP(i)- lvf_off(i)
            endif
          else
            lvf_off(i)=0
            lvf_on(i)=lvf_CAP(i)
          endif
        end do
        !
        call sCWaccounting(gvi_order,lvf_off,lvf_on,code)
        !
        gvi_order=gvi_order+1
        !
    return
  end subroutine sCAP_water
! =================================================================================================
! E.O.F.

