!
! File is Designations_SVT.f90
!
! This file contains the calculations of surface water designations for SVT
!
!
!
! Local OUTPUTS:
!              
! Local INPUTS:
!
!--------------------------
!
! created on 06.07.10
!
! david arthur sampson
! last write was: 02.10.12
! =================================================================================================
!
Module lm_Designations_A
 use gm_ModelControl
  use gm_GlobalData

    implicit none
    ! -----------
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
 contains
    subroutine initAdesignations()
      call openFiles_Adesignations()
      call readFiles_Adesignations()
    end subroutine initAdesignations
    !
      subroutine openFiles_Adesignations()

          character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
          if(gpl_release)lvc_dataPath=trim(gvc_DPath)
          !
           LU=40
          !'App_Data\Parameters\SVTtrott_new.txt'
          ! as 0f 12.29.11 actual designations, by provider, in maf annum-1 by normal flow threshold (table 10- Trott)
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Designations_2012.txt'),exist=lexist)
          if(lexist)then
            open(40,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Designations_2012.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Designations_A missing(or corrupted): SVT_Designations_2012.txt", "Logical Unit = ", LU 
            endif
          endif
           LU=41
            ! 'App_Data\Parameters\SVTthresholddesignations.txt'
            ! This was changed to a 42 x 2 array (from a 42 x 1 array)
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Threshold_2012.txt'),exist=lexist)
          if(lexist)then
            open(41,FILE=trim(trim(lvc_dataPath) &
            //'App_Data\Parameters\SVT_Threshold_2012.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Designations_A missing(or corrupted): SVT_Threshold_2012.txt", "Logical Unit = ", LU 
            endif
          endif
           LU=42
            !'App_Data\Parameters\SVTacreage.txt'
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVTacreageClassA_2012.txt'),exist=lexist)
          if(lexist)then
            open(42,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVTacreageClassA_2012.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Designations_A missing(or corrupt): SVTacreageClassA_2012.txt", "Logical Unit = ", LU 
            endif
          endif
           LU=44
          ! SVTflowNextLevel_new.txt
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Relative.txt'),exist=lexist)
          if(lexist)then
            open(44,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\SVT_Relative.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Designations_A missing(or corrupt): SVT_Relative.txt", "Logical Unit = ", LU 
            endif
          endif
      end subroutine openFiles_Adesignations
      ! ------------------------------------

      ! ----------------------------------
      subroutine readFiles_Adesignations()
           integer :: LU
            integer :: i,j,ios
            real(8) :: lvd_designationsSVT(42,10)
            !
            !---------------------------------------------------------------------
            !
            read(40,*,err=31,iostat=ios)((lvd_designationsSVT(i,j),j=1,10),i=1,42)
            read(41,*,err=32,iostat=ios)((li_thresholddesigSVT(i,j),j=1,2),i=1,42)
            read(42,*,err=33,iostat=ios)(li_acreageSVT(j),j=1,10)
            read(44,*,err=35,iostat=ios)((li_providerTrott(i,j),j=1,10),i=1,42)
!            do i = 1,42,1
!              do j = 1,10,1
!                li_designationsSVT(i,j)=lvd_designationsSVT(i,j) 
!              end do
!            end do
                li_designationsSVT=lvd_designationsSVT
31          continue
            if(ios >0)then
             LU=40
             goto 1000
            endif
32          continue
            if(ios >0)then
             LU=41
             goto 1000
            endif
33          continue
            if(ios >0)then
             LU=42
             goto 1000
            endif
34          continue
     
35          continue
            if(ios >0)then
             LU=44
             goto 1000
            endif
36          continue
            if(ios >0)then
             LU=45
             goto 1000
            endif
            ! NOTE: not closed if an err is returned
            do i = 40,45,1
             close(i)
            end do
         return
1000     continue
           if(gvl_WriteToDisk)&
            write(7,*)'Designations_SVT.f90 line 137: Error in file read, logical unit is', LU
      end subroutine readFiles_Adesignations
      ! ------------------------------------
End Module lm_Designations_A
!
Module lms_Designations_A
 use gm_ModelControl
  use gm_GlobalData
   use gm_Global
    use gm_TypeControl

    implicit none
    ! -----------
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
    type Designations_A
     real(8) :: lvd_realizedDesignations_A_maf(gpi_lBY:gpi_uBY,10)
     real(8) :: lvd_maxBCDesignations_A_maf(gpi_lBY:gpi_uBY,10)
     real(8) :: lvd_classADesignations_A_maf(gpi_lBY:gpi_uBY,10)
     real(8) :: lvd_SRPpumping_maf(gpi_lBY:gpi_uBY,10)
    end type Designations_A
    !
 contains
  !================================================================================================
        ! -----------------------
        subroutine aClear(T,ltDa)
          integer :: i,j

          type(runTime)T
          type(Designations_A)ltDa
          ! ======================
             if(gvl_start)then
                do i = gpi_lBY,gpi_uBY,1
                  do j = 1,10,1
                    ltDa%lvd_classADesignations_A_maf(i,j)=0.
                  end do
                end do
              endif
          ! ======================
          return
        end subroutine 
        !-------------

        !-------------------------------------------------------
        subroutine aDesignations_classBCmax_A(T,acfta,ltDa,Aout)

          integer :: i,k

          real(8) :: acfta,lv_addBC(10)
          ! Changed from 375,000 AF to 350,000 AF on 09.01.11 
          ! see function fStorageRelease(state) for more details
          !
          type(runTime)T
          type(RiverA)Aout
          type(Designations_A)ltDa
          ! ===============
            !
                do i = 1,10,1
                  ltDa%lvd_maxBCDesignations_A_maf(T%year,i)=0.
                  lv_addBC(i)=0.
                end do
               do k = 1,10,1
                 !
                  !
                 ! acft of water as determined by member land acreage-                                  (acft a-1)
                 ! 3 acft acre-1 if storage is above 0.6 maf
                 ! 2 acft acre-1 if below
                 ! Only use class B and C acreages (i.e., second column in the array)
                 !
                 !
                ! 01.03.12 DAS
                ! 
                ! There can only be ~ 116,000 acres (total) serviced at 3 AF acre-1 ( 350,000 AF max pumping)
                !
                ! 02.06.12 DAS
                ! Not sure how to model this because the sum total of class B lands is 146,416 so never could meet 3 AF per acre from pumping
                ! Heavy reliance on the reservoirs.
                    ! Previous code
 !                  ltDa%lvd_maxBCDesignations_A_maf(T%year,k)=(acfta*gvd_acreageSVT(k,1))*gpd_acftTomaf
                    !
                    ! New code
                  ltDa%lvd_maxBCDesignations_A_maf(T%year,k)=(acfta*gvd_acreageSVT(k,2))*gpd_acftTomaf
                  Aout%gvf_classBCmax(k)=(acfta*gvd_acreageSVT(k,2))*gpd_acftTomaf
                  lv_addBC(k)= ltDa%lvd_maxBCDesignations_A_maf(T%year,k)
                 !
                end do
                !
                !  Maximum pumping cannot exceed 350,000 AF annually (Phillips et al. 2009)
                ! ------------------------
                  !
                Aout%gvf_classBCmax=lv_addBC
                !
        end subroutine aDesignations_classBCmax_A
        !-----------------------------------------
        ! 02.08.12
        ! Rules: Conservation space water (NCS) and gatewater can be used off project.
        !
        !Water from the Reservoir and Pumped water  are treated the same, allocated based 
        !on the 3 acre feet per acre.  SRP tries to deliver 3 acre feet per acre using a 
        !combination of  water flow above normal flow rights, water from the reservoir, and 
        ! pumped water.   From day to day how much each contributes to the 3 acre feet will
        ! vary.  When there is not enough from these three to meet 3 acre feet, then SRP 
        !reduces the allocation it delivers to everyone.
 
        !Ray Quay
        !Research Professional
        !Decision Center for a Desert City
        !Global Institute of Sustainability
        !Arizona State University
        !Phone: 480.965.4394
        !
        ! ----------------------------------------------------
        subroutine aDesignations_classBC_Storage(T,Aout,acfta)

          integer :: i,j,k
          integer :: lvi_list
          real(8) :: acfta
          real :: lvf_ratioAcresForPumping(10),lvf_totalBacres
          real, parameter :: lpf_mafTokAF=1000
          real :: fStorageRelease
          real :: lvf_addSorage,lvf_sum,lvf_ratio
          real :: lvf_pumpingTotal_maf,lvf_storageAlloted_maf(10),tvf_storageAlloted_maf(10)
          !
          type(runTime)T
          type(RiverA)Aout
          ! ===============
            ! Units kAF
            !
                ! Function to estimate release from reservoirs

             lvf_pumpingTotal_maf=0
            lvf_pumpingTotal_maf= fStorageRelease(lv_State_A_maf(T%year)) * (1./lpf_mafTokAF)
            !
             lvf_totalBacres=0
            do i = 1,10,1
             lvf_totalBacres=lvf_totalBacres+gvd_acreageSVT(i,2)
            end do
            !
             lvf_addSorage=0
                do j = 1,10,1
                 tvf_storageAlloted_maf(j)=0.
                 lvf_ratioAcresForPumping(j)=0.
                    !
                 lvf_ratioAcresForPumping(j)=gvd_acreageSVT(j,2) * (1./lvf_totalBacres)
                 tvf_storageAlloted_maf(j)=max(0,(gvd_acreageSVT(j,2)*acfta*gpd_acftTomaf)-(lvf_pumpingTotal_maf*lvf_ratioAcresForPumping(j)))      
                end do
            !
            lvf_addSorage=sum(lvf_storageAlloted_maf)
             lvf_sum=0
            lvf_sum=lv_State_A_maf(T%year)-li_deadpoolSVT
             lvf_ratio=1.
            if(0 < lvf_addSorage)lvf_ratio=min(1.,lvf_sum/lvf_addSorage)
            !
           if(li_deadpoolSVT < lv_State_A_maf(T%year))then
              if(lvf_addSorage < lvf_sum)then
                lvf_storageAlloted_maf= tvf_storageAlloted_maf
              else
                ! cannot release more than what is there
                do i = 1,10,1
                  lvf_storageAlloted_maf(j)=0
                 lvf_storageAlloted_maf(i)=lvf_ratio *  tvf_storageAlloted_maf(i)
                end do
                lvf_addSorage=sum(lvf_storageAlloted_maf)
              endif
           else
                do i = 1,10,1
                 lvf_storageAlloted_maf(i)=0
                end do
                lvf_addSorage=sum(lvf_storageAlloted_maf)
           endif
            !
            lvi_list=1
            call sMaskSRP(gvl_maskSRP)
            do k = 1,gvi_Providers,1
              !
              Aout%gvf_storageAlloted_35_AF(k)=0.
              Aout%gvf_pumpingSRP_35_AF(k)=0.
              if(gvl_maskSRP(k))then     
                Aout%gvf_storageAlloted_35_AF(k)=lvf_storageAlloted_maf(lvi_list)* (1/gpd_acftTomaf)
                ! 
                Aout%gvf_pumpingSRP_35_AF(k)=(lvf_pumpingTotal_maf*lvf_ratioAcresForPumping(lvi_list))* (1/gpd_acftTomaf)
                 !
                lvi_list=lvi_list+1
              endif
            end do
             !
            Aout%gvf_BCstorageUseMax_AF= sum(lvf_storageAlloted_maf)* (1./gpd_acftTomaf)
             ! To pass to apprpriate subroutines
             Aout%gvf_pumpingSRP_maf=0
            Aout%gvf_pumpingSRP_maf=lvf_pumpingTotal_maf
            ! To ensure (pass to) SRP release
             Aout%gvf_releaseSRP_maf=0
            Aout%gvf_releaseSRP_maf=sum(lvf_storageAlloted_maf)
            !
          return
        end subroutine aDesignations_classBC_Storage
        ! ------------------------------------------
      !
End Module lms_Designations_A
! =====================================================================================
  !
  ! -------------------------------------
  subroutine classAdesignations_A(T,Aout)
    use lms_Designations_A
     use gm_ModelControl
      use gm_TypeCOntrol

        integer :: k
        real(8) :: gvd_ClassAarray(10)
        !
        type(runTime)T
        type(RiverA)Aout
        ! ==============
        !
           ! In DailyDesignations.f90
           call extractDaily(T,gvd_ClassAarray)
            gvi_countYearsSVT=gvi_countYearsSVT+1
            if(24 < gvi_countYearsSVT)gvi_countYearsSVT=0
          !
          Aout%gvd_ClassAarray_10_maf=gvd_ClassAarray ! maf annum-1
          !
         ! ------------------------------------------------------------------
         !
         ! Note: 03.20.12
         ! ==============
         if(gpl_test_SRPrelease)then
           Aout%gvd_ClassAarray_10_maf=0.010
         endif
         !
         ! ------------------------------------------------------------------
    return
  end subroutine classAdesignations_A
  ! ----------------------------------

 ! -------------------------------------------------------
  subroutine sSRP_classBandCstorage(T,gvi_order,Aout,gtPV)
    use lms_Designations_A
     use gm_ModelControl
      use gm_TypeCOntrol
       use gm_Global

        integer(1) :: gvi_order
        integer :: i,lvi_count

        real(8) :: acfta
        real :: lvf_WaterDemand35(gvi_maxProV)
        real :: lvf_WaterUse35(gvi_maxProV)
        real :: lvf_totalSRP_AF(10),lvf_ratioResToTotal(10)
        real :: lvf_subtractFromRelease(10),lvf_subtractFromPumping(10)
        !
        real :: lvf_on(gvi_maxProV),lvf_off(gvi_maxProV)
        real :: code=7

        ! =====================
        type(runTime)T
        type(RiverA)Aout
        type(provider) :: gtPV        
        type(Designations_A)ltDa
        ! =====================
        !
         acfta=gvd_AFperAcreSVT ! Aout%aAcfta
        !
        if(gpl_test_SRPrelease)then
         call aDesignations_classBCmax_A(T,acfta,ltDa,Aout)
         call aDesignations_classBC_Storage(T,Aout,acfta)
        else
         call aDesignations_classBCmax_A(T,acfta,ltDa,Aout)
         call aDesignations_classBC_Storage(T,Aout,acfta)
        endif
        !
        lvi_count=1
        call sMaskSRP(gvl_maskSRP)
         do i = 1,gvi_Providers,1
          lvf_WaterDemand35(i)=0
          lvf_WaterUse35(i)=0
          Aout%gvf_classBCfromReservoir(i)=0
          Aout%gvf_classBCavailableTopump(i)=0

          !
            ! On-project only
            ! 02.08.12 - this code compares On project water demand to total SRP (reservoir and pumping)
            ! if demand is greater than supply than use is supply.  IF supply is greater than demand,
            ! I take the proportion from the reservoirs and then from pumping and subtract each from the 
            ! initial estimate.  i.e., Release from the reservoirs is reduced (< 3 AF per acre) and pumping is reduced
          if(gvl_maskSRP(i))then  
             lvf_subtractFromRelease(lvi_count)= 0.
             lvf_subtractFromPumping(lvi_count)= 0.
             Aout%gvf_SRPdemandDifference_10_AF(lvi_count)=0.   
 
            lvf_totalSRP_AF(lvi_count)=Aout%gvf_storageAlloted_35_AF(i)+ Aout%gvf_pumpingSRP_35_AF(i)
            lvf_WaterDemand35(i)=gvf_WaterDemand_AF(i,gvi_order,3) 
            !
            if(0 < lvf_WaterDemand35(i))then
              if(lvf_WaterDemand35(i) <  lvf_totalSRP_AF(lvi_count))then
                Aout%gvf_SRPdemandDifference_10_AF(lvi_count)=lvf_totalSRP_AF(lvi_count)-lvf_WaterDemand35(i) 
                lvf_WaterUse35(i)=lvf_WaterDemand35(i)  
              else
                lvf_WaterUse35(i)= lvf_totalSRP_AF(lvi_count)
              endif
                ! 02.08.12 DAS
                if(0 <  lvf_totalSRP_AF(lvi_count))&
                lvf_ratioResToTotal(lvi_count)=Aout%gvf_storageAlloted_35_AF(i) * (1./ lvf_totalSRP_AF(lvi_count))
    
                lvf_subtractFromRelease(lvi_count)= lvf_ratioResToTotal(lvi_count)* Aout%gvf_SRPdemandDifference_10_AF(lvi_count)
                lvf_subtractFromPumping(lvi_count)=max(0,Aout%gvf_SRPdemandDifference_10_AF(lvi_count) &
                 - lvf_subtractFromRelease(lvi_count))

                ! 02.07.12,02.08.12 DAS
                Aout%gvf_classBCavailableTopump(i)= anint(Aout%gvf_pumpingSRP_35_AF(i)- lvf_subtractFromPumping(lvi_count))
                !
                ! passed to SRPrelease.f90 to 
                Aout%gvf_classBCfromReservoir(i)=anint( Aout%gvf_storageAlloted_35_AF(i) &
                    -  lvf_subtractFromRelease(lvi_count))
                !
                ! Send to the interface for output
                ! THIS is strange..... fix this 02.07.12 DAS
                goi_classBCstorageMax_acft(lvi_count)=Aout%gvf_storageAlloted_35_AF(i)
                !
            endif
            !

            lvi_count=lvi_count+1
            !
          endif
         end do
          !
          ! ==================================================
          do i = 1,gvi_Providers,1
            lvf_on(i)= lvf_WaterUse35(i)
            lvf_off(i)=0
          end do
         !
         call sCWaccounting(gvi_order,lvf_off,lvf_on,code)
         !
        gvi_order=gvi_order+1
        !
      ! ===========================================================================================
      lvi_count=1
      call sMaskSRP(gvl_maskSRP)
         do i = 1,gvi_Providers,1
          if(gvl_maskSRP(i))then  
        
             ! New meaning here too..02.08.12
             gtPV%gAclassAdesignations_A_maf(T%year,lvi_count)=0.
             gtPV%gAclassAdesignations_A_maf(T%year,lvi_count)= Aout%gvd_ClassAarray_10_maf(lvi_count)
             gtPV%gApumpingSRP_maf(T%year,lvi_count)=  & 
               Aout%gvf_pumpingSRP_35_AF(i)-lvf_subtractFromPumping(lvi_count)
             gtPV%gArealizeddesignations_A_maf(T%year,lvi_count)= &
               Aout%gvf_classBCavailableTopump(i) +  Aout%gvf_classBCfromReservoir(i) &
                +  Aout%gvd_ClassAarray_10_maf(lvi_count)

             gtPV%gAclassAmax_A_maf(T%year,lvi_count)=lid_dailyDesignationsSVT(42,lvi_count) ! 02.08.12 DAS        
             gtPV%gAclassBCdesignationsMax_10_maf(T%year,lvi_count)=gpd_acftTomaf * &
                (Aout%gvf_storageAlloted_35_AF(i)+ Aout%gvf_pumpingSRP_35_AF(i))
            !
            lvi_count=lvi_count+1
          endif
         end do                  
        !
  end subroutine sSRP_classBandCstorage
! =================================================================================================
! E.O.F.