!
! File is GlobalSubroutines.f90
!
! Created on 29 October 2009
!
! david arthur sampson
! Last write was: 03.06.12
! -------------------------
!
! =================================================================================================
! 
        subroutine sCompareControl(one,two,level,flag)
            real :: level
            real :: one,two,y
            logical :: flag
                !
                flag=.false.
                if(0 < two)then
                y = abs(((one-two)/two)* 100.)
                if(level < y)flag=.true.
                endif
                !
         return
        end subroutine sCompareControl
        subroutine sEightyPercentCAP(i,lvf_receivedCAP,lvf_eligibleCAP,lvl_NoRestrictions)
          use  gm_GlobalData
            integer :: i
            real :: lvf_relativeCAP(gvi_maxProV)
            real :: lvf_receivedCAP(gvi_maxProV),lvf_eligibleCAP(gvi_maxProV)
            real, parameter :: lvp_thresholdCAP=0.80
            logical :: lvl_NoRestrictions(gvi_maxProV)
            !
                !call  sMaskCAP(lvl_mask)
                    lvl_NoRestrictions(i)=.false.
                 if(0 < lvf_eligibleCAP(i))then
                  lvf_relativeCAP(i)=lvf_receivedCAP(i)/lvf_eligibleCAP(i)
                  !
                  if( lvf_relativeCAP(i) < lvp_thresholdCAP)then
                    lvl_NoRestrictions(i)=.true.
                  endif
                 endif
                 !
           return
        end subroutine sEightyPercentCAP
        ! ------------------------------

        ! ----------------------------------------------------------------------------
        subroutine sEightyPercentSRP(lvf_receivedSRP,lvf_eligibleSRP,lvl_NoRestrictions)
            real :: lvf_relativeSRP
            real :: lvf_receivedSRP,lvf_eligibleSRP
            real, parameter :: lvp_thresholdSRP=0.80
            logical :: lvl_NoRestrictions
            !
                !call  sMaskCAP(lvl_mask)
                    lvl_NoRestrictions=.false.
                 if(0 < lvf_eligibleSRP)then
                  lvf_relativeSRP=lvf_receivedSRP/lvf_eligibleSRP
                  !
                  if( lvf_relativeSRP < lvp_thresholdSRP)then
                    lvl_NoRestrictions=.true.
                  endif
                 endif
                 !
           return
        end subroutine sEightyPercentSRP
        ! ------------------------------

        ! ----------------------------------------------------------------------------
        subroutine sEightyPercent(provider,lvf_receivedSRP,lvf_eligibleSRP,lvf_receivedCAP,lvf_eligibleCAP,lvl_NoRestrictions)
            integer :: provider
            real :: lvf_receivedSRP,lvf_eligibleSRP
            real :: lvf_receivedCAP,lvf_eligibleCAP
            real :: lvf_relative_1, lvf_relative_2
            real :: lvf_relative
            !
            real, parameter :: lvp_threshold=0.80
            logical :: lvl_NoRestrictions
                !
                lvl_NoRestrictions=.false.
                 lvf_relative_1 =0.
                 lvf_relative_2 =0.
                 lvf_relative   =0.
                if(0 < lvf_eligibleCAP)lvf_relative_2 = (lvf_receivedCAP/lvf_eligibleCAP)
                if(0 < lvf_eligibleSRP)then
                     if(0 < lvf_eligibleSRP)lvf_relative_1 = ((lvf_receivedSRP/lvf_eligibleSRP))
                    if(0 < lvf_eligibleCAP)then
                     ! Providers have rights to SRP and CAP water
                     lvf_relative=  ((lvf_relative_1+ lvf_relative_2)* 1/2.)
                    else
                     ! Providers have rights to only SRP water
                      lvf_relative=  lvf_relative_1
                    endif
                   !
                else
                     if(0 < lvf_eligibleCAP)then
                      ! Providers have rights to CAP water
                      lvf_relative=  lvf_relative_2
                     else
                     endif
                endif
                   !
                    if( 0 < lvf_relative)then
                        if(lvf_relative < lvp_threshold)then
                          lvl_NoRestrictions=.true.
                        endif
                    else
                        if(0 < lvf_eligibleSRP .or. 0 < lvf_eligibleCAP)then
                          lvl_NoRestrictions=.true.
                        endif
                    endif
                  !
           return
        end subroutine sEightyPercent
       ! ----------------------------------------------------------------------------


        ! -------------------------------------------------------------
        subroutine sAgGroundwaterCheck(agWaterRequest,agAMApumped)
            use  gm_GlobalData

            integer :: agWaterRequest(gvi_maxProV),i
            real :: lvf_checkBalance,agAMApumped
            real :: lvf_proportion
          
                 lvf_checkBalance=0
                lvf_checkBalance=sum(agWaterRequest)
                !
                 lvf_proportion=1
                if(lvf_checkBalance <  agAMApumped)then
                else
                    if(0 < lvf_checkBalance)lvf_proportion=agAMApumped/lvf_checkBalance
                    do i = 1,gvi_Providers,1
                      agWaterRequest(i)=nint(agWaterRequest(i)*lvf_proportion)
                    end do
                endif
                !
            return
            !
        end subroutine sAgGroundwaterCheck
        ! ------------------------------------------------------------

       ! -----------------------------------------
        subroutine sUnit_2(string,year,i,floatIn_1,floatIn_2,logicalIn)
            character(len=20) :: string
            integer :: i,year
            logical :: logicalIn
            real :: floatIn_2,FloatIn_1
             write(2,*)string,year,i,FloatIn_1,floatIn_2,logicalIn
        end subroutine sUnit_2
!
       ! -----------------------------------------
       subroutine sTemperature(Tmax,lvf_Tresponse)

           real :: lvf_Tresponse,Tmax
           real, parameter :: lvc_beta=1.0258 !,beta_upper=1.0326,beta_lower=1.0189
           ! =====================
            ! NOTE:
            !Tmax=lvf_MetData(T%year,vTstep,1)
            !
             lvf_Tresponse=0.
            lvf_Tresponse=lvc_beta**Tmax
           !
        end subroutine sTemperature
        ! -------------------------

        ! -------------------------------------------------------------
        subroutine sProportional_Temp(Tmax1,Tmax2,demand,lvf_Tresponse)

           real :: lvf_Tresponse,Tmax1,Tmax2
           real :: demand
           real :: lvf_responseOne,lvf_responseTwo
           real, parameter :: lvc_beta=1.0258 !,beta_upper=1.0326,beta_lower=1.0189
           ! =====================
            ! NOTE:
            !Tmax1=lvf_MetDataBaseline(T%year,vTstep,1)
            !Tmax2=lvf_MetDataProjected(T%year,vTstep,1)
            ! using (response-control / control)* 100
            ! -----------------------------------------
            !
             lvf_responseOne=0
             lvf_responseTwo=0
            lvf_responseOne=lvc_beta**Tmax1
            lvf_responseTwo=lvc_beta**Tmax2
            !
             lvf_Tresponse=1.
            if(DConvert(Tmax1,6) < DConvert(Tmax2,6))then
             lvf_Tresponse=1+(((demand/lvf_responseOne)-(demand/lvf_responseTwo))/(demand/lvf_responseTwo))
            else if(DConvert(Tmax1,6) > DConvert(Tmax2,6))then
             lvf_Tresponse=1+(((demand/lvf_responseOne)-(demand/lvf_responseTwo))/(demand/lvf_responseTwo))
            endif
           !
        end subroutine sProportional_Temp
        ! -------------------------------

! -------------------------------------------------------------
  subroutine SESRunningT(T,lvf_Met,lvf_MetProjected,Difference)
      use gm_ModelControl
      implicit none

      integer :: i,j
      real :: T1,T2,Difference
      real :: lvf_MetProjected(2000:2100,12,3)
      real :: lvf_Met(2000:2100,12,3)
      type(runTime)T
      ! -----------------------
        !
        T1=0
        do i = 1,12,1
         T1=T1+(( (lvf_Met(T%year,i,1)+lvf_Met(T%year-1,i,1))*0.5 + &
                (lvf_Met(T%year,i,2)+lvf_Met(T%year-1,i,2))*0.5  &
                ))*0.5
        end do
        T1=T1/12
        T2=0
        do j = 1,12,1
         T2=T2+(((lvf_MetProjected(T%year,j,1)+lvf_MetProjected(T%year-1,j,1)) + &
                (lvf_MetProjected(T%year,j,2)+lvf_MetProjected(T%year-1,j,2)) &
                )*0.5 )*0.5
        end do
        T2=T2/12
        !
        Difference=0
        Difference=T2-T1
        !
   end subroutine SESRunningT
   ! ------------------------

! -----------------------------------------------------------------------------------------
  subroutine SESgpcdRunning(T,gvf_ReductionGPCD_pct,provider,year,lvf_GPCD_in, lvf_GPCDout)
    use gm_ModelControl
    implicit none
      real :: alpha
      integer :: provider,year
      integer :: i,j,k,lvi_referenceYear
      real :: lvf_GPCDin(gvi_maxProV,5),lvf_GPCDout(gvi_maxProV,100)
      real :: fSESgpcdRunning,lvf_last(gvi_maxProV)
      real :: gvf_ReductionGPCD_pct ! alpha=0.65
      real :: lvf_GPCD_in(gvi_maxProV)
      real :: fSESgpcd_alpha,fSESgpcd_bias
        !
      ! parameters to estimate alpha based on the reduction in GPCD desired
!      real, parameter :: a=20.9630
!      real, parameter :: b=0.9767
!      real, parameter :: c=-0.0371
!      real, parameter :: d=64.6664

      ! Parameters to correct for slight bias in the alpha estimates; GPCD is very sensitive to alpha
      !
       real :: lvf_a=1.
!       real :: lvf_aa,lvf_bb,lvf_cc
      ! -----------------------------------------------
      type(runTime)T
       ! ===============
        fSESgpcdRunning=0
        if(year == T%startyear)then
          do i = 1,gvi_Providers,1
            do j = 1,100,1
              lvf_GPCDout(i,j)=0
            end do
          end do
        endif
        ! http://www.duke.edu/~rnau/411avg.htm
        ! Brown's simple Exponential Smoothing (exponentially weighted moving average)
        ! alpha determines relative weight among observations

       ! lvf_projReductionGPCD= projected reduction in GPCD by 2100 (over 2006 mean estimate) - tempe used as a base case
        !
        ! Modified type IV exponential [exponent is < 0] and power functions [type IV is the scaling parameter];
        ! 12.29.12 das
        ! Data range 0 to 83% reduction
        ! See alpha_SAS.sas
        ! --------------------------------------------------------------------------------------
        !%LET model = d + a*b**x *x**-c;
        !
!        
!                                             Sum of        Mean               Approx
!           Source                    DF     Squares      Square    F Value    Pr > F
!
!           Model                      3       418.7       139.6    2590.25    <.0001
!           Error                      3      0.1616      0.0539
!           Corrected Total            6       418.9
!
!                                                Approx
!                  Parameter      Estimate    Std Error    Approximate 95% Confidence Limits
!
!                  a               20.9630       0.5336     19.2647     22.6612
!                  b                0.9767      0.00294      0.9674      0.9861
!                  c                0.0371      0.00337      0.0264      0.0478
!                  d               64.6664       0.7966     62.1312     67.2015
!

        ! y = alpha in percent (must divide input by 100)
        ! x = proportional reduction
        ! -------------------------------------------------------------------------------------
        !
        alpha=0
        if(gvf_ReductionGPCD_pct < 1)then
          alpha=0.9
        else if(100 < gvf_ReductionGPCD_pct)then
          alpha = 0.66
        else
          ! Difficult curve to fit.  The fit was significant with a r2 > 0.99
          !
!          alpha=a*b**gvf_ReductionGPCD_pct * gvf_ReductionGPCD_pct**c + d
            alpha=fSESgpcd_alpha(gvf_ReductionGPCD_pct)
            !
!            lvf_aa=1.03935 ; lvf_bb=0.0065 
         if(gvf_ReductionGPCD_pct < 6)then
             lvf_a=fSESgpcd_bias(gvf_ReductionGPCD_pct)
            alpha=lvf_a*alpha/100.  
          else
            alpha=alpha/100.  
          endif
        endif
          !
        lvi_referenceYear=T%startyear-2
        k = year-lvi_referenceYear
        ! 10.28.10 das
        ! 07.07.11
        ! ---------------------------
        ! Have GPCD estimates
         if(0 < lvf_GPCD_in(provider))then
           lvf_GPCDin(provider,k)=lvf_GPCD_in(provider)
         else
          ! No GPCD estimates: grab from the six year average
          call GPCD_eight(lvf_GPCDin)
         endif
        !
        if(gvf_ReductionGPCD_pct < 1)then
          fSESgpcdRunning=lvf_GPCDin(provider,5)
        else
        ! For those year without data for now, one percent drop in GPCD
        ! after our data range
        if(T%startyear <= 2002)then
          if(year <= 2010)then
           if(year <= 2002)fSESgpcdRunning=lvf_GPCDin(provider,1)
           if(year == 2003)fSESgpcdRunning=lvf_GPCDin(provider,2)
           if(year == 2004)fSESgpcdRunning=lvf_GPCDin(provider,3)
           if(year == 2005)fSESgpcdRunning=lvf_GPCDin(provider,4)
           if(year == 2006)fSESgpcdRunning=lvf_GPCDin(provider,5)
           if(year == 2007)fSESgpcdRunning=lvf_GPCDin(provider,5) * 0.99
           if(year == 2008)fSESgpcdRunning=lvf_GPCDin(provider,5) * 0.98
           if(year == 2009)fSESgpcdRunning=lvf_GPCDin(provider,5) * 0.97
           if(year == 2010)fSESgpcdRunning=lvf_GPCDin(provider,5) * 0.96
          else
            ! year >= 2009
           fSESgpcdRunning= alpha*(lvf_GPCDout(provider,k-1) &
                 +      (1.-alpha)*lvf_GPCDout(provider,k-2) & 
                 + ((1.-alpha)**2)*lvf_GPCDout(provider,k-3) &
                 + ((1.-alpha)**3)*lvf_GPCDout(provider,k-4) &
                  ) 
          endif
           !
        else
         if(0 < lvf_GPCD_in(1))then
           ! year >= 2006
           if(year <= 2009)then
            if(year <= 2006)fSESgpcdRunning=lvf_GPCD_in(provider)
            if(year == 2007)fSESgpcdRunning=lvf_GPCD_in(provider)
            if(year == 2008)fSESgpcdRunning=lvf_GPCD_in(provider)
            if(year == 2009)fSESgpcdRunning=lvf_GPCD_in(provider)
           else
            fSESgpcdRunning= alpha*(lvf_GPCDout(provider,k-1) &
                 +      (1.-alpha)*lvf_GPCDout(provider,k-2) & 
                 + ((1.-alpha)**2)*lvf_GPCDout(provider,k-3) &
                 + ((1.-alpha)**3)*lvf_GPCDout(provider,k-4) &
                  )
           endif
         else
           if(year == 2006)fSESgpcdRunning=lvf_GPCDin(provider,5)
           if(year == 2007)fSESgpcdRunning=lvf_GPCDin(provider,5)*0.99
           if(year == 2008)fSESgpcdRunning=lvf_GPCDin(provider,5)*0.98
           if(year == 2009)fSESgpcdRunning=lvf_GPCDin(provider,5)*0.97
           if(year == 2010)fSESgpcdRunning=lvf_GPCDin(provider,5)*0.96
           !
           if(year > 2009)then
            ! year > 2009
            fSESgpcdRunning= alpha*(lvf_GPCDout(provider,k-1) &
                 +      (1.-alpha)*lvf_GPCDout(provider,k-2) & 
                 + ((1.-alpha)**2)*lvf_GPCDout(provider,k-3) &
                 + ((1.-alpha)**3)*lvf_GPCDout(provider,k-4) &
                  )
            endif
         endif
        endif
          !
        endif
        !
          if(k <=100)then
           lvf_GPCDout(provider,k)=fSESgpcdRunning
            lvf_last(provider)=lvf_GPCDout(provider,k)
          else
            lvf_GPCDout(provider,k)=lvf_last(provider)
          endif
        !
    return
  end subroutine
 ! -------------
      ! -----------------------------
      subroutine GPCD_eight(lvf_GPCD)
        real :: lvf_GPCD(35,5)
          ! Five year running mean
          ! 1 is 2000-2004
          ! 2 is 2001-2005
          ! 3 is 2002-2006
          ! 4 is 2003-2007
          ! 5 is 2004-2008

          ! Created using ADWR data - 2000-2008_LP_GPCD_ADWR.xls Sally gave this file to me
          ! 10.27.10 das
          ! ----------------------------------------------------------------------------------------------------------
            lvf_GPCD(1,1)= 542     ; lvf_GPCD(1,2)= 522   ; lvf_GPCD(1,3)=526  ; lvf_GPCD(1,4)=522 ; lvf_GPCD(1,5)=517
            lvf_GPCD(2,1)= 167     ; lvf_GPCD(2,2)= 165   ; lvf_GPCD(2,3)=169  ; lvf_GPCD(2,4)=177 ; lvf_GPCD(2,5)=180
            lvf_GPCD(3,1)= 1067    ; lvf_GPCD(3,2)= 1044  ; lvf_GPCD(3,3)=1025 ; lvf_GPCD(3,4)=1029; lvf_GPCD(3,5)=1053
            lvf_GPCD(4,1)= 279     ; lvf_GPCD(4,2)= 274   ; lvf_GPCD(4,3)=265  ; lvf_GPCD(4,4)=283 ; lvf_GPCD(4,5)=307
            lvf_GPCD(5,1)= 202     ; lvf_GPCD(5,2)= 195   ; lvf_GPCD(5,3)=191  ; lvf_GPCD(5,4)=188 ; lvf_GPCD(5,5)=186

            lvf_GPCD(6,1)= 159     ; lvf_GPCD(6,2)= 157   ; lvf_GPCD(6,3)=157  ; lvf_GPCD(6,4)=156 ; lvf_GPCD(6,5)=154
            lvf_GPCD(7,1)= 818     ; lvf_GPCD(7,2)= 816   ; lvf_GPCD(7,3)=832  ; lvf_GPCD(7,4)=835 ; lvf_GPCD(7,5)=847
            lvf_GPCD(8,1)= 251     ; lvf_GPCD(8,2)= 229   ; lvf_GPCD(8,3)=221  ; lvf_GPCD(8,4)=169 ; lvf_GPCD(8,5)=110
            lvf_GPCD(9,1)= 409     ; lvf_GPCD(9,2)= 403   ; lvf_GPCD(9,3)=392  ; lvf_GPCD(9,4)=389 ; lvf_GPCD(9,5)=391
            lvf_GPCD(10,1)= 318    ; lvf_GPCD(10,2)= 302  ; lvf_GPCD(10,3)=304 ; lvf_GPCD(10,4)=296; lvf_GPCD(10,5)=297

            lvf_GPCD(11,1)= 242    ; lvf_GPCD(11,2)= 233  ; lvf_GPCD(11,3)=228 ; lvf_GPCD(11,4)=225; lvf_GPCD(11,5)=216
            lvf_GPCD(12,1)= 273    ; lvf_GPCD(12,2)= 268  ; lvf_GPCD(12,3)=264 ; lvf_GPCD(12,4)=256; lvf_GPCD(12,5)=250
            lvf_GPCD(13,1)= 170    ; lvf_GPCD(13,2)= 151  ; lvf_GPCD(13,3)=159 ; lvf_GPCD(13,4)=172; lvf_GPCD(13,5)=178
            lvf_GPCD(14,1)= 157    ; lvf_GPCD(14,2)= 156  ; lvf_GPCD(14,3)=150 ; lvf_GPCD(14,4)=147; lvf_GPCD(14,5)=142
            lvf_GPCD(15,1)= 161    ; lvf_GPCD(15,2)= 159  ; lvf_GPCD(15,3)=160 ; lvf_GPCD(15,4)=155; lvf_GPCD(15,5)=150

            lvf_GPCD(16,1)= 172    ; lvf_GPCD(16,2)= 160  ; lvf_GPCD(16,3)=158 ; lvf_GPCD(16,4)=160; lvf_GPCD(16,5)=160
            lvf_GPCD(17,1)= 229    ; lvf_GPCD(17,2)= 219  ; lvf_GPCD(17,3)=211 ; lvf_GPCD(17,4)=205; lvf_GPCD(17,5)=195
            lvf_GPCD(18,1)= 195    ; lvf_GPCD(18,2)= 191  ; lvf_GPCD(18,3)=188 ; lvf_GPCD(18,4)=184; lvf_GPCD(18,5)=179
            lvf_GPCD(19,1)= 192    ; lvf_GPCD(19,2)= 178  ; lvf_GPCD(19,3)=169 ; lvf_GPCD(19,4)=170; lvf_GPCD(19,5)=172
            lvf_GPCD(20,1)= 336    ; lvf_GPCD(20,2)= 322  ; lvf_GPCD(20,3)=311 ; lvf_GPCD(20,4)=312; lvf_GPCD(20,5)=306

            lvf_GPCD(21,1)= 202    ; lvf_GPCD(21,2)= 194  ; lvf_GPCD(21,3)=190 ; lvf_GPCD(21,4)=189; lvf_GPCD(21,5)=182
            lvf_GPCD(22,1)= 200    ; lvf_GPCD(22,2)= 200  ; lvf_GPCD(22,3)=200 ; lvf_GPCD(22,4)=200; lvf_GPCD(22,5)=200
            lvf_GPCD(23,1)= 200    ; lvf_GPCD(23,2)= 200  ; lvf_GPCD(23,3)=200 ; lvf_GPCD(23,4)=200; lvf_GPCD(23,5)=200
            lvf_GPCD(24,1)= 182    ; lvf_GPCD(24,2)= 174  ; lvf_GPCD(24,3)=176 ; lvf_GPCD(24,4)=176; lvf_GPCD(24,5)=176
            lvf_GPCD(25,1)= 210    ; lvf_GPCD(25,2)= 205  ; lvf_GPCD(25,3)=202 ; lvf_GPCD(25,4)=198; lvf_GPCD(25,5)=189

            lvf_GPCD(26,1)= 281    ; lvf_GPCD(26,2)= 267  ; lvf_GPCD(26,3)=250 ; lvf_GPCD(26,4)=237; lvf_GPCD(26,5)=228
            lvf_GPCD(27,1)= 200    ; lvf_GPCD(27,2)= 200  ; lvf_GPCD(27,3)=200 ; lvf_GPCD(27,4)=200; lvf_GPCD(27,5)=200
            lvf_GPCD(28,1)= 1462   ; lvf_GPCD(28,2)= 1418 ; lvf_GPCD(28,3)=1400; lvf_GPCD(28,4)=1378;lvf_GPCD(28,5)=1386   
            lvf_GPCD(29,1)= 203    ; lvf_GPCD(29,2)= 193  ; lvf_GPCD(29,3)=195 ; lvf_GPCD(29,4)=197; lvf_GPCD(29,5)=197
            lvf_GPCD(30,1)= 336    ; lvf_GPCD(30,2)= 327  ; lvf_GPCD(30,3)=326 ; lvf_GPCD(30,4)=320; lvf_GPCD(30,5)=320

            lvf_GPCD(31,1)= 235    ; lvf_GPCD(31,2)= 241  ; lvf_GPCD(31,3)=254 ; lvf_GPCD(31,4)=264; lvf_GPCD(31,5)=275
            lvf_GPCD(32,1)= 322    ; lvf_GPCD(32,2)= 302  ; lvf_GPCD(32,3)=290 ; lvf_GPCD(32,4)=282; lvf_GPCD(32,5)=267
            lvf_GPCD(33,1)= 576    ; lvf_GPCD(33,2)= 566  ; lvf_GPCD(33,3)=590 ; lvf_GPCD(33,4)=590; lvf_GPCD(33,5)=562
            lvf_GPCD(34,1)= 148    ; lvf_GPCD(34,2)= 146  ; lvf_GPCD(34,3)=142 ; lvf_GPCD(34,4)=146; lvf_GPCD(34,5)=149
            lvf_GPCD(35,1)= 200    ; lvf_GPCD(35,2)= 200  ; lvf_GPCD(35,3)=200 ; lvf_GPCD(35,4)=200; lvf_GPCD(35,5)=200
 
      end subroutine
     ! -------------
       subroutine GPCD(gv_EmpiricalGPCD)
            integer(4) :: gv_EmpiricalGPCD(35)

            ! Six year averages
            ! ===========================================================================================================
            gv_EmpiricalGPCD(1)=536;   gv_EmpiricalGPCD(2)=168;   gv_EmpiricalGPCD(3)=1035;  gv_EmpiricalGPCD(4)=267;
            gv_EmpiricalGPCD(5)=196;   gv_EmpiricalGPCD(6)=156;   gv_EmpiricalGPCD(7)=823;   gv_EmpiricalGPCD(8)=210;
            gv_EmpiricalGPCD(9)=398;   gv_EmpiricalGPCD(10)=310;   gv_EmpiricalGPCD(11)=233;   gv_EmpiricalGPCD(12)=269;
            gv_EmpiricalGPCD(13)=171;   gv_EmpiricalGPCD(14)=151;   gv_EmpiricalGPCD(15)=158;   gv_EmpiricalGPCD(16)=169;
            gv_EmpiricalGPCD(17)=219;   gv_EmpiricalGPCD(18)=192;   gv_EmpiricalGPCD(19)=180;   gv_EmpiricalGPCD(20)=325;
            gv_EmpiricalGPCD(21)=197;   gv_EmpiricalGPCD(22)=224;   gv_EmpiricalGPCD(23)=224;   gv_EmpiricalGPCD(24)=181;
            gv_EmpiricalGPCD(25)=203;   gv_EmpiricalGPCD(26)=264;   gv_EmpiricalGPCD(27)=224;   gv_EmpiricalGPCD(28)=1455;
            gv_EmpiricalGPCD(29)=202;   gv_EmpiricalGPCD(30)=332;   gv_EmpiricalGPCD(31)=244;   gv_EmpiricalGPCD(32)=304;
            gv_EmpiricalGPCD(33)=568;   gv_EmpiricalGPCD(34)=147;   gv_EmpiricalGPCD(35)=224;  
            ! ===========================================================================================================
        end subroutine GPCD
        ! -----------------



! In this case, the first array must be rank 35 whilst the second MUST be 10
! 
! Masks
 ! -----------------------------------------------------------------------------
 subroutine sMaskSRP(lvl_mask)
  use gm_GlobalData
    integer :: i
    logical :: lvl_mask(gvi_maxProV)
    character(len=2), dimension(gvi_maxProV) :: providers
    !
     call sProviders(providers)
        do i = 1,gvi_Providers,1
          lvl_mask(i)=.false.
          if(providers(i) == 'av' .or. providers(i)=='ch' .or. providers(i)=='gi' &
            .or. providers(i)=='gl'.or. providers(i)=='me'.or. providers(i)=='pe'  &
            .or. providers(i)=='ph'.or. providers(i)=='sc'.or. providers(i)=='te'  &
            .or. providers(i)=='to')then     
            lvl_mask(i)=.true.
          endif
        end do
    !
 end subroutine sMaskSRP
 ! ----------------------

! ------------------------
subroutine sMask(lvl_mask)
  use gm_GlobalData
    integer :: i
    character(len=2), dimension(gvi_maxProV) :: providers
    logical :: lvl_mask(gvi_maxProV)
    !
     call sProviders(providers)
       do i = 1,gvi_Providers,1
        lvl_mask(i)=.true.
          if(Providers(i) == 'no' .or. Providers(i) == 'op')lvl_mask(i)=.false.
       end do
    !
 end subroutine sMask
 ! ------------------

 ! ---------------------------
 subroutine sMaskCAP(lvl_mask)
  use gm_GlobalData
    integer :: i
    logical :: lvl_mask(gvi_maxProV)
    character(len=2), dimension(gvi_maxProV) :: providers
    !
     call sProviders(providers)
       do i = 1,gvi_Providers,1
          lvl_mask(i)=.true.
          if(providers(i) == 'ad' .or. providers(i)=='be' .or. providers(i)=='cu' &
            .or. providers(i)=='dh'.or. providers(i)=='lp'.or. providers(i)=='no'  &
            .or. providers(i)=='op'.or. providers(i)=='rg'.or. providers(i)=='ry'  &
            .or. providers(i)=='sr'.or. providers(i)=='to'.or. providers(i)=='vu'  &
            .or. providers(i)=='we')then     
            !
            lvl_mask(i)=.false.
            !
          endif
       end do
    !
 end subroutine sMaskCAP
 ! ---------------------

 ! ----------------------------
 subroutine sMaskSROG(lvl_mask)
  use gm_GlobalData
    integer :: i
    logical :: lvl_mask(gvi_maxProV)
    character(len=2), dimension(gvi_maxProV) :: providers
    !
     call sProviders(providers)
       do  i = 1,gvi_Providers,1
          lvl_mask(i)=.false.
          if(providers(i) == 'gl' .or. providers(i)=='me' .or. providers(i)=='ph' &
            .or. providers(i)=='sc'.or. providers(i)=='te')then
           lvl_mask(i)=.true.
          endif
       end do
    !
 end subroutine sMaskSROG
 ! ----------------------

 ! ----------------------------------
 subroutine sMaskAgriculture(lvl_mask)
  use gm_GlobalData
    integer :: i
    logical :: lvl_mask(gvi_maxProV)
    character(len=2), dimension(gvi_maxProV) :: providers
    !
     call sProviders(providers)
       do  i = 1,gvi_Providers,1
          lvl_mask(i)=.false.
         if(providers(i) == 'bu' .or. providers(i)=='ch' .or. providers(i)=='em' &
            .or. providers(i)=='go'.or. providers(i)=='me'.or. providers(i)=='no'  &
            .or. providers(i)=='op'.or. providers(i)=='pe'.or. providers(i)=='qk'  &
            .or. providers(i)=='to')then
             lvl_mask(i)=.true.
          endif
       end do
    !
 end subroutine sMaskAgriculture
     ! ---------------------------

! Curve fitting- runtime
!
! ---------------------------------------------
subroutine typefiveExpSRP(annual,peakmonth,tfe)

   integer :: i,j,k
   integer, parameter :: iterations=1500
   real(8), parameter :: b=0.85
   real(8) :: max
   real(8) :: start
   real(8) :: peakmonth
   real(8) :: avg,annual,acft,check,diff
   real(8) :: tfe(12)
   ! ----------------
!   real(8) :: xbarUn(12)
   ! --------------------------
    !
    do i = 1,12,1
      tfe(i)=0
    end do
    if(0 < annual)then
    !
    acft=anint(annual*1e6)
    diff=1
    avg = acft/12.
    max = 1.5*avg ! 1.76
    start=0.2*avg ! 
    bstar=b
    check=0
    !
    max=max-start
    do j = 1,iterations,1
     do i = 1,12,1
      tfe(i) = start+max*bstar**(i-peakmonth)**2
     end do 
     !
     check=sum(tfe)
     if(abs(check - acft) < diff)then
!       write(7,*)j, "iterations in typefiveExp"
      exit
     else
      if(check - acft > 0)then
        bstar=bstar*0.999
      else
        bstar=bstar*1.001
      endif
     endif
    end do
    !
    do k = 1,12,1
     tfe(k)=anint(tfe(k))
    end do
    !
    else
    endif
 10   continue
  return
 100 continue
    !write(7,*) " iterations failed in typefiveExp"
    stop
 end subroutine typefiveExpSRP
! ----------------------------

! ------------------------------------------
subroutine typefiveExp(annual,peakmonth,tfe)

   integer :: i,j,k
   integer, parameter :: iterations=2500
   integer :: one
!   integer :: dt(8)

   real(8), parameter :: b=0.825
   real(8) :: max
   real(8) :: start
   real(8) :: peakmonth
   real(8) :: avg,annual,acft,check,diff
   real(8) :: tfe(12),difference
   ! ----------------
   ! --------------------------
    !
    do i = 1,12,1
     tfe(i)=0
    end do
    !
    acft=anint(annual*1e6)
    diff=1  ! One acft
    avg = acft/12.
    max = 1.46*avg ! Chi Chis defense ppt slide #9
    start=0.83*avg ! Chi Chi defense ppt slide #9
    bstar=b
    one=0  
    check=0
    difference=0
    !
1   max=max-start
    do j = 1,iterations,1
     do i = 1,12,1
      tfe(i) = start+max*bstar**(i-peakmonth)**2
     end do 
     one=one+1
     !
     check=sum(tfe)
     difference=abs(check - acft)
     if(difference < diff)then
      goto 10
     else
      if(check - acft > 0.)then
        bstar=bstar*0.9999
      else
        bstar=bstar*1.001
      endif
     endif
     !
!     if(diff == 0.)goto 10
     !
    end do
    !
     if(one > iterations)then
!      call date_and_time(values=dt)
      !write(7,*)bstar," In error loop type five",difference,dt
      one=0
      diff=diff+1
      bstar=0.85
      goto 1
     endif
     
10 continue
    do k = 1,12,1
     tfe(k)=anint(tfe(k))
    end do
!    if(diff /= 1.)then
!     !write(7,*)diff, "diff in typefiveExp"
!    endif
    !
  return
 100 continue
    !write(7,*)bstar,j," Iterations failed in typefiveExp"
    stop
 end subroutine typefiveExp
 ! ------------------------

! -----------------------------------------------------
subroutine typefiveExpRes(Model,E,annual,peakmonth,tfe)
 use gm_GlobalData
  use gm_Exception

    ! inputs maf a-1
    ! outputs AF month-1
   integer :: i,j,k
   integer, parameter :: iterations=5000
   integer :: one
!   integer :: dt(8)

   real(8), parameter :: b=0.81
   real(8) :: difference
   real(8) :: max
   real(8) :: start
   real(8) :: peakmonth
   real(8) :: avg,annual,acft,check,diff
   real(8) :: firstobs,inc 
   real(8) :: tfe(12,2),temp(12)
   real(8) :: xbarUn(12)
   character(10) :: Model

   type(Exception)E
   ! --------------------------
    !
    do i = 1,12,1
      do j = 1,2,1
        tfe(i,j)=0
      end do
    end do
    !
    acft=anint(annual*1e6)
    diff=1
    avg = acft/12.
    max = 1.43*avg 
    start=0.65*avg ! (data suggests 0.65) 
    firstobs=0.73*avg ! 0.8
    bstar=b
    inc=0.09
    one=0
    check=0
    difference=0
    !
    ! ------------------------------------------------------------------------------
    ! 95% uncertainty in the estimate, relative to the mean for each month 
    ! (two standard deviations / mean)
    !
    xbarUn(1)=0.08580   ; xbarUn(2)=0.16769 ; xbarUn(3)=0.18918 ; xbarUn(4)=0.12625
    xbarUn(5)=0.10108   ; xbarUn(6)=0.05551 ; xbarUn(7)=0.04710 ; xbarUn(8)=0.08454
    xbarUn(9)=0.05403   ; xbarUn(10)=0.09051; xbarUn(11)=0.24367; xbarUn(12)=0.11092
    ! -------------------------------------------------------------------------------

1    max=max-start
    do j = 1,iterations,1
      tfe(1,1)=firstobs
     do i = 2,12,1
      tfe(i,1) = start+max*bstar**(i-peakmonth)**2
      tfe(8,1) = (1-inc)*tfe(7,1)
      tfe(9,1) = (1-(inc*2))*tfe(7,1)
      tfe(10,1)= (1-(inc*3))*tfe(7,1)
      tfe(11,1)= (1-(inc*4))*tfe(7,1)
      tfe(12,1)= (1-(inc*5))*tfe(7,1)
     end do 
     one=one+1
     !
     do i = 1,12,1
      temp(i)=tfe(i,1)
     end do
     check=sum(temp)
     difference=abs(check - acft)
     if(difference < diff)then
!       write(7,*)j, "iterations in typefiveExp"
      exit
     else
      if(check - acft > 0)then
        bstar=bstar*0.999
      else
        bstar=bstar*1.001
      endif
     endif
     !
    end do
    !
    if(one > iterations)then
!      call date_and_time(values=dt)
      !write(7,*)bstar," In error loop- residential",difference,dt
      one=0
      diff=diff+1
      bstar=bstar+0.1
      goto 1
     endif
10    do k = 1,12,1
     tfe(k,2)= tfe(k,1)*xbarUn(k)
     tfe(k,1)=anint(tfe(k,1))   ! check this result
    end do
    !
   return
 100 continue
    !
    if(gvl_WriteToDisk)then
     !
     call catchException(Model,E)
     !
    endif
    stop
 end subroutine typefiveExpRes
! ----------------------------

! -----------------------------------------------------
subroutine typefiveExpCIO(Model,E,annual,peakmonth,tfe)
 use gm_GlobalData
  use gm_Exception
   !
   integer :: i,j,k
   integer, parameter :: iterations=2500
   integer :: one
!   integer :: dt(8)
   real(8) :: difference
   real(8), parameter :: b=0.85
   real(8) :: max
   real(8) :: start
   real(8) :: peakmonth
   real(8) :: avg,annual,acft,check,diff
   real(8) :: firstobs,inc 
   real(8) :: tfe(12,2),temp(12)
   real(8) :: xbarUn(12)
   character(10) :: Model

   type(Exception)E

   ! --------------------------
    !
    do i = 1,12,1
      do j = 1,2,1
       tfe(i,j)=0
      end do
    end do
    !
    acft=anint(annual*1e6)
    diff=1
    avg = acft/12.
    max = 1.41*avg 
    start=0.63*avg ! 
    firstobs=0.69*avg ! 
    bstar=b
    inc=0.05
    check=0
    difference=0
    one=0
    !
    ! ------------------------------------------------------------------------------
    ! 95% uncertainty in the estimate, relative to the mean for each month 
    ! (two standard deviations / mean)
    !
    xbarUn(1)=0.08580   ; xbarUn(2)=0.16769 ; xbarUn(3)=0.18918 ; xbarUn(4)=0.12625
    xbarUn(5)=0.10108   ; xbarUn(6)=0.05551 ; xbarUn(7)=0.04710 ; xbarUn(8)=0.08454
    xbarUn(9)=0.05403   ; xbarUn(10)=0.09051; xbarUn(11)=0.24367; xbarUn(12)=0.11092
    ! -------------------------------------------------------------------------------

1    max=max-start
    do j = 1,iterations,1
      tfe(1,1)=firstobs
      tfe(2,1)=firstobs*(1-inc)
      tfe(3,1)=firstobs*(1-(2*inc))
      tfe(4,1)=firstobs*(1+(2*inc))
    
     do i = 5,12,1
      tfe(i,1) = start+max*bstar**(i-peakmonth)**2
     end do 
     !
     one=one+1
     do i = 1,12,1
      temp(i)=tfe(i,1)
     end do
     check=sum(temp)
   difference=abs(check - acft)
     if(difference < diff)then
!       write(7,*)j, "Iterations in typefiveExp"
      exit
     else
      if(check - acft > 0)then
        bstar=bstar*0.999
      else
        bstar=bstar*1.001
      endif
     endif
     !
    end do
    !
    if(one > iterations)then
!      call date_and_time(values=dt)
      if(difference < diff)goto 10
      !write(7,*)bstar,diff," In error loop- cio",difference,dt
      one=0
      diff=diff+1
      bstar=0.85
      goto 1
     endif

10    do k = 1,12,1
     tfe(k,2)= tfe(k,1)*xbarUn(k)
     tfe(k,1)=anint(tfe(k,1))   ! check this result
    end do
    !
   return
 100 continue
    if(gvl_WriteToDisk)then
     !
     call catchException(Model,E)
     !
    endif
    ! write(7,*) " iterations failed in typefiveExp"
    stop
 end subroutine typefiveExpCIO
! -------------------------------

! --------------------------------------------------------
subroutine Normal(Model,E,lvf_min,lvf_total,lvf_out)
 use gm_GlobalData
  use gm_Exception

  character(10) :: Model
  !
  integer :: j,k,lvi_threshold
  integer :: iterations=5000
  real :: lvf_adjust,lvf_min,lvf_pct
  real(8) :: lvd_mod
  real :: lvf_total,lvf_difference,lvf_sum,lvf_threshPCT
  real :: lvf_magnitude
  real, dimension(1:12) :: lvf_out !,tfe
  real, dimension(1:12) :: tfe

  type(Exception)E

    ! ==================================================
    !
!    lvf_Beta=3.5
!    lvf_alpha=7.2 ! 6.5 and 3
    !
    if(0 < lvf_min .and. lvf_total == 0)goto 97
     call catchMinException(lvf_min,lvf_total,lvf_min)

    if(lvf_min <=0)goto 95
    if(lvf_total <=0)goto 96
1   continue
    !
    lvi_threshold=1
    lvf_difference=0
    lvf_magnitude=lvf_total-lvf_min
    lvf_pct=lvf_min/lvf_total
    lvd_mod=0.8
    if(0.01 <= lvf_pct)lvd_mod=0.75
    if(0.02 <= lvf_pct)lvd_mod=0.65
    if(0.03 <= lvf_pct)lvd_mod=0.55
    if(0.04 <= lvf_pct)lvd_mod=0.45
    if(0.05 <= lvf_pct)lvd_mod=0.35
    if(0.06 <= lvf_pct)lvd_mod=0.25
    if(0.07 <= lvf_pct)lvd_mod=0.16
    !
  
    if(0.08 < lvf_pct)then
     if(gvl_WriteToDisk)write(7,*)" In normal curve fit, initial water > 8% of total"
    else
!      do i = 1,12,1
!         tfe(i)=0
!!        tfe(i)=(1 / (lvf_sigma*(2*lvp_pi)**0.5))* EXP(- (((i-lvf_mu)**2) /2*lvf_sigma**2))
!        tfe(i)=1 / (lvf_Beta*2*lvp_pi)**0.5 * EXP((-1/(2*lvf_Beta))* (i-lvf_alpha)**2) 
!      end do
      call Zdistribution(tfe)
        !
    !     -------------------
    do j = 1,iterations,1
      lvf_sum=0
      lvf_adjust=(lvf_total-lvf_min)*lvd_mod
      ! +23
10    do k = 1,12,1
        lvf_out(k)=0
       lvf_out(k)=nint(tfe(k)*lvf_adjust + lvf_min)   ! check this result
      end do
      !
      lvf_sum=sum(lvf_out)
      lvf_difference=abs(lvf_sum - lvf_total)
      !
      lvf_threshPCT=lvf_difference/lvf_total
      if(2000 < j)then
        if(lvf_threshPCT <= 0.0001)then
         exit
        endif
      endif
      if(lvf_difference <=lvi_threshold)then
        exit
      else
        !
        call Nmodifier(j,lvf_magnitude,lvf_sum,lvf_total,lvd_mod)
        !
      endif
     end do
    endif
90  continue
   return
   
 95 continue 
    if(gvl_WriteToDisk)write(7,*)"Minimum <= 0- call to Normal subroutine"
      goto 101
 96 continue
    if(gvl_WriteToDisk)write(7,*)"Total Water <= 0- call to Normal subroutine"
      goto 101
 97 continue
    if(gvl_WriteToDisk)write(7,*)"No surface water rights in call to Normal"
      goto 101
 100 continue
    if(gvl_WriteToDisk)then
     write(7,*)"No closure-call to Normal", lvf_difference, " = Difference to closure "
     write(7,*)"Min:" ,lvf_min, "Total: ",lvf_total, "pct: ",lvf_min/lvf_total 
    endif
    !
 
 101 continue
     !
     call catchException(Model,E)
     !
end subroutine Normal
subroutine Zdistribution(tfe)
  integer :: i 
  real, dimension(1:12) :: tfe
  real,parameter :: lvp_pi=3.1415926535
  real,parameter :: lvf_Beta=8
  real,parameter :: lvf_alpha=7.2 ! 6.5 and 3
  !
    do i = 1,12,1
      tfe(i)=0
     tfe(i)=1 / (lvf_Beta*2*lvp_pi)**0.5 * EXP((-1/(2*lvf_Beta))* (i-lvf_alpha)**2) 
    end do
  !
end subroutine Zdistribution
!
subroutine DoNormal(i,lvf_indoor,lvp_min,parm,lvf_indoorOUT,lvf_outdoorOUT)
 use gm_GlobalData
 use gm_Exception

  integer :: i,j
  real :: lvf_indoor,lvp_min(gvi_maxProV)
  real ::  parm(gvi_maxProV),lvf_norm(12)
  real :: lvf_indoorOUT(gvi_maxProV,12),lvf_outdoorOUT(gvi_maxProV,12)
  real :: lvf_annual
  character(10) :: Model='DoNormal'
  type(Exception)E
  ! ==============
      !
       lvf_annual=lvf_indoor * parm(i)
      ! --------------------------------------------------
      E%MyFunction='Normal'
      call Normal(Model,E,lvp_min(i),lvf_annual,lvf_norm)                 
      ! --------------------------------------------------
      do j = 1,12,1
        lvf_indoorOUT(i,j)=(lvf_indoor -lvf_annual)/12
        lvf_outdoorOUT(i,j)=lvf_norm(j)
      end do
      !
end subroutine DoNormal
!
subroutine Nmodifier(it,lvf_mag,lvf_sum,lvf_tot,lvd_mod)
   !
   integer :: it
   real :: lvf_mag
   real(8) :: lvd_mod
   real :: lvf_tot,lvf_sum
   real(8) :: lvd_diffPct
   !
   real,parameter :: lvp_eightTens=0.8
   real,parameter :: lvp_Tenths=0.9
   real,parameter :: lvp_Hundredths=0.99
   real,parameter :: lvp_Thous=.999
   real,parameter :: lvp_TenThous=0.9999
   !
      !
      lvd_diffPct=lvf_sum/lvf_tot
      !
      if(lvd_diffPct <= 0.95)then
          !
           if(lvf_sum < lvf_tot)then
              lvd_mod=lvd_mod*1/lvp_eightTens
           else
              lvd_mod=lvd_mod*lvp_eightTens
           endif
           !
       else if(0.95 < lvd_diffPct .and. lvd_diffPct <= 1.05)then
       !
       !
          if(0.999 < lvd_diffPct .and. lvd_diffPct < = 1.001)then
            if(lvf_sum < lvf_tot)then
              lvd_mod=lvd_mod*1/0.99999
            else
              lvd_mod=lvd_mod*0.99999
            endif
          else if(0.99 < lvd_diffPct .and. lvd_diffPct < = 1.01)then
            if(lvf_sum < lvf_tot)then
              !
              if(10000 < lvf_mag)then
               lvd_mod=lvd_mod*1/lvp_TenThous
              else
               lvd_mod=lvd_mod*1/lvp_Thous
                if(500 < it )lvd_mod=lvd_mod*1/lvp_TenThous
              endif
              !
            else
              if(10000 < lvf_mag)then
                lvd_mod=lvd_mod*lvp_TenThous
              else
                lvd_mod=lvd_mod*lvp_Thous
                if(500 < it )lvd_mod=lvd_mod*1/lvp_TenThous            
              endif
            endif
          else if(0.98 < lvd_diffPct .and. lvd_diffPct < = 1.02)then
           !
            if(lvf_sum < lvf_tot)then
              lvd_mod=lvd_mod*1/lvp_Thous         
            else
              lvd_mod=lvd_mod*lvp_Thous
            endif
          else
            if(lvf_sum < lvf_tot)then

              lvd_mod=lvd_mod*1/lvp_Hundredths
            else
              lvd_mod=lvd_mod*lvp_Hundredths
            endif
          endif
       !
       !
       else if(1.05 < lvd_diffPct .and. lvd_diffPct <= 1.1)then
          !
           if(lvf_sum < lvf_tot)then
              lvd_mod=lvd_mod*1/lvp_Tenths
           else
              lvd_mod=lvd_mod*lvp_Tenths
           endif
           !
       else
         !
           if(lvf_sum < lvf_tot)then
              lvd_mod=lvd_mod*1/lvp_eightTens
           else
              lvd_mod=lvd_mod*lvp_eightTens
           endif
           !
       endif
       !
end subroutine Nmodifier
       !


        ! --------------------------------
        subroutine catchException(Model,E)
         use gm_GlobalData
          use gm_Exception
          !
          integer :: i
          character(10) :: Model
          character(len=3), dimension(12) :: MyMonth
          character(len=2), dimension(gvi_maxProV) :: providers
          !
          type(Exception)E
          !
          MyMonth(1)='Jan' ;  MyMonth(2)='Feb'; MyMonth(3)='Mar';  MyMonth(4)='Apr'
          MyMonth(5)='May';  MyMonth(6)='Jun';  MyMonth(7)='Jul';  MyMonth(8)='Aug'
          MyMonth(9)='Sep'; MyMonth(10)='Oct';  MyMonth(11)='Nov'; MyMonth(12)='Dec'
          !
          call sProviders(providers)
          !
          if(gvl_WriteToDisk)then
            i=E%Prov
            !
            if(E%TStep /=0)then
              write(7,*)i,"Module: ",Model," Provider: ",providers(i),"  Month: " ,&
              MyMonth(E%TStep)," Subroutine: ", E%MySub," Function: ",E%MyFunction,&
              "Specific Call: ", E%MyCall
            else
              write(7,*)i,"Module: ",Model," Provider: ",providers(i), &
              "  Subroutine: ",E%MySub," Function: ",E%MyFunction," Specific Call: ", E%MyCall
            endif
              write(7,*)" "
            !
          endif
        end subroutine catchException
        ! ---------------------------

        ! --------------------------------------------
        subroutine catchMinException(min,total,newMin)
          real :: min,total,newMin
          real :: pct
            !
             newMin=0
            if(0 < total)then
              pct=min/total
              if(0.07 < pct)then
                newMin = 0.06 * total
              else
                if(pct < 0.01)then
                 newMin = 0.01 * total
                endif
              endif 
            endif
        end subroutine catchMinException
        ! ------------------------------
 subroutine sProviders(providers)
  !
!   integer, parameter :: ad=1
!   integer, parameter :: wt=2
!   integer, parameter :: pv=3
!   integer, parameter :: su=4
!   integer, parameter :: sw=5
!   integer, parameter :: av=6
!   integer, parameter :: be=7
!   integer, parameter :: bu=8
!   integer, parameter :: cf=9
!   integer, parameter :: cc=10
!   integer, parameter :: ch=11
!   integer, parameter :: cp=12
!   integer, parameter :: sp=13
!   integer, parameter :: cu=14 
!   integer, parameter :: dh=15
!   integer, parameter :: em=16 
!   integer, parameter :: gi=17
!   integer, parameter :: gl=18
!   integer, parameter :: go=19
!   integer, parameter :: lp=20
!   integer, parameter :: me=21
!   integer, parameter :: no=22
!   integer, parameter :: op=23
!   integer, parameter :: pe=24
!   integer, parameter :: ph=25
!   integer, parameter :: qk=26 
!   integer, parameter :: rg=27
!   integer, parameter :: rv=28 
!   integer, parameter :: ry=29
!   integer, parameter :: sc=30
!   integer, parameter :: sr=31
!   integer, parameter :: te=32
!   integer, parameter :: to=33
!   integer, parameter :: vu=34
!   integer, parameter :: we=35
 
   character(len=2), dimension(35) :: providers
                             
   providers(1) ='ad'
   providers(2) ='wt'
   providers(3) ='pv'
   providers(4) ='su'
   providers(5) ='sw'
   providers(6) ='av'
   providers(7) ='be'
   providers(8) ='bu'
   providers(9) ='cf'
   providers(10)='cc'
   providers(11)='ch'
   providers(12)='cp'
   providers(13)='sp'
   providers(14)='cu'
   providers(15)='dh'
   providers(16)='em'
   providers(17)='gi'
   providers(18)='gl'
   providers(19)='go'
   providers(20)='lp'
   providers(21)='me'
   providers(22)='no'
   providers(23)='op'
   providers(24)='pe'
   providers(25)='ph'
   providers(26)='qk'
   providers(27)='rg'
   providers(28)='rv'
   providers(29)='ry'
   providers(30)='sc'
   providers(31)='sr'
   providers(32)='te'
   providers(33)='to'
   providers(34)='vu'
   providers(35)='we'
  !
 end subroutine sProviders
!
! =================================================================================================
!E.O.F