!
! File is Groundwater.f90
!
!   This Module models the County-scale groundwater pool and fluxes.  And, it controls
! some of the provider balance-pumping for municipal water providers
!
! Global OUTPUTS:  
!
! Local OUTPUTS:
!               
!   
! Local INPUTS:
!
! created on 10.01.09
!
!
! david arthur sampson
! last write was: 03.05.12
! =================================================================================================
!
Module lm_Groundwater_A
 use gm_ModelControl
  use gm_GlobalData
   
    implicit none
   ! ------------
     !
     include "C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt"
     !
  contains
      subroutine initGW()
       call openFiles_g()
       call readParms_g()
       call readFiles_g()
       call initialState_g()
      end subroutine initGW
      ! -------------------

        ! ----------------------
        subroutine openFiles_g()

          character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
          if(gpl_release)lvc_dataPath=trim(gvc_DPath)
          !
           LU=24
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\cagrd.txt'),exist=lexist)
          if(lexist)then
            open(24,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\cagrd.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Groundwater_A missing(or corrupt):cagrd.txt ", "Logical Unit = ", LU 
            endif
          endif
           LU=33
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\GWdesignations.txt'),exist=lexist)
          if(lexist)then
            open(33,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\GWdesignations.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Groundwater_A missing(or corrupt): GWdesignations.txt ", "Logical Unit = ", LU 
            endif
          endif
           LU=34
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_GW.dat'),exist=lexist)
          if(lexist)then
            open(34,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_GW.dat'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Groundwater_A missing(or corrupt): parm_GW.dat", "Logical Unit = ", LU 
            endif
          endif
          !
         return
        end subroutine openFiles_g
        ! ------------------------

        ! ----------------------
        subroutine readFiles_g()
            !
            integer :: i,j,LU
            integer :: ios
            !
            !  Read unit 17 - CAGRD data.  Convert from ac-ft to maf
            !-----------------------------------------------------------------  
            !
            LU=24
            read(LU,*,err=8,iostat=ios)(li_cagrdRecharge(i),i=2000, gpi_uBY)      ! acft a-1
            do j = 2000, gpi_uBY,1
            li_cagrdRecharge(j)=li_cagrdRecharge(j)*gpd_acftTomaf      
           ! maf a-1
            end do
8           continue
            close(24)
            if(ios >0)then
            LU=24
            goto 1000
            endif
            !
            LU=33
            do i = 1,gvi_Providers,1
             read(LU,*,err=9,iostat=ios)vDesignationsGW(i)
            end do
            
9           continue
            close(33)
            if(ios >0)then
            LU=33
            goto 1000
            endif
         return
         1000 continue
          if(gvl_WriteToDisk)&
           write(7,*)" Error reading file input, line 113:Groundwater.f90- logical unit is:", LU
        end subroutine readFiles_g
        ! ------------------------

        ! ----------------------
        subroutine readParms_g()
            read(34,*)gv_gwcutoffvalue
            read(34,*)li_absorptionoverflow
            read(34,*)li_accesstosurfacewater
            read(34,*)li_initialgroundwater
            read(34,*)gv_rechargeAWBA
            read(34,*)gv_rechargeCAGRD
            read(34,*)gv_rechargeNatural
            !
            close(34)
           return
        end subroutine readParms_g
        ! ------------------------
        subroutine initialState_g()
            !~
             go_StateGW=nint(li_initialgroundwater*1e6)
            !~
        end subroutine initialState_g
End Module lm_Groundwater_A
!
Module lms_Groundwater_A
 use gm_ModelControl
  use gm_GlobalData
   use gm_TypeControl
   
    implicit none
   ! ------------
    !
    include "C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt"
    !
    type groundwater
     real(8) :: lv_rechargeNatural,lv_GWDifference(gpi_lBY:gpi_uBY)
     real(8) :: lv_GWRecharged(gpi_lBY:gpi_uBY),lv_GWPumped(gpi_lBY:gpi_uBY)
     real(8) :: lv_rechargeNatural_monthly(12)
    end type groundwater
    !
   contains
      subroutine initState_g(T)

      type(runTime)T
      ! ===============
        !
        if(T%year == T%startyear)then
         vState_GW_maf(T%year)=li_initialgroundwater    ! maf
         if(2000 < T%year)vState_GW_maf(T%year-1)=vState_GW_maf(T%year)
        endif
        !
      end subroutine initState_g
     !---------------------------

      ! -----------------------------------------------------
      subroutine deltaState_g(T,vGW,lv_demand,overf,acft,gwo)

        integer :: fLogicalToInteger
        integer :: acft

        real(8) :: lv_demand,overf
        real(8) :: lv_surfacedemand
        real(8) :: lv_directGroundwaterDemand 
        real(8) :: lv_AwbaRecharge,lv_rechargeCAGRD,lv_rechargeobligations
        real(8) :: lv_demandMinusSupply,lv_excess,lv_directPumping
        real(8) :: lv_overflowRechargeRiver_A
        real(8) :: lv_municiplePumping

        logical :: lv_GWOverride=.false.
        logical :: gwo

        type(groundwater)vGW
        type(runTime)T
       ! ===============
        !
         lv_surfacedemand=(li_accesstosurfacewater)*lv_demand    
         lv_directGroundwaterDemand=(1.-li_accesstosurfacewater)*lv_demand
        !
        if(fLogicalToInteger(gv_rechargeAWBA) == 1)lv_AwbaRecharge=0.150218 
        if(fLogicalToInteger(gv_rechargeCAGRD) == 1)then
         lv_rechargeCAGRD=li_cagrdRecharge(T%year)
        else
         lv_rechargeCAGRD=0.
        endif
        !
         lv_excess=0
         lv_rechargeobligations=0
         lv_municiplePumping=0.
        lv_rechargeobligations=lv_AwbaRecharge+lv_rechargeCAGRD
            ! acft = maricopa county surface water (acft a-1)
        lv_demandMinusSupply=(lv_surfacedemand+lv_rechargeobligations)-(acft*gpd_acftTomaf)

        if(lv_demandMinusSupply > 0)then
          lv_municiplePumping=lv_demandMinusSupply
        else
          lv_excess=abs(lv_demandMinusSupply)
        endif
        !
         lv_directPumping=0
        lv_directPumping=lv_directGroundwaterDemand
        vGW%lv_GWPumped(T%year)=lv_directPumping+lv_municiplePumping
         lv_overflowRechargeRiver_A=0.
        lv_overflowRechargeRiver_A=overf*li_absorptionoverflow             ! Overflow from the SVT - or "of" (acft a-1)
        !
        if(fLogicalToInteger(gv_rechargeNatural) == 1)then

        else
          vGW%lv_rechargeNatural=0.
        endif
        !
        vGW%lv_GWRecharged(T%year)=lv_excess+vGW%lv_rechargeNatural+lv_overflowRechargeRiver_A+lv_rechargeobligations
!    
        vState_GW_maf(T%year)=vState_GW_maf(T%year)+vGW%lv_GWRecharged(T%year)-vGW%lv_GWPumped(T%year)
        !
        if(gv_gwcutoffvalue <=0)goto 100
         vGW%lv_GWDifference(T%year)=vState_GW_maf(T%year)-li_initialgroundwater
        if(vGW%lv_GWDifference(T%year) > gv_gwcutoffvalue)lv_GWOverride=.true.
         gwo=lv_GWOverride
        !
        return
       100 stop
      end subroutine deltaState_g
      !--------------------------

      ! -------------------------------------------
      subroutine unintendedRecharge_g(T,flow_A,vGW)

            integer :: flow_A   ! acft
            real(8) :: lv_artificialLake,lv_effluentdischarge,lv_majordrainage
            real(8) :: lv_leakageSRP,lv_leakageCAP,lv_mountainfront,lv_ephemeralstreams

            type(groundwater)vGW
            type(runTime)T
            ! ===============
            !
            lv_artificialLake=10000            ! acft
            lv_effluentdischarge=0.258*0.      ! acft
            lv_majordrainage=(0.7*exp(-exp(2.5 - 1.7*(flow_A*gpd_acftTomaf))))

            lv_leakageSRP=34200
            lv_leakageCAP=16700
            lv_mountainfront=13000*(flow_A*gpd_acftTomaf)    
            lv_ephemeralstreams=15427*(flow_A*gpd_acftTomaf)
            !
            vGW%lv_rechargeNatural=(lv_artificialLake+lv_effluentdischarge+lv_majordrainage & 
              + lv_leakageSRP+lv_leakageCAP+lv_mountainfront+ lv_ephemeralstreams)*gpd_acftTomaf
            !
          return
        end subroutine unintendedRecharge_g 
        !-----------------------------------

    !------------------------
    subroutine outinitialG(T) 

      type(runTime)T
      ! ===============
        !
       if(T%year /= T%startyear)then
       else
        if(gvl_WriteToDisk)then
        ! -------------------------------------------------------------------------------------
        write(9,*) ""
        write(9,*) "                           Groundwater Variables                            "
        write(9,*) "----------------------------------------------------------------------------"
        write(9,*) "                       "," Year=",T%year
        write(9,*) "                                                                            "
        write(9,*) "Initial groundwater:   ",li_initialgroundwater, "  To 1000 feet (305 m)(maf)"
        if(gv_gwcutoffvalue < 25)then
        write(*,*) "Groundwater cut-off:   ",gv_gwcutoffvalue,  "  Value To invoke sustainabillity"
        endif
        write(9,*) "Use AWBA recharge?     ",gv_rechargeAWBA,   "  Arizona Water Banking Authority"
        write(9,*) "CAGRD recharge?        ",gv_rechargeCAGRD,  "  Use CAGRD annual projections?"
        write(9,*) "Natural Recharge?      ",gv_rechargeNatural,"  Include in the water budget?"
        write(9,*) ""
        write(9,*) "       Some groundwater constants used in the model"
        write(9,*) " =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  = "
        write(9,*) "Access to surface groundwater:                 ",li_accesstosurfacewater
        write(9,*) "Absorption overflow:                           ",li_absorptionoverflow
        write(9,*) "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
        write(9,*) ""
        !
       endif
     endif
    end subroutine outinitialG
    !-------------------------

    ! -----------------------
    subroutine outputs(T,vGW)

       type(runTime)T
       type(groundwater)vGW
       !===================
        !
        go_StateGW=NINT(vState_GW_maf(T%year)*(1./gpd_acftTomaf))  ! acft a-1
        go_PumpageGW=NINT(vGW%lv_GWPumped(T%year)* (1./gpd_acftTomaf))
        go_RechargeGW=NINT(vGW%lv_GWRecharged(T%year)* (1./gpd_acftTomaf))
        go_naturalRecharge=NINT(vGW%lv_rechargeNatural* (1./gpd_acftTomaf))
        go_groundwaterDifference=NINT(vGW%lv_GWDifference(T%year)*(1./gpd_acftTomaf))
        !
        vState_GW_maf(T%year+1)=vState_GW_maf(T%year)
        !
            ! Once through the module- write to log file
            ! ==========================================
            if(T%year == T%startyear)then
             if(gvl_WriteToDisk)then
              if(.not. gvl_Interrupt)write(7,*)"  Groundwater:"
             endif
            endif
        !
      return
    end subroutine outputs
    !---------------------
!
End Module lms_Groundwater_A
!
 ! ----------------------------------
 subroutine sGroundwater(T,Sin,D,gwo)
  use gm_ModelControl
   use lms_Groundwater_A
    !
      logical :: gwo
      integer :: aflow_A
      real(8) :: mwd=1.0
      real(8) :: overflow
      integer :: msw
      !
      type(Demand)D
      type(groundwater)vGW
      type(Surfacewater)Sin
      type(runTime)T
      ! ===================
        !
        aflow_A=NINT(Sin%sSVTflow_maf*(1./gpd_acftTomaf))
        overflow=Sin%sSVTPreRelease_maf
        msw=NINT(Sin%sMaricopaSWS_maf*(1./gpd_acftTomaf))
        mwd=D%dag_demand(T%year)+D%dres_demand(T%year)+D%dcio_demand(T%year)
        !
        call initState_g(T)
        call unintendedRecharge_g(T,aflow_A,vGW)
        call deltaState_g(T,vGW,mwd,overflow,msw,gwo)
        call outinitialG(T) 
        call outputs(T,vGW)
        !
    end subroutine sGroundwater    
   !---------------------------

    ! Called from the Kernel.f90
    ! -----------------------------
    subroutine sGWater(T,gvi_order)
      use gm_ModelControl
       use lms_Groundwater_A
      !
      integer(1) :: gvi_order
      integer :: i
      ! Units in AF or AF annum-1
      real  :: lvf_WaterDemand35(gvi_maxProV),gvf_usedGW(gvi_maxProV)
      real :: lvf_GW(gvi_maxProV),lvf_on(gvi_maxProV),lvf_off(gvi_maxProV)
      real :: lvf_addGroundwaterFromAg(gvi_maxProV)
      integer :: lvi_AgRequest(gvi_maxProV)
      real :: lvf_AgAvailable(2000:2100)
      real :: code=10
      real :: lvf_demand,lvf_propDemand
      !
      type(runTime)T
      ! ============
       !
        do j = 1,gvi_Providers,1
            !
            lvi_AgRequest(j)=0
          lvi_AgRequest(j)=gvi_WaterFromAgPumping_AF_a(j)
            lvf_AgAvailable(T%year)=0
          lvf_AgAvailable(T%year)=gv_AgWaterPumpingSRV(T%year,1)
          !
        end do
        call sAgGroundwaterCheck(lvi_AgRequest,lvf_AgAvailable(T%year))
         !
         do i = 1,gvi_Providers,1
          gvf_usedGW(i)=0
          lvf_addGroundwaterFromAg(i)=0
            lvf_addGroundwaterFromAg(i)=lvi_AgRequest(i)

             ! Agriculture water added from the general bucket; controled
             ! by the interface.  No spatial representation of this water
             ! (at the moment) 03.05.12
            vDesignationsGW(i)=vDesignationsGW(i)+max(0,lvf_addGroundwaterFromAg(i))
             !
             lvf_WaterDemand35(i)=gvf_WaterDemand_AF(i,gvi_order,1)
            if(0 < lvf_WaterDemand35(i))then
              if(lvf_WaterDemand35(i) <=  vState_WB_Aquifer(T%year,i))then
                if(0 < vDesignationsGW(i)*1)then
                  if(lvf_WaterDemand35(i) <  vDesignationsGW(i)*1)then
                    gvf_usedGW(i)=lvf_WaterDemand35(i)
                  else
                    !
                    gvf_usedGW(i)= vDesignationsGW(i)
                    ! 03.07.12 DAS if surface water availalbility hits 80% of needs,
                    ! designations no longer apply
                    if(gvl_removeGWRestrictions(i))gvf_usedGW(i)= lvf_WaterDemand35(i)
                  endif
                else
                    gvf_usedGW(i)= lvf_WaterDemand35(i)
                endif
              else
                  ! added on 27 July at 16 hours, 20 min
                if(0 < vState_WB_Aquifer(T%year,i))then
                  if(1.*vDesignationsGW(i) < vState_WB_Aquifer(T%year,i))then
                    if(0 < vDesignationsGW(i)*1.)then
                     gvf_usedGW(i)=vDesignationsGW(i)*1.
                    else
                     gvf_usedGW(i)=vState_WB_Aquifer(T%year,i) ! added 02.01.12
                    endif
                  else
                    gvf_usedGW(i)= vState_WB_Aquifer(T%year,i)
                  endif
                else
                endif              
              endif
             ! 
            else
            endif
         end do
          !
          ! =======================
          do i = 1,gvi_Providers,1
             lvf_demand=0
             lvf_propDemand=0
             lvf_GW(i)=0
            lvf_GW(i)=gvf_usedGW(i)
            lvf_demand=gvf_WaterDemand_AF(i,gvi_order,1)
            ! Total demand > 0
            if(0 < lvf_demand)then
                ! Check on-project first
               if(0 < gvf_WaterDemand_AF(i,gvi_order,3))then
                !
                if( 1 < gvf_WaterDemand_AF(i,gvi_order,3))then
                 lvf_propDemand=gvf_WaterDemand_AF(i,gvi_order,3) * (1./lvf_demand)
                 !
                 lvf_on(i)=lvf_propDemand* lvf_GW(i)
                 lvf_off(i)=lvf_GW(i)-lvf_on(i)
                else
                  ! give the 1 AF demand to off-project
                 lvf_on(i)=0
                 lvf_off(i)=lvf_GW(i)
                endif
               else
                lvf_on(i)=0
                lvf_off(i)=lvf_GW(i)
               endif
            else
                lvf_on(i)=0
                lvf_off(i)=0
            endif
          !
          end do
         !
          call sCWaccounting(gvi_order,lvf_off,lvf_on,code)
        ! 
        gvi_order=gvi_order+1
        !
      return
    end subroutine sGWater
!
! =================================================================================================
! E.O.F.