!
! File is Meteorology.f90
!
! This module reads meteorological data into common memory
!
! Initialized in subroutine InitK() which is found in Kernel.f90
!----------------------------------------------------------------
!
! created on 11.19.10
!
! david arthur sampson
! last write was: 02.10.12
! -------------------------
!
! =================================================================================================
Module lm_Meteorology
 use gm_ModelControl
    use gm_GlobalData
   
   implicit none
   ! -------------
   include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
   !
  contains
    subroutine initMeteo()
      if(gvl_IncludeMeteorology)then
        call openFiles_met()
        call readFiles_met()
      endif
    end subroutine initMeteo
    ! ----------------------

        ! ------------------------
        subroutine openFiles_met()

          character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
          if(gpl_release)lvc_dataPath=trim(gvc_DPath)
          !
           LU=60
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\MetDataBaseline.txt'),exist=lexist)
          if(lexist)then
            open(60,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\MetDataBaseline.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Meteorology missing(or corrupted): MetDataBaseline.txt", "Logical Unit = ", LU 
            endif
          endif
           LU=61
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\MetDataProjected.txt'),exist=lexist)
          if(lexist)then
            open(61,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\MetDataProjected.txt'),status='old')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_Meteorology missing(or corrupted): MetDataProjected.txt", "Logical Unit = ", LU 
            endif
          endif
          !
         return
        end subroutine openFiles_met
        ! --------------------------

        ! -----------------------
        subroutine readFiles_met()
          integer :: LU,ios,i,j,k,lvc_length=1200
          real :: lif_MetData(2000:2100,12,3),lvf_year,lvf_month,lvf_Tmax,lif_ErrorTmax,lvf_Tmin,lif_ErrorTmin,lvf_Precip
          real :: lif_MetDataProjected(2000:2100,12,3)
          !
          ! NCEP special projects - read Tmax,Tmin, and Precipitation from GCM outputs
          ! 11.19.10 das
        ! =====================================================================================
        !
        LU=60
          ! This should be a "do while" construct
          do i = 1,lvc_length,1
            lvf_Tmax=0 
            lvf_Tmin=0
            lvf_Precip=0
               read(LU,*,err=1000,iostat=ios)lvf_year,lvf_month,lvf_Tmax,lif_ErrorTmax,lvf_Tmin,lif_ErrorTmin,lvf_Precip
               lif_MetData(lvf_year,lvf_month,1)=lvf_Tmax
               lif_MetData(lvf_year,lvf_month,2)=lvf_Tmin
               lif_MetData(lvf_year,lvf_month,3)=lvf_Precip
          end do
          !
         close(LU)
         do i = 2000,2099,1
            do j = 1,12,1
              do k = 1,3,1
                lvf_MetData(i,j,k)=0.
              end do
            end do
          end do
          !
          do i = 2000,2099,1
            do j = 1,12,1
              do k = 1,3,1
               lvf_MetData(i,j,k)= lif_MetData(i,j,k)
              end do
            end do
          end do
          ! ===================================================================================
          LU=61
          ! THis should be a "do while" construct
          do i = 1,lvc_length,1
               read(LU,*,err=1000,iostat=ios)lvf_year,lvf_month,lvf_Tmax,lif_ErrorTmax,lvf_Tmin,lif_ErrorTmin,lvf_Precip
               lif_MetDataProjected(lvf_year,lvf_month,1)=lvf_Tmax
               lif_MetDataProjected(lvf_year,lvf_month,2)=lvf_Tmin
               lif_MetDataProjected(lvf_year,lvf_month,3)=lvf_Precip
          end do
          !
         close(LU)
         do i = 2000,2099,1
            do j = 1,12,1
              do k = 1,3,1
                lvf_MetDataProjected(i,j,k)=0.
              end do
            end do
          end do
          !
          do i = 2000,2099,1
            do j = 1,12,1
              do k = 1,3,1
               lvf_MetDataProjected(i,j,k)= lif_MetDataProjected(i,j,k)
              end do
            end do
          end do
          !
    return
1000    continue
         if(gvl_WriteToDisk)then
          write(7,*)"Error reading meteorological data on line 109, in Meteorology.f90 - local module", ios
          write(7,*)"Abnormal Program Termination"
         endif
      end subroutine readFiles_met
      ! --------------------------
!
End Module lm_Meteorology
! =================================================================================================
! E.O.F.
