!
!   File is Provider.f90
!
!       This file contains the provider level calculations; essentialy, most of the final 
!   water balance calculations area conducted here. And, are sent to the interface. i.e.,
!   individual water protfiolios are provided here, as output either to other submodules
!   of to the C# interface, as discussed.
!
!
! Global OUTPUTS:

!
! Local OUTPUTS:
!                

!               
! Local INPUTS:
!              
!-------------------------------------------------------------------------------------------
!
! created on 06.08.10
!
! david arthur sampson
! last write was: 03.28.12
! ------------------------------------------------------------------------------------------
!
Module lms_Provider
 use gm_ModelControl
  use gm_GlobalData
   use gm_TypeControl
    use gm_Euler
     use gm_Exception
    !
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
    type LocalProvider
     real(8) :: lv_capMandItiers(5,2)
     real(8) :: lv_realizedDesignationCAP_acft(gpi_lBY:gpi_uBY,gvi_maxProV)
     real(8) :: lv_providerDemandAg(gpi_lBY:gpi_uBY,gvi_maxProV)
     real(8) :: lvd_demand_designations(gvi_maxProV)
     real(8) :: lvd_providerSRP_total_35_AF(gpi_lBY:gpi_uBY,gvi_maxProV)
     real(8) :: lvd_providerSRP_classA_35_AF(gpi_lBY:gpi_uBY,gvi_maxProV)
     real(8) :: lv_ProvidersSRPpumping_AF(gpi_lBY:gpi_uBY,gvi_maxProV)
     !
     real    :: lvf_NCS(10),lvf_maxNCS(10)
     real    :: lvf_providerSRP_NCS_35_AF(gpi_lBY:gpi_uBY,gvi_maxProV)
     real    :: lvf_unusedClass_A_AF(gvi_maxProV)
     real    :: lvf_reclaimed(gvi_maxProV),lvf_ROreclaimed(gvi_maxProV),lvf_GWbanking(gvi_maxProV)
     real    :: lvf_unMetDemand_AF(gvi_maxProV)
     real    :: lvf_demand_SRP_used_AF(10),lvf_CAP_used_AF(gvi_maxProV),lvf_BandCpumpingPass_35_AF(gvi_maxProV)
    end type LocalProvider
    !
    character(10),parameter :: Model='Provider'
 
 contains
     !
        subroutine writetodisk_(T,vLP,vD)
          integer :: i
          integer :: Prov,lvi_countSRP
          integer :: ios
          integer :: dt(8)
          integer :: maxSVT(gvi_maxProV),fixedSVT(gvi_maxProV),list
          integer :: lv_demand,lv_ppl
          integer :: sumCAP,sumGW,sumFixed,sumClassA,sumNCS
          integer :: lv_demandSans_no_op,lv_CAPSans_no_op,lv_GWSans_no_op,lv_PopSans_no_op
          integer :: cvi_NCS10(10)

          real, parameter :: cv_NCSmax=272500
          real :: lvf_NCS(10),lvf_GPCDavg

          logical :: lv_agdemand_out=.false.
          ! ch=10%,gl=10%,me=15%,ph=50%,sc=10%,te=5%
          ! Maximum available=cv_NCSmax=272500
          data lvf_NCS(1),lvf_NCS(2),lvf_NCS(3),lvf_NCS(4),lvf_NCS(5),lvf_NCS(6) &
                ,lvf_NCS(7),lvf_NCS(8),lvf_NCS(9),lvf_NCS(10) /0,0.1,0,0.1,0.15,0,0.5,0.1,0.05,0/
          character(len=2), dimension(35) :: providers
          !
          ! =====================
          type(runTime)T
          type(LocalProvider)vLP
          type(Provider)vD
          ! =====================
            !
            ! -------------------------------------------------------------------------------
            !
            do i = 1,gvi_Providers,1
              maxSVT(i)=0
              fixedSVT(i)=0
            end do
            !
            do i = 1,10,1
              cvi_NCS10(i)=0
              cvi_NCS10(i)=nint(cv_NCSmax*lvf_NCS(i))
            end do
!                
            ! ---------------------------
            if(T%year == T%startyear)then
              !
              call date_and_time(values=dt)
                !
               if(gvl_WriteToDisk)then

              ! =============================================================================================
!              write(8,*) "WaterSim-Urban 4.07- Provider Inputs"
              write(8,*) "Model Run is:  Year M D  - Time"
              write(8,*) "              ", dt
              write(8,*) ""
              write(8,*) "Prov    Water   GPCD   Population            Designations (acft a-1)     "
              write(8,*) "                                   - - - - - - - - - - - - - - - - - - -  - - -"
              write(8,*) "       Demand  (2006)      ppl      CAP      GW               SRP               "
              write(8,*) "     (acft a-1)                                  Class B&C Class A  NCS   Total"
              write(8,*) "                                                   (max)    (max)  (max)  (max)"
              write(8,*) "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -"
              !
              endif
            !
            do i = 1,10,1
             maxSVT(i)=nint(li_designationsSVT(42,i)* (1./gpd_acftTomaf))
             fixedSVT(i)=nint(vD%gAclassBCdesignationsMax_10_maf(T%year,i)* (1./gpd_acftTomaf))
            end do
              ! Come back to this DAS
              sumCAP=sum(li_designationsCAP)
              sumGW=sum(vDesignationsGW)
              sumFixed=sum(fixedSVT)
              sumClassA=sum(maxSVT)
              sumNCS=nint(cv_NCSmax)
              ! What about a sumB&C?????? figure this out... 12.14.11 DAS
              !
               lv_demand=0
               lv_ppl=0
              do i = 1,gvi_Providers,1
                 lv_demand=lv_demand+lv_providerDemandRandM(T%year,i)
                if(2000 < T%year)then
                 lv_ppl=lv_ppl+li_providerpop(T%year-1,i)
                else
                 lv_ppl=lv_ppl+li_providerpop(T%year,i)
                endif
              end do
               !
            call sProviders(providers)
            call sMaskSRP(gvl_maskSRP)
            call GPCD(gv_EmpiricalGPCD)
             lvf_GPCDavg=0
             lvf_GPCDavg=sum(gv_EmpiricalGPCD) * (1./35)
            lvi_countSRP=1
            !
            do i = 1,gvi_Providers,1
               Prov = i
             if(gvl_maskSRP(i))then     
                 list=lvi_countSRP
               if(2000 < T%year)then
                if(lv_agdemand_out)then
                  if(gvl_WriteToDisk)&
                   write(8,10, err=100,iostat=ios)Prov,providers(Prov),lv_providerDemandRandM(T%year,Prov),&
                  vLP%lv_providerDemandAg(T%year,Prov),li_providerpop(T%year-1,Prov),li_designationsCAP(Prov,1), & 
                  vDesignationsGW(Prov),fixedSVT(list),maxSVT(list),cvi_NCS10(list),fixedSVT(list)+maxSVT(list)+cvi_NCS10(list)
                else
                  if(gvl_WriteToDisk)&
                   write(8,20, err=100,iostat=ios)Prov,providers(Prov),lv_providerDemandRandM(T%year,Prov),&
                  gv_EmpiricalGPCD(Prov),li_providerpop(T%year-1,Prov),li_designationsCAP(Prov,1), & 
                  vDesignationsGW(Prov),fixedSVT(list),maxSVT(list),cvi_NCS10(list),fixedSVT(list)+maxSVT(list)+cvi_NCS10(list)
                endif
              else
               if(lv_agdemand_out)then
                  if(gvl_WriteToDisk)&
                   write(8,10, err=100,iostat=ios)Prov,providers(Prov),lv_providerDemandRandM(T%year,Prov),&
                  vLP%lv_providerDemandAg(T%year,Prov),li_providerpop(T%year,Prov),li_designationsCAP(Prov,1), & 
                  vDesignationsGW(Prov),fixedSVT(list),maxSVT(list),cvi_NCS10(list),fixedSVT(list)+maxSVT(list)+cvi_NCS10(list)
                else
                  if(gvl_WriteToDisk)&
                   write(8,20, err=100,iostat=ios)Prov,providers(Prov),lv_providerDemandRandM(T%year,Prov),&
                  gv_EmpiricalGPCD(Prov),li_providerpop(T%year,Prov),li_designationsCAP(Prov,1), & 
                  vDesignationsGW(Prov),fixedSVT(list),maxSVT(list),cvi_NCS10(list),fixedSVT(list)+maxSVT(list)+cvi_NCS10(list)
                endif
              endif
               lvi_countSRP=lvi_countSRP+1
             else
              if(2000 < T%year)then
                if(lv_agdemand_out)then
                  if(gvl_WriteToDisk)&
                   write(8,10, err=100,iostat=ios)Prov,providers(Prov),lv_providerDemandRandM(T%year,Prov),&
                  vLP%lv_providerDemandAg(T%year,Prov),li_providerpop(T%year-1,Prov), &
                    li_designationsCAP(Prov,1),vDesignationsGW(Prov),0,0,0,0
                else
                  if(gvl_WriteToDisk)&
                   write(8,20, err=100,iostat=ios)Prov,providers(Prov),lv_providerDemandRandM(T%year,Prov),&
                  gv_EmpiricalGPCD(Prov),li_providerpop(T%year-1,Prov),li_designationsCAP(Prov,1),vDesignationsGW(Prov),0,0,0,0
                endif
              else
               if(lv_agdemand_out)then
                  if(gvl_WriteToDisk)&
                   write(8,10, err=100,iostat=ios)Prov,providers(Prov),lv_providerDemandRandM(T%year,Prov),&
                  vLP%lv_providerDemandAg(T%year,Prov),li_providerpop(T%year,Prov), &
                    li_designationsCAP(Prov,1),vDesignationsGW(Prov),0,0,0,0
                else
                  if(gvl_WriteToDisk)&
                   write(8,20, err=100,iostat=ios)Prov,providers(Prov),lv_providerDemandRandM(T%year,Prov),&
                  gv_EmpiricalGPCD(Prov),li_providerpop(T%year,Prov),li_designationsCAP(Prov,1),vDesignationsGW(Prov),0,0,0,0
                endif
              endif

             endif         
           end do
         
              !
              lv_demandSans_no_op=0
              lv_PopSans_no_op=0
              lv_CAPSans_no_op=0
              lv_GWSans_no_op=0
              !
              lv_demandSans_no_op=lv_demand-(lv_providerDemandRandM(T%year,22) + lv_providerDemandRandM(T%year,23))
              lv_PopSans_no_op=li_providerpop(T%year,22)+lv_GrowthRateAdjPop(T%year,23)
             if(2000 < T%year)lv_PopSans_no_op=lv_ppl-(li_providerpop(T%year-1,22) + lv_GrowthRateAdjPop(T%year-1,23))
              lv_CAPSans_no_op=sumCAP-(li_designationsCAP(22,1)+li_designationsCAP(23,1) )
              lv_GWSans_no_op=sumGW-(vDesignationsGW(22)+vDesignationsGW(23))
              !
           if(gvl_WriteToDisk)then
            write(8,*)"- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
            write(8,11)"Total",lv_demand,lvf_GPCDavg,lv_ppl,sumCAP,sumGW,sumFixed,sumClassA,sumNCS,sumFixed+sumClassA+sumNCS
            write(8,12)"Used",lv_demandSans_no_op,lv_PopSans_no_op,lv_CAPSans_no_op,lv_GWSans_no_op &
                ,sumFixed,sumClassA,sumNCS,sumFixed+sumClassA+sumNCS
           endif
            !
            if(gvl_WriteToDisk)close(8)
10          format(I2,1x,A,1x,F7.0,1x,F8.0,1x,F7.0,1x,F7.0,1x,I10,2x,I6,3x,I6,2x,I6,2x,I6)
11          format(A5,1x,I8,3x,F4.0,2x,I8,2x,I6,2x,I6,8x,I6,2x,I6,2x,I6,1x,I7)
12          format(A5,1x,I8,9x,I8,2x,I6,2x,I6,8x,I6,2x,I6,2x,I6,1x,I7)

20          format(I2,1x,A,1x,F7.0,3x,I4,4x,F8.0,1x,F7.0,1x,I7,3x,I10,2x,I6,2x,I6,2x,I6,2x,I6)
21          format(A5,1x,I8,8x,I8,2x,I6,4x,I6,3x,I6,1x,I8,2x,I8)
22          format(A4,1x,I8,15x,I8,2x,I6)

            endif
          return
100         continue
             if(gvl_WriteToDisk)then
                write(7,*)"ios on unit", ios, " Provider.f90 line 237"
             endif
             stop
        end subroutine writetodisk_
        !---------------------------

        !----------------------------------
        subroutine sProvider(T,vGP,vLP)

            integer :: i,j

            type(Provider)vGP
            type(LocalProvider)vLP
            type(runTime)T
            ! ============
            !
            !==============
            ! 
            do j = 1,gvi_Providers,1
             vGP%cPopProvider(j)     =gvf_populations(j) 
             vGP%oDemandNoAg_acft(j) = gvf_WaterDemand_AF(j,1,1)
            end do
            !
            call aDemandSupply(T,vGP,vLP)
            call aDifference(T,vGP)
            !
            !==============
            ! -------------------------------------------------------------
            ! All Providers
            ! ---------------------
             ! Send to the interface- Provider water demand and population
             ! ----------------------
             do i = 1,gvi_Providers,1
               go_ProviderDemand(i)      =0
              go_ProviderDemand(i)       =NINT(vGP%oDemandNoAg_acft(i))                          ! acft a-1 :integer

               go_providerpop(i)=0  
              go_providerpop(i)          =NINT(gvf_populations(i))                             !  ppl a-1
             end do
            ! --------------------
            ! Send to CityModel
            ! ------------------------
!            vGP%cPopProvider(j) 
!            vPV%gvf_cCAP_used_AF_a(i)
!            vPV%gvf_cSRP_A_used_AF_a(i)+vPV%gvf_cSRP_NCS_used_AF_a(i)
!            vPV%gvf_cSRP_BC_used_AF_a(i)
!            vPV%gvf_cMunicipalPumping_AF(i)

!            vPV%lvf_cDemand_Res_outdoor_AF_annual(i)
!            vPV%lvf_cDemand_Res_indoor_AF_annual(i)
!            vPV%lvf_cDemand_Cio_outdoor_AF_annual(i)
!            vPV%lvf_cDemand_Cio_indoor_AF_annual(i)
            ! --------------------------------------------------------------
            ! Write to the log file, unit 7
            if(T%year == T%startyear)then
              if(gvl_WriteToDisk)&
               write(7,*)"  Provider.f90"
            endif
            ! --------------------------------------
          !
        end subroutine sProvider
        ! ---------------------------------
        !
        ! ======================================================================================
            subroutine aDemandSupply(T,vGP,vLP)

             integer :: i,j,k,lvi_countSRP
             integer :: lvi_One,lvi_Two,lvi_Three,lvi_Four,lvi_Five,lvi_Six

             real :: lvf_CAP(gvi_maxProV),lvf_SRP_A(gvi_maxProV),lvf_SRP_BandCpump(gvi_maxProV),lvf_SRP_NCS(gvi_maxProV)
             real :: lvf_reservoirSRP(gvi_maxProV)
             real :: lvf_GWpumpageMunicipal_AF(gvi_maxProV),lvf_SRP_BandCresAndPumping(gvi_maxProV)
             real :: lvf_otherWater(gvi_maxProV)
             real :: lvf_CAPunused(gvi_maxProV),lvf_SRPunused(gvi_maxProV)
             real :: lvf_addWater,lvf_subtWater(gvi_maxProV)
             !
             real :: lvf_Off_CAP(gvi_maxProV),lvf_On_CAP(gvi_maxProV)
             real :: lvf_Off_NCS(gvi_maxProV),lvf_On_NCS(gvi_maxProV)
             real :: lvf_Off_GWater(gvi_maxProV),lvf_On_GWater(gvi_maxProV)
             real :: lvf_capAvailable(gvi_maxProV)
             real :: lvf_srpAvailable(gvi_maxProV)
             !
             type(Provider)vGP
             type(LocalProvider)vLP
             type(runTime)T
            ! =====================
            ! --------------------------------------------------------------------
              !
              if(gpl_DemandDriven)then
                  !
                  call sMaskCAP(gvl_maskCAP)
                  call sMask(gvl_mask)
                  do i = 1,gvi_Providers,1
                    lvi_One=0; lvi_Two=0; lvi_Three=0; lvi_Four=0; lvi_Five=0; lvi_Six=0
                    do j = 1,12 ,1
                      lvi_One=nint(gvf_WaterDemand_AF(i,j,1))
                      lvi_Two=nint(gvf_WaterDemand_AF(i,j,2))
                      lvi_Three=nint(gvf_WaterDemand_AF(i,j,3))
                      lvi_Four=nint(gvf_WaterDemand_AF(i,j,4))
                      lvi_Five=nint(gvf_WaterDemand_AF(i,j,5))
                      lvi_Six=nint(gvf_WaterDemand_AF(i,j,6))
                    !
                    ! Write to Provider.txt
                    if(gvl_WriteToDisk)then
                        if(gvl_mask(i))then
                            write(4,5)T%year,i,j,lvi_One,lvi_Two,lvi_Three,lvi_Four,lvi_Five,lvi_Six
                        endif
                    endif

                    end do
                  end do
                  !
                  do i = 1,gvi_Providers,1
                    lvf_CAP(i)=0
                    lvf_SRP_A(i)=0
                    lvf_SRP_NCS(i)=0
                    lvf_SRP_BandCpump(i)=0
                    lvf_GWpumpageMunicipal_AF(i)=0
                    !
                    do j = 1,12,1
                      if(gvf_WaterDemand_AF(i,j,6) == 1)then
                       ! This is the raw municipial and CIO demand
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 2)then
                        vGP%gvf_cVadose_a(i)=gvf_WaterDemand_AF(i,j,1) & 
                          - gvf_WaterDemand_AF(i,1,1) ! OK
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 3)then
                        vGP%gvf_cDirectInjection_a(i)=gvf_WaterDemand_AF(i,j,1) &
                          - gvf_WaterDemand_AF(i,1,1) ! OK
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 4)then
                         vLP%lvf_reclaimed(i)=gvf_WaterDemand_AF(i,j,4) &
                          + gvf_WaterDemand_AF(i,j,5)
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 5)then
                         vLP%lvf_ROreclaimed(i)=gvf_WaterDemand_AF(i,j,4) &
                          + gvf_WaterDemand_AF(i,j,5)
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 6)then
                        lvf_SRP_A(i)= gvf_WaterDemand_AF(i,j,4)  & 
                          + gvf_WaterDemand_AF(i,j,5)
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 7)then
                         lvf_SRP_BandCresAndPumping(i)=gvf_WaterDemand_AF(i,j,5)
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 8)then
                       lvf_CAP(i)= gvf_WaterDemand_AF(i,j,4) &
                          + gvf_WaterDemand_AF(i,j,5)
                        !
                        lvf_Off_CAP(i)=gvf_WaterDemand_AF(i,j,4) 
                        lvf_On_CAP(i)=gvf_WaterDemand_AF(i,j,5)
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 9)then
                       lvf_SRP_NCS(i)= gvf_WaterDemand_AF(i,j,4) &
                          + gvf_WaterDemand_AF(i,j,5)
                        !
                        lvf_Off_NCS(i)=gvf_WaterDemand_AF(i,j,4) 
                        lvf_On_NCS(i)=gvf_WaterDemand_AF(i,j,5)
                        !
                      else if(gvf_WaterDemand_AF(i,j,6) == 10)then
                        lvf_GWpumpageMunicipal_AF(i)=gvf_WaterDemand_AF(i,j,4) &
                          + gvf_WaterDemand_AF(i,j,5)
                        !
                        lvf_Off_GWater(i)=gvf_WaterDemand_AF(i,j,4) 
                        lvf_On_GWater(i)=gvf_WaterDemand_AF(i,j,5)
                        !
                     else if(gvf_WaterDemand_AF(i,j,6) == 11)then
                        !
                         vLP%lvf_GWbanking(i)=gvf_WaterDemand_AF(i,j,4) &
                          + gvf_WaterDemand_AF(i,j,5)
                         vGP%gvf_cGetWBanking_a(i)=vLP%lvf_GWbanking(i)
                        !
                     else
                       vLP%lvf_unMetDemand_AF(i)=gvf_WaterDemand_AF(i,j,2)
                     endif  
                    end do
                  end do
                  !
                  ! -----------------------------------------------------------------------------------
                  ! 10 provider NCS
                  call sMaskSRP(gvl_maskSRP)
                    lvi_countSRP=1
                  do i = 1,gvi_Providers,1
                     lvf_SRP_BandCpump(i)=0
                    lvf_SRP_BandCpump(i)=vLP%lvf_BandCpumpingPass_35_AF(i)
                    !
                     ! DAS 02.10.12
                     lvf_reservoirSRP(i)=0
                    lvf_reservoirSRP(i)=max(0,lvf_SRP_BandCresAndPumping(i)-lvf_SRP_BandCpump(i))

                   if(gvl_maskSRP(i))then
                     vLP%lvf_NCS(lvi_countSRP)=0 ! 
                     vLP%lvf_NCS(lvi_countSRP)=  lvf_SRP_NCS(i)
                    !
                    vLP%lvf_demand_SRP_used_AF(lvi_countSRP)= lvf_SRP_A(i)+ lvf_SRP_NCS(i)
                    vLP%lvd_providerSRP_classA_35_AF(T%year,i)=lvf_SRP_A(i)
                    vGP%gAclassBCdesignationsUsed_A_maf(T%year,lvi_countSRP)= lvf_SRP_BandCpump(i)* gpd_acftTomaf
                    !
                    lvi_countSRP=lvi_countSRP+1
                   endif
                       !
                     lvf_CAPunused(i)=0
                     lvf_SRPunused(i)=0
                    if(lvf_CAP(i) < vGP%gRealizedDesignationCAP_acft(T%year,i))then
                      lvf_CAPunused(i)=vGP%gRealizedDesignationCAP_acft(T%year,i)-lvf_CAP(i)
                    endif
                      ! This no longer has meaning
                      lvf_SRPunused(i)=vLP%lvf_unusedClass_A_AF(i)
                       !
                      vGP%gvf_cSetWBanking_a(i)= 0
                      vGP%gvf_pAddToSRPrelease(i)=0
                    if(gvi_WBankingOption(i) == 1)then
                      if(0 < gvf_parm_SWtoWB(i) .and. gvf_parm_SWtoWB(i) <= 1)then
                        vGP%gvf_cSetWBanking_a(i)= gvf_parm_SWtoWB(i)*(lvf_SRPunused(i)+lvf_CAPunused(i))
                        vGP%gvf_pAddToSRPrelease(i)=(gvf_parm_SWtoWB(i)*lvf_SRPunused(i)) * gpd_acftTomaf
                      endif
                        ! 07.18.11 
                        gvf_WBankingBalance(T%year+1,i,1)=gvf_WBankingBalance(T%year,i,1)+vGP%gvf_cSetWBanking_a(i)
                    else
                      gvf_WBankingBalance(T%year+1,i,1)=gvf_WBankingBalance(T%year,i,1)+gvf_parm_SWtoWBamount(i)
                      vGP%gvf_cSetWBanking_a(i)=0.
                    endif
                      ! Save balance for Kernel.f90 loop
                      gvf_GW_Banking_Hold(i)=gvf_WBankingBalance(T%year+1,i,1)
                      !
                      ! FOR GPCD calculations; do not include banked or stored water
                     lvf_subtWater(i)=0
                    if(0 < gvf_parm_WStoDIamount(i) .or. 0 < gvf_parm_SWtoVadoseAmt(i))then
                      if(gvl_maskCAP(i))then
                       lvf_subtWater(i)=gvf_parm_WStoDIamount(i)+gvf_parm_SWtoVadoseAmt(i)
                      endif

                      ! Have surface water
                      lvf_otherWater(i)= vLP%lvf_reclaimed(i)+  vLP%lvf_ROreclaimed(i)+  & 
                        lvf_GWpumpageMunicipal_AF(i) 
                    else
                      ! 
                      lvf_otherWater(i)= vLP%lvf_reclaimed(i)+  vLP%lvf_ROreclaimed(i)+  & 
                        lvf_GWpumpageMunicipal_AF(i) 
                    endif

                      ! send SRP pumping to CitiWaterBudgets.f90
                      ! -------------------------------------------------------
                      vLP%lvf_providerSRP_NCS_35_AF(T%year,i)= lvf_SRP_NCS(i)
                      vLP%lvd_providerSRP_total_35_AF(T%year,i)= lvf_SRP_A(i)+ lvf_SRP_NCS(i) + lvf_SRP_BandCresAndPumping(i)
                      vLP%lv_ProvidersSRPpumping_AF(T%year,i)=lvf_SRP_BandCpump(i)
                      vGP%oSRPpumping_a(i)=lvf_SRP_BandCpump(i)*gpd_acftTomaf   

                      vLP%lvf_CAP_used_AF(i)=lvf_CAP(i)
                      ! Pass to monthly: all water used
                      vLP%lvd_demand_designations(i)=(lvf_CAP(i)+lvf_SRP_A(i)+ lvf_SRP_NCS(i) + lvf_SRP_BandCresAndPumping(i) &
                        +   vLP%lvf_reclaimed(i)+  vLP%lvf_ROreclaimed(i)+  vLP%lvf_GWbanking(i))*gpd_acftTomaf
                      !
                      vGP%oGWpumpingNoSRP_a_maf(i)= lvf_GWpumpageMunicipal_AF(i)*gpd_acftTomaf
                       vGP%oGWrecharge_a_maf(i)=0.
                      vGP%oSWandSRPused_a_maf(i)=vLP%lvd_demand_designations(i)
                    !
                    vGP%gvf_cCAP_used_AF_a(i)     = vLP%lvf_CAP_used_AF(i)
                    !
                    ! Send to CityModel
                    ! ---------------------------------------------
                    vGP%gvf_cSRP_A_used_AF_a(i)   =lvf_SRP_A(i)
                    vGP%gvf_cSRP_BC_used_AF_a(i)  =lvf_SRP_BandCpump(i)
                    vGP%gvf_cSRP_NCS_used_AF_a(i) =lvf_SRP_NCS(i)
                    vGP%gvf_cSRP_BCresAndPump_AF_a(i)= lvf_SRP_BandCresAndPumping(i)
                    vGP%gvf_cMunicipalPumping_AF(i)=lvf_GWpumpageMunicipal_AF(i)
1 format(I4,1x,I2,1x,5(F14.6,1x))
                  end do
                  ! -------------------------------------------
                  !
                    call sMask(gvl_mask)
                  do k = 1,gvi_Providers,1

                    ! Send outputs to the interface
                    ! ------------------------------------------------------------------------------
                    !
                    ! Checked: 02.10.12
                    ! ======================
                     vGP%gvf_cCAP_acft(k)=0.
                    vGP%gvf_cCAP_acft(k)=vGP%gRealizedDesignationCAP_acft(T%year,k)

                     lvf_capAvailable(k)=li_designationsCAP(k,1) + li_designationsCAP(k,2)
                    call sEightyPercentCAP(k,vGP%gvf_cCAP_acft,lvf_capAvailable,gvl_removeRestrictionsCO)

                    ! send SRP pumping to the Interface
                    ! ------------------------------------
                    ! Checked: 02.10.12
                     go_GWPumpageSRP_acft(k)=0
                    go_GWPumpageSRP_acft(k)=nint(lvf_SRP_BandCpump(k))

                   ! Not currently used in the API
                   ! Total provider water used
                    ! ------------------------------
                    ! Checked 02.10.12
                     go_ProviderWaterUsed_acft(k)=0
                    go_ProviderWaterUsed_acft(k)= nint(lvf_CAP(k)+lvf_SRP_A(k)+ lvf_SRP_NCS(k)+ lvf_SRP_BandCresAndPumping(k) &
                      + vLP%lvf_reclaimed(k)+  vLP%lvf_ROreclaimed(k)+  vLP%lvf_GWbanking(k) + lvf_GWpumpageMunicipal_AF(k))

                     ! Municipal pumping
                    ! --------------------------
                    ! Checked 02.10.12
                     go_GWPumpageMuni_acft(k)=0
                    go_GWPumpageMuni_acft(k)    = nint(lvf_GWpumpageMunicipal_AF(k))

                    ! Not doing groundwater recharge at the moment
                    go_GWRecharge_acft(k)       = 0                 
                    ! --------------------------------

                    ! Designated water for each provider-
                    ! Not currently using this variable
                    ! -----------------------------------
                    ! Checked: 02.10.12
                    ! schedule to be removed from the common block
                    ! go_Designations_acft(k)=0
                    !

                    ! New definition as of 02.10.12 -das to be consistant with GWDesignations(k)
                    ! ---------------------------
                    ! Checked: 02.10.12
                     go_SWdesignations_acft(k)=0
                    go_SWdesignations_acft(k)   = nint(lvf_CAP(k)+lvf_SRP_A(k)+ lvf_SRP_NCS(k)+ lvf_reservoirSRP(k) ) ! acft a-1
                    ! 

                    ! Legal, available CO River water from CAP
                    ! ----------------------------------------
                    ! Checked: 02.10.12
                     go_annualDeliveriesCO(k)=0
                    go_annualDeliveriesCO(k)   =NINT(vGP%gRealizedDesignationCAP_acft(T%year,k))     ! acft a-1


                    ! Going to want to add a variable for USED CO water

                    ! Legal amount of CAP in their contract (and purchased water)
                    ! -------------------------------------
                    ! Checked 02.10.12
                     go_maxDeliveriesCO(k)=0
                    go_maxDeliveriesCO(k)      =NINT(li_designationsCAP(k,1) +li_designationsCAP(k,2) )   

                    ! GPCD of various sorts
                      lvf_addWater=0
                      lvf_addWater              =max(0,(lvf_otherWater(k) + lvf_CAP(k)+lvf_SRP_A(k)+ lvf_SRP_NCS(k)+lvf_SRP_BandCpump(k))-lvf_subtWater(k))
                     go_adjustedGPCD(k)=0
                    go_adjustedGPCD(k)          = nint(max(0,lvf_addWater* (1./T%days) *gpd_galperacft* (1./vGP%cPopProvider(k))))
                    !
                     go_providersGPCD(k)=0
                    go_providersGPCD(k)        =nint(max(0,vGP%oDemandNoAg_acft(k)* (1./T%days) *gpd_galperacft*1./vGP%cPopProvider(k)))
                    !
                  end do
2 format(I4,1x,I2,1x,7(I8,1x),2(I4,1x))
!                  do k = 1,10,1
                  call sMaskSRP(gvl_maskSRP)
                    lvi_countSRP=1
                    do i = 1,gvi_Providers,1
                    if(gvl_maskSRP(i))then

                        ! Class A designations
                        ! -------------------------------------
                        ! Checked 02.10.12
                        go_classAdesignations(lvi_countSRP)  =0
                      go_classAdesignations(lvi_countSRP)   =NINT(lvf_SRP_A(i))             ! acft a-1

                        ! Needs re-defining: I have a variable already (ProvNormalFlowAvailable) NOT verified !!!!
                        go_classAmax(lvi_countSRP)            =0

                        ! Class BC designations
                        ! -------------------------------------
                        ! Checked 02.10.12
                        go_classBCdesignations(lvi_countSRP)  =0
                      go_classBCdesignations(lvi_countSRP)  =NINT( lvf_SRP_BandCresAndPumping(i))             ! acft a-1

                        ! Class BC maximum designations
                        ! -------------------------------------
                        ! Checked 02.10.12
                        go_classBCmax(lvi_countSRP)           =0
                      go_classBCmax(lvi_countSRP)           =NINT(vGP%gAclassBCdesignationsMax_10_maf(T%year,lvi_countSRP)*(1./gpd_acftTomaf) )
             
                        ! Class BC designations from surface water
                        ! -----------------------------------------
                        ! Cannot Check 02.10.12- not in the C# API
                        goi_classBCstorage_acft(lvi_countSRP)      =0
                      goi_classBCstorage_acft(lvi_countSRP)      =nint(lvf_reservoirSRP(i))

                        go_NCS_acft(lvi_countSRP)             =0
                      go_NCS_acft(lvi_countSRP)             =NINT(lvf_SRP_NCS(i))

                        go_NCSmax_acft(lvi_countSRP)          =0
                      go_NCSmax_acft(lvi_countSRP)          =NINT((1./gpd_acftTomaf)*vLP%lvf_maxNCS(lvi_countSRP) )

                        ! Class ABC designations delivered
                        ! -------------------------------------
                        ! Checked 02.10.12
                        go_annualDeliveriesSRP(lvi_countSRP)  =0                  
                      go_annualDeliveriesSRP(lvi_countSRP)  =NINT(lvf_SRP_A(i)+ lvf_SRP_NCS(i)+lvf_SRP_BandCresAndPumping(i))  ! maf a-1
                                            ! Class ABC designations max
                        ! -------------------------------------
                        ! 
                        go_maxDeliveriesSRP(lvi_countSRP)     =0
                      go_maxDeliveriesSRP(lvi_countSRP)     =NINT((1./gpd_acftTomaf)*  (li_designationsSVT(42,lvi_countSRP)+vGP%gAclassBCdesignationsMax_10_maf(T%year,lvi_countSRP) &
                        + vLP%lvf_maxNCS(lvi_countSRP)))

                        lvf_srpAvailable(i)=lvf_SRP_A(i)+ lvf_SRP_BandCresAndPumping(i)
                        call sEightyPercentSRP(lvf_srpAvailable(i),gvf_designationsCAPandSRP(i,2),gvl_removeRestrictionsSVT(i))
                        !
                      !
                      lvi_countSRP=lvi_countSRP+1
                      !
                    end if

if(gvl_WriteToMyDisk)then
if(i == 25)then
!write(2,*)T%year,lvf_SRP_A(i), lvf_SRP_NCS(i),lvf_SRP_BandCresAndPumping(i)-lvf_reservoirSRP(i),lvf_reservoirSRP(i), gvf_WaterDemand_AF(i,1,1)
endif
endif
                        ! Signify when 80% of surface water designations
                        ! cannot be met (exclude NCS for SRP members)
                        ! ----------------------------------------------
                        ! Checked 03.24.12, 03.28.12

                        call sEightyPercent(i,lvf_srpAvailable(i),gvf_WaterDemand_AF(i,1,3), &
                            vGP%gRealizedDesignationCAP_acft(T%year,i),lvf_capAvailable(i),gvl_removeGWRestrictions(i))
                        !
                  end do
                  !
3 format(I4,1x,2(I2,1x),8(I8,1x))
                  ! Send outputs to the interface: annual outputs
                  ! -----------------------------------------------------------------
                    ! marked for removal from common block
                   go_annualGroundwaterDemandSRP=0  

                    go_mandiCAP=0
                  go_mandiCAP                  =nint(vGP%gCAPMandI_II(T%year))     ! acft a-1
                  !
                  ! ------------------------------------------------------------------
                !
              else
              endif
            ! =====================
          !
5           format(I4,1x,2(I2,1x),6(I8,1x),I2)
          end subroutine aDemandSupply
          !--------------------------

         ! --------------------------
          subroutine aDifference(T,vGP)

             integer :: i

             type(Provider)vGP
             type(runTime)T
             ! -------------
              
!              E%MySub='SupplyDemand'
!              E%TStep=1
              !
              do i = 1,gvi_Providers,1

              ! -----------------------------------------------------------------
                vGP%lvf_cDemand_Res_outdoor_AF_annual(i)=gvf_TotalDemand_AF(i) &
                  * gvf_parm_WStoRes_Prop(i)*gvf_parm_OutDoorProp(i)

                vGP%lvf_cDemand_Res_indoor_AF_annual(i) =gvf_TotalDemand_AF(i) &
                  * gvf_parm_WStoRes_Prop(i)*(1-gvf_parm_OutDoorProp(i))

                vGP%lvf_cDemand_Cio_outdoor_AF_annual(i)=gvf_TotalDemand_AF(i) &
                  * gvf_parm_WStoCio_Prop(i)*gvf_parm_OutDoorProp(i)

                vGP%lvf_cDemand_Cio_indoor_AF_annual(i) =gvf_TotalDemand_AF(i) &
                  * gvf_parm_WStoCio_Prop(i)*(1-gvf_parm_OutDoorProp(i))
              ! -----------------------------------------------------------------
              end do
              !
          end subroutine aDifference
         ! --------------------------
         ! =========================================================================
     !
End Module lms_Provider
   ! -----------------------------------------------
   !
   subroutine NexchangeVariables(Sin,vLP)
     use lms_Provider
      use gm_ModelControl
       use gm_TypeCOntrol
        
        integer :: i,k
        !
          ! ============
          type(LocalProvider)vLP
          type(Surfacewater)Sin
          ! ====================
           !
          do k = 1,10,1
            ! Are these working?
           vLP%lvf_maxNCS(k)=Sin%sNCSmaxAllocations_maf(k)
          end do
           !
           vLP%lvf_BandCpumpingPass_35_AF=Sin%gvf_pumpBandC_35_AF

          do i = 1,gvi_Providers,1
            vLP%lvf_unusedClass_A_AF(i)=Sin%lvf_unusedClass_A_AF(i)
          end do
          !
    end subroutine NexchangeVariables
    ! -------------------------------

    ! -----------------------
    subroutine sWaterProviders(T,Sin,vGP)
      use lms_Provider
       use gm_Global
        use gm_ModelControl
         use gm_TypeCOntrol
          !
          ! =====================
          type(Surfacewater)Sin
          type(Provider)vGP
          type(LocalProvider)vLP
          type(runTime)T
          ! ============
          ! 
          call NexchangeVariables(Sin,vLP)
          call sProvider(T,vGP,vLP)
          call writetodisk_(T,vLP,vGP)
          !
    end subroutine sWaterProviders
    ! ----------------------------

    ! ----------------------------
    !
! -----------------------------------------------------------------------------
! E.O.F.