!
! File is ProviderPopulationandDemand.f90
!
! This file contains the provider level estimates of water demand and population
!
! Created on 06.09.10 
!
!
! Global OUTPUTS: 
!
! Local OUTPUTS:   No local outputs
!
! Local INPUTS:    Inputs are outputs
!
!
! Last write was: 03.05.12
! -----------------------------------------------------------------------------------
Module lm_ProviderPopulation
 use gm_ModelControl
  use gm_GlobalData

    implicit none
    ! -----------
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
  contains
     subroutine initPop()
       call openFiles_pop()
       call readFiles_pop()
     end subroutine initPop
      ! ----------------------
      subroutine openFiles_pop()
        character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
        if(gpl_release)lvc_dataPath=trim(gvc_DPath)
        !
         LU=50
        inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\providerPopulation_2085.txt'),exist=lexist)
        if(lexist)then
          open(50,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\providerPopulation_2085.txt'),status="unknown")
        else
         if(gvl_WriteToDisk)then
          write(7,*)"Data in module lm_ProviderPopulation missing(or corrupt): providerPopulation_2085.txt", "Logical Unit = ", LU 
         endif
        endif
         LU=51
        inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\providerDemand_2085.txt'),exist=lexist)
        if(lexist)then
          open(51,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\providerDemand_2085.txt'),status="unknown")
        else
         if(gvl_WriteToDisk)then
          write(7,*)"Data in module lm_ProviderPopulation missing(or corrupt): providerDemand_2085.txt", "Logical Unit = ", LU 
         endif
        endif
        !
         LU=52
        inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\providerAcres_2012.txt'),exist=lexist)
        if(lexist)then
          open(52,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\providerAcres_2012.txt'),status="unknown")
        else
         if(gvl_WriteToDisk)then
          write(7,*)"Data in module lm_ProviderPopulation missing(or corrupt): providerAcres_2012.txt", "Logical Unit = ", LU 
         endif
        endif
        !
      !
         LU=53
        inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\onProject_2030.txt'),exist=lexist)
        if(lexist)then
          open(LU,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\onProject_2030.txt'),status="unknown")
        else
         if(gvl_WriteToDisk)then
          write(7,*)"Data in module lm_ProviderPopulation missing(or corrupt): onProject_2030.txt", "Logical Unit = ", LU 
         endif
        endif
        !



        return
      end subroutine openFiles_pop 
     ! ---------------------------

        ! ------------------------
        subroutine readFiles_pop()
            !
            integer :: LU
            integer :: i,j,k,ios
            integer :: lvi_countSRP
            real(8) :: lvd_onProjPopProportion(2000:2030,10)
            ! ---------------------
            ios=0
            LU=0
            !----------------
            ! Read from Disk
            ! Provider-level data; populations and water demand
            !--------------------------------------------------------------------------------------
            ! acft a-1
            ! 
            read(50,*,err=41,iostat=ios)((li_providerpop(i,j),j=1,gvi_maxProV),i=gpi_lBY,gpi_uBY)
            read(51,*,err=42,iostat=ios)((li_providerDemand(i,j),j=1,gvi_maxProV),i=gpi_lBY,gpi_uBY)
            read(52,*,err=43,iostat=ios)((lid_providerAcres(i,j),j=1,2),i=1,gvi_maxProV)
            read(53,*,err=44,iostat=ios)((lvd_onProjPopProportion(i,j),j=1,10),i=gpi_lBY,2030)
             !
             gvd_onProjectPop=lvd_onProjPopProportion
             !
            ! -------------------------------------------------------------------------------------
             ! 
 41          continue
            close(50)
            if(ios >0)then
             LU=50
             goto 1000
            endif
42          continue
            close(51)
            if(ios >0)then
             LU=51
             goto 1000
            endif
43          continue
            close(52)
            if(ios >0)then
             LU=52
             goto 1000
            endif
44          continue
            close(53)
            if(ios >0)then
             LU=53
             goto 1000
            endif
            ! -------------------
            call sMaskSRP(gvl_maskSRP)
            lvi_countSRP=1
            do i = 1,gvi_Providers,1
              if(gvl_maskSRP(i))then     
                 gvd_acreageSVT(lvi_countSRP,1)=li_acreageSVT(lvi_countSRP) ! Class A from Designations_SVT.f90 (lm_Designations_A)
                 gvd_acreageSVT(lvi_countSRP,2)=lid_providerAcres(i,1) ! on project 
                 gvd_acreageSVT(lvi_countSRP,3)=lid_providerAcres(i,2)
                lvi_countSRP=lvi_countSRP+1
              endif
            end do 
!              gvd_acreageSVT(k,1)= ! Class A
!              gvd_acreageSVT(k,2)= ! On project
!              gvd_acreageSVT(k,3)= ! off-project

            ! -------------------
 140        format(10(F7.5,1x))
 141        format(F5.3)
 142        format(F6.0)
 143        format(F6.0)
            !
         return
1000     continue
           if(gvl_WriteToDisk)&
            write(7,*)'ProviderPopullationandDemand.f90 line 95: Error in file read, logical unit is', LU
        end subroutine readFiles_pop
  End Module lm_ProviderPopulation
!
Module lms_ProviderPopandDemand
 use gm_ModelControl
  use gm_GlobalData
   use gm_TypeControl
    use gm_Euler
    !
    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
    character(10),parameter :: Model='ProvPopDem'
    !
 contains
       ! -------------------------------
        subroutine calcDemand(T)
          use gm_Exception
            !
            ! Requires: gv_popgrowthfactor - from interface
            !           li_providerpop(T%year,i): population by provider - from include file
            !           lv_providerDemandRandM - from include file
            !           gv_EmpiricalGPCD - from include file
            ! ----------------------------------------------------------
            !
           integer :: i,j,k,lvi_countSRP
           real(8) :: differencepop(gpi_lBY:gpi_uBY,gvi_maxProV)
           real(8) :: differencefluxpop(gvi_maxProV),differencedemand(gvi_maxProV)
           real(8) :: lv_addedDemand_acft(gvi_maxProV)
           real(8) :: lv_annual,tfe(12,2)
           real(8) :: vPeakmonth
           !
           real, parameter :: lvf_resDemand_Proportion=0.7
           real :: lvf_resDemand_Prop(gvi_maxProV)
           real :: lvf_cioDemand_Prop(gvi_maxProV)
           !
           ! demand based on a simple exponential smoothing of GPCD (over time)
           real :: lvf_GPCD(gvi_maxProV,100)
           real :: lvf_Tmax,lvf_TmaxP
           real :: lvf_Tresponse,lvf_TresponseP(12)
           real :: lvf_demandTot,lvf_avgTresponse,lvf_avgDresponse
           real :: lvf_GPCD_total(gvi_maxProV),lvf_GPCD_use(gvi_maxProV) !lvf_GPCD_res(gvi_maxProV)
                      ! http://www.azwaterinstitute.org/media/EWSR/200909/200909_Hartmann.pdf
           real, parameter :: lvf_CF_Hartmann=-3.7 ! NOAA CLIMAS 200909_Hartmann.pdf
           real :: lvf_TDiff
           real :: lvf_providerArea2012(gvi_maxProV) 
           real :: lvf_TestPop(gvi_maxProV)
           !
           real :: lvf_popGrowthFactor,lvf_ProviderPopFromInterface(gpi_lBY:gpi_uBY,gvi_maxProV)
           real :: lvf_popYearly
           logical :: lvl_demandOption(4)
            !
            real(8) :: lv_adjustedDemand(gpi_lBY:gpi_uBY,gvi_maxProV)
            real(8) :: lv_ratioGPCD(gpi_lBY:gpi_uBY,gvi_maxProV)
           !
           type(Exception)E
           type(runTime)T
           ! ===============
            !
            E%MySub='calcDemand'
            !
            ! Conditional defaults - in Interface
            lvf_demandTot=0
            !
              gvf_ReductionGPCD_pct=gvi_ReductionGPCD_pct   
            if(gvi_ReductionGPCD_pct < 1)gvi_ReductionGPCD_pct=1
            !
            gvf_ReductionGPCD_pct=gvi_ReductionGPCD_pct
            !
            ! Change from integer input from the interface to float
            if(0 == gvi_ReductionDemand_pctOfBaseline)gvi_ReductionDemand_pctOfBaseline = 100
            !
            ! Should move this to read input and put in global memory
            call ProviderArea2012(lvf_providerArea2012)
            !
            gvf_providerAreaTotal_m2=sum(lvf_providerArea2012)
            !
            ! Calculate the on and off project lands
            ! 02.06.12 DAS- data from Ray
            ! ------------------------------------------
            ! From above
            ! --------------------------
                  call sMaskSRP(gvl_maskSRP)
                    lvi_countSRP=1
              do i = 1,gvi_Providers,1
                gvd_classABCacreRatio(i)=0
                  ! 12.30.11 DAS
                  ! On (provider,1) and off (provider,2)
                 ! 04.09.12 DAS
                    if(gvl_maskSRP(i))then
                      if(T%year < 2031)then
                        gvd_classABCacreRatio(i)=gvd_onProjectPop(T%year,lvi_countSRP)
                      else
                        gvd_classABCacreRatio(i)=gvd_onProjectPop(2030,lvi_countSRP)
                      endif
                       lvi_countSRP=lvi_countSRP+1
                    endif
!                  gvd_classABCacreRatio(i)= lid_providerAcres(i,1) * (1./(lid_providerAcres(i,1)+lid_providerAcres(i,2)))
!                    if(i == 25) gvd_classABCacreRatio(i)=0.4
              end do
            ! ---------------------------------------------------------------------------------------
            !           Population - set and adjust
            ! --------------------------------------
            !
           do i = 1,gvi_Providers,1
            differencefluxpop(i)=0.
            differencepop(T%year,i)=0.
            if(0 < gi_ProviderPopulation(i))gvl_popFromInterface(i)=.true.
            lvf_TestPop(i) =gi_ProviderPopulation(i)
            lvf_ProviderPopFromInterface(T%year,i)= lvf_TestPop(i)
           end do
            !
              lvf_popGrowthFactor=0
!              gvf_ResponseToGrowth=0
            !
            do i = 1,gvi_Providers,1
              ! 12.17.11 DAS
                if(T%year == T%startyear)then
                  differencepop(T%year,i) = 0 
                else
                  if(gvl_popFromInterface(i))then
                    differencepop(T%year,i) = lvf_ProviderPopFromInterface(T%year,i)- lvf_ProviderPopFromInterface(T%year-1,i) ! ppl a-
                  else
                    differencepop(T%year,i) =  li_providerpop(T%year,i)-li_providerpop(T%year-1,i) ! ppl a-
                  endif
                endif
              !
              ! Use one value for all providers if > 1, or use provider-specific values
              
                if(0 < gv_popgrowthfactor)then
                 differencefluxpop(i) =differencepop(T%year,i)*gv_popgrowthfactor
                else
                 differencefluxpop(i) =differencepop(T%year,i)*gv_PopGrowthRateAdjPct(i)
                endif
                 go_PopGrowthRate(i)=0
                if(T%year == T%startyear)then
                else
                 go_PopGrowthRate(i)=nint((li_providerpop(T%year,i)-li_providerpop(T%year-1,i))*gv_PopGrowthRateAdjPct(i))
                endif

               ! Used for passing into MODFLOW
                ! ------------------------------------------------------------------------------------------
                lvf_popYearly=0
                if(gvl_popFromInterface(i))then
                  if( 0 < lvf_ProviderPopFromInterface(T%year,i))then
                     lvf_popYearly= lvf_ProviderPopFromInterface(T%year,i)
                  else
                    if(2000 < T%year)then
                      lvf_popYearly= gvd_shadowPopulation(T%year-1,i)+ differencefluxpop(i)
                    else
                      lvf_popYearly= gvd_shadowPopulation(T%year,i)+ differencefluxpop(i)
                    endif
                  endif
                else
                  lvf_popYearly=li_providerpop(T%year,i)
                endif
                  !
                  lvf_popGrowthFactor=lvf_popGrowthFactor + differencefluxpop(i)* (1./lvf_popYearly)
                  !
                ! -----------------------------------------------------------------------------------------
                !
                !
                ! popgrowthfactor incremental changes population, updated each time-step
                if(T%year == T%startyear)then
                  lv_GrowthRateAdjPop(T%year,i)=li_providerpop(T%year,i)
                else
                  if(gvl_popFromInterface(i))then
                    lv_GrowthRateAdjPop(T%year,i)=  lvf_ProviderPopFromInterface(T%year-1,i) + differencefluxpop(i)
                  else
                    lv_GrowthRateAdjPop(T%year,i)=lv_GrowthRateAdjPop(T%year-1,i)+ differencefluxpop(i)
                  endif
                endif
            !
            end do
            !
!            gvf_ResponseToGrowth=1+(lvf_popGrowthFactor * (1./gvi_Providers))
            !
            ! ----------------------------------------------------------------------------------------
            !
              do i = 1,4,1
                lvl_demandOption(i)=.false.
              end do
            !
            ! --------------------------
            ! Be careful of this DEFAULT SETTING DAS
            if(0 == gvi_ProviderDemandOption)gvi_ProviderDemandOption=3
            !
            if(gvi_ProviderDemandOption==1)lvl_demandOption(1)=.true.
            if(gvi_ProviderDemandOption==2)lvl_demandOption(2)=.true.
            if(gvi_ProviderDemandOption==3)lvl_demandOption(3)=.true.
            if(gvi_ProviderDemandOption==4)lvl_demandOption(4)=.true.
            !
            if(lvl_demandOption(1))then
             ! Read Demand from files
              do i = gpi_minPVY,gpi_maxPVY,1
                do j = 1,gvi_Providers,1
                  ! 06.2.11 das
                  lv_providerDemand(i,j)= li_providerDemand(i,j)
                  lv_providerDemandRandM(i,j)= lv_providerDemand(i,j)
                  !
                end do
              end do
            else if (lvl_demandOption(2))then
              !
              ! Demand adjusted by the six-year average GPCD by provider
              ! --------------------
              call GPCD(gv_EmpiricalGPCD)
              !
              do i = gpi_minPVY,gpi_maxPVY,1
                do j = 1,gvi_Providers,1
                  lv_adjustedDemand(2006,j)=((gv_EmpiricalGPCD(j)*365)/325851.43326)*lv_GrowthRateAdjPop(2006,j)
                  lv_ratioGPCD(2006,j)=lv_adjustedDemand(2006,j) * (1./li_providerDemand(2006,j))
                  lv_ratioGPCD(i,j)=lv_ratioGPCD(2006,j)
                end do
              end do
              !
              do i = gpi_minPVY,gpi_maxPVY,1
                do j = 1,gvi_Providers,1
                !
                ! Total Demand - 
                ! GPCD modified demand curves      
                lv_providerDemand(i,j)= lv_ratioGPCD(i,j)*li_providerDemand(i,j)
                ! 
                ! 06.15.10 das-This is what I gave GeoDa in May 2010 sans Ag
                lv_providerDemandRandM(i,j)= lv_providerDemand(i,j)
                end do
              end do
            else if (lvl_demandOption(3))then
            else if (lvl_demandOption(4))then
            else
            endif
            !
           ! ====================================================
            do j = 1,gvi_Providers,1
               !  write to the inputs file (2000 only)
               go_providerpop(j)=li_providerpop(2000,j)  
               go_ProviderDemand(j)=li_providerDemand(2000,j)
               !--------------------------------------------------       
            end do
            ! ====================================================

            ! ---------------------------------------------------------------------
            !


            ! --------------------------------------------------------------------------
            !           Demand - Adjusted
            ! --------------------------------
           ! Option 1, read demand directly from the file: modify for population growth changes ONLY
          select case(gvi_ProviderDemandOption)
          case (1)
            do i = 1,gvi_Providers,1
              lv_addedDemand_acft(i)=0.
                if(2000 < T%year)then
                 differencedemand(i)=lv_providerDemandRandM(T%year,i)-lv_providerDemandRandM(T%year-1,i)
                else
                 differencedemand(i)=lv_providerDemandRandM(T%year,i)-lv_providerDemandRandM(T%year,i)
                endif
               !
               lv_addedDemand_acft(i)= differencedemand(i)*gv_popgrowthfactor
               !
               if(T%year == T%startyear)then
                if(2000 < T%year)then
                 lv_GrowthRateAdjDemand(T%year,i)=lv_providerDemandRandM(T%year-1,i)+lv_addedDemand_acft(i)
                else
                 lv_GrowthRateAdjDemand(T%year,i)=lv_providerDemandRandM(T%year,i)+lv_addedDemand_acft(i)
                endif
               else
                lv_GrowthRateAdjDemand(T%year,i)=lv_GrowthRateAdjDemand(T%year-1,i)+lv_addedDemand_acft(i)
               endif
             end do
          case(2)
          !       Six year averages of GPCD = gv_EmpiricalGPCD
            !
            do i = 1,gvi_Providers,1

              lv_addedDemand_acft(i)=0.
                if(2000 < T%year)then
                  differencedemand(i)=max(0,lv_providerDemandRandM(T%year,i)-lv_providerDemandRandM(T%year-1,i))
                else
                  differencedemand(i)=max(0,lv_providerDemandRandM(T%year,i)-lv_providerDemandRandM(T%year,i))
                endif
                !
                if(gv_popgrowthfactor <= 0.999)then
                  if(0 < gv_popgrowthfactor)then
                    lv_addedDemand_acft(i)= -(differencefluxpop(i)* gv_EmpiricalGPCD(i)*T%days* (1./gpd_galperacft))
                  else
                    lv_addedDemand_acft(i)= (differencefluxpop(i)* gv_EmpiricalGPCD(i)*T%days* (1./gpd_galperacft))
                  endif
                else
                 lv_addedDemand_acft(i)= (differencefluxpop(i)* gv_EmpiricalGPCD(i)*T%days* (1./gpd_galperacft))
                endif
                !
                 if(T%year == T%startyear)then
                    if(2000 < T%year)then
                      lv_GrowthRateAdjDemand(T%year,i)=lv_providerDemandRandM(T%year-1,i)+lv_addedDemand_acft(i)
                    else
                      lv_GrowthRateAdjDemand(T%year,i)=lv_providerDemandRandM(T%year,i)+lv_addedDemand_acft(i)
                    endif
                 else
                    lv_GrowthRateAdjDemand(T%year,i)=max(0,lv_GrowthRateAdjDemand(T%year-1,i)+lv_addedDemand_acft(i))
                 endif
                !
              call GPCD(gv_EmpiricalGPCD)
               goi_SES_GPCD(i)=(gv_EmpiricalGPCD(i))
                !
            end do
          case(3)
                ! Simple exponential smoothing of ADWR gpcd data extended for the simulation; 
               do j = 1,gvi_Providers,1
                !
                lvf_GPCD_total(j)=gv_AdjustedGPCD(j)
                lvf_GPCD_use(j)=lvf_GPCD_total(j)
                !
                call SESgpcdRunning(T,gvf_ReductionGPCD_pct,j,T%year,lvf_GPCD_use,lvf_GPCD) !          
                !
                if(T%startyear == 2000)then
                 k=T%year-1998
                else if(T%startyear == 2001)then
                 k=T%year-1999
                else
                 k=T%year-(T%startyear-2)
                endif
                !
                 lv_GrowthRateAdjDemand(T%year,j) = &
                 ((lvf_GPCD(j,k)*365)*(1./gpd_galperacft))*lv_GrowthRateAdjPop(T%year,j)
                !
                goi_SES_GPCD(j)=nint(lvf_GPCD(j,k))
                !
              end do
          case(4)
                ! Simple exponential smoothing of ADWR gpcd data extended for the simulation; gpcd modified
                ! from the C# interface to alter the estimates at any point
              do j = 1,gvi_Providers,1
                ! Take inputs from the Interface
                if(0 < gv_AdjustedGPCD(j))then
                  lvf_GPCD_total(j)=gv_AdjustedGPCD(j)
                  lvf_GPCD_use(j)=gv_AdjustedGPCD(j)
                else
                  lvf_GPCD_use(j)=0.
                endif
                !
                call SESgpcdRunning(T,gvf_ReductionGPCD_pct,j,T%year,lvf_GPCD_use,lvf_GPCD) !          
                !
               if(T%startyear == 2000)then
                 k=T%year-1998
                else if(T%startyear == 2001)then
                 k=T%year-1999
                else
                 k=T%year-2004
                endif
                 !
                if(lv_GrowthRateAdjPop(T%year,j) < 1)lv_GrowthRateAdjPop(T%year,j)=1.
                if(0 < gv_AdjustedGPCD(j))then
                  lv_GrowthRateAdjDemand(T%year,j) = &
                    ((lvf_GPCD_use(j)*365)*(1./gpd_galperacft))*lv_GrowthRateAdjPop(T%year,j)
                  !
                  goi_SES_GPCD(j)=nint(lvf_GPCD_use(j))
                  !
                else
                  lv_GrowthRateAdjDemand(T%year,j) = &
                    ((lvf_GPCD(j,k)*365)*(1./gpd_galperacft))*lv_GrowthRateAdjPop(T%year,j)
                  !
                  goi_SES_GPCD(j)=nint(lvf_GPCD(j,k))
                  !
                endif
                !
              end do
          !
          case default
            write(7,*)" Error in the selection of gvi_ProviderDemandOption: ProviderPopulationandDemand.f90"
          end select
          !
          do j = 1,gvi_Providers,1
              !
              if(T%year == T%startyear)lv_providerDemandRandM(T%year,j)=lv_GrowthRateAdjDemand(T%year,j)
               gvf_populations(j)=lv_GrowthRateAdjPop(T%year,j) 
               gvf_demandNoAg(j)=lv_GrowthRateAdjDemand(T%year,j) 
               gvf_demand(j)=lv_GrowthRateAdjDemand(T%year,j)
              !
7             format(I4,1x,I2,1x,2(F9.1,1x))
              ! 2 March 2011,07.19.11 das
               gvf_TotalDemand_AF(j)=gvf_demandNoAg(j)
              ! 
               gvf_WaterDemand_AF(j,1,1)=anint(gvf_TotalDemand_AF(j)) ! Total demand
               gvf_WaterDemand_AF(j,1,2)=anint(gvf_TotalDemand_AF(j)*(1.- gvd_classABCacreRatio(j))) ! Off Project
               gvf_WaterDemand_AF(j,1,3)=anint(gvf_TotalDemand_AF(j)- gvf_WaterDemand_AF(j,1,2)) ! On Project
              !
               gvf_reclaimedInputMax(T%year,j)=0.
              gvf_reclaimedInputMax(T%year,j)=gvf_WaterDemand_AF(j,1,1)*gvf_parm_RtoInputMaxPct(j)
              !
              go_OnProjectDemand(j)= nint(gvf_WaterDemand_AF(j,1,3))
              go_OffProjectDemand(j)= nint(gvf_WaterDemand_AF(j,1,2))
              !
           end do
           !
            ! ------------------------------------------------------------------
            !
            ! Note: 03.20.12
            ! ==============
            if(gpl_test_SRPrelease)then
              do j = 1,gvi_Providers,1
              !
               gvd_classABCacreRatio(j)=0.5
              !
                
                lv_GrowthRateAdjPop(T%year,j)=800000
                k=T%year-1998
                lvf_GPCD(j,k)=200
               gvf_demandNoAg(j)= ((lvf_GPCD(j,k)*365)*(1./gpd_galperacft))*lv_GrowthRateAdjPop(T%year,j)
                gvf_populations(j)= lv_GrowthRateAdjPop(T%year,j)
               gvf_demand(j)=5000
              !
              ! 2 March 2011,07.19.11 das
               gvf_TotalDemand_AF(j)=gvf_demandNoAg(j)
              ! 
               gvf_WaterDemand_AF(j,1,1)=anint(gvf_TotalDemand_AF(j)) ! Total demand
               gvf_WaterDemand_AF(j,1,2)=anint(gvf_TotalDemand_AF(j)*(1.- gvd_classABCacreRatio(j))) ! Off Project
               gvf_WaterDemand_AF(j,1,3)=anint(gvf_TotalDemand_AF(j)- gvf_WaterDemand_AF(j,1,2)) ! On Project
              !
               gvf_reclaimedInputMax(T%year,j)=0.
!              gvf_reclaimedInputMax(T%year,j)=gvf_WaterDemand_AF(j,1,1)*gvf_parm_RtoInputMaxPct(j)
              !
              go_OnProjectDemand(j)= anint(gvf_WaterDemand_AF(j,1,3))
              go_OffProjectDemand(j)= anint(gvf_WaterDemand_AF(j,1,2))
              !
              end do
            endif
            !
            ! ------------------------------------------------------------------
                !
                if(T%year == T%startyear)then
                if(gvl_WriteToDisk)&
                    write(7,*)"  ProviderPopulationandDemand.f90"
                 endif
                 !
          ! -------------------------------------------------------------------------------
            ! =============
            do i = 1,12,1
              do j = 1,2,1
               tfe(i,j)=0.
              end do
            end do
            ! =============
  
              !  Estimate the runoff change on the Colorado River
              !  using difference in temperature.
        
            if(gpl_ClimateDriven)then
              if(gvl_IncludeMeteorology)then
                call SESRunningT(T,lvf_MetData,lvf_MetDataProjected,lvf_TDiff)
!               if(lvf_TDiff /= 0)then
                gv_climatefactorCO=(100+(lvf_CF_Hartmann*lvf_TDiff))*0.01
                ! Set bounds
                if(gv_climatefactorCO < 0)gv_climatefactorCO=0
                if(2 < gv_climatefactorCO)gv_climatefactorCO=2
!               endif
                !
                          !
                ! Monthly water demand for each provider
                ! ------------------------------------------------
                !
                ! Temperature response in water demand (Tmax)
                !
                !lvf_demandTot=lvf_demandTot+ gvf_demandNoAg(j)
                lvf_demandTot=gvf_demandNoAg(1)
                lvf_avgTresponse=0
                do j = 1,12,1
                  lvf_Tresponse=0

                  lvf_Tmax=lvf_MetData(T%year,j,1)
                  lvf_TmaxP=lvf_MetDataProjected(T%year,j,1)
                  call sProportional_Temp(lvf_Tmax,lvf_TmaxP,lvf_demandTot,lvf_Tresponse)
              
                  lvf_TresponseP(j)=lvf_Tresponse
                  lvf_avgTresponse=(lvf_avgTresponse+ lvf_TresponseP(j))
                end do
                lvf_avgTresponse=lvf_avgTresponse/12
                !
                gvf_ResponseToTemperature=lvf_avgTresponse
                !
                !
                ! Sensitivity analyses: Water demand, temperature, and Tmax (avg)
                ! ----------------
                lvf_avgDresponse=0
                do k = 1,gvi_Providers,1
                  if(k /= 22)then
                    if(k /= 23)then
                      lvf_avgDresponse=lvf_avgDresponse+gvf_demandNoAg(k)
                    endif
                  endif
                end do
                lvf_avgDresponse=lvf_avgDresponse/33
                !
              endif ! include meteorology logical
            else
              !
              lvf_avgTresponse=1
              do j = 1,12,1
                lvf_TresponseP(j)=1
              end do
              !
            endif
             ! ------------------------------------------------------------
             !
           if(gpi_timeStepWB /=1)then
             do k = 1,gvi_Providers,1

              lvf_resDemand_Prop(k)=lvf_resDemand_Proportion
              if(0 < gvf_parm_WStoRes_Prop(k))then
                lvf_resDemand_Prop(k)=gvf_parm_WStoRes_Prop(k)
              endif
                lv_annual=0.
               lv_annual=(gvf_TotalDemand_AF(k)*lvf_resDemand_Prop(k))*gpd_acftTomaf ! Place holder- assume 70% residential
               vPeakmonth=6.5  
               ! ---------------------------------------------------------------------
                 E%MyFunction='Type5ERes' ; E%TStep=0 ; E%Prov=k; E%MyCall='DemandRES'
               call typefiveExpRes(Model,E,lv_annual,vPeakmonth,tfe)
               ! ---------------------------------------------------------------------
               !
               ! Written to a common memory block
               do j = 1,12,1
                 do i = 1,2,1
                  vState_Res_demand_monthly(k,j,i)=nint(tfe(j,i)*lvf_TresponseP(j))
                 end do
               end do
               !        
               lvf_cioDemand_Prop(k)=1.-lvf_resDemand_Proportion

              if(0 < gvf_parm_WStoCio_Prop(k))then
                 lvf_cioDemand_Prop(k)=gvf_parm_WStoCio_Prop(k)
              endif
 
               lv_annual=(gvf_TotalDemand_AF(k)* (lvf_cioDemand_Prop(k)))*gpd_acftTomaf
               vPeakmonth=7.5
                ! --------------------------------------------------------------------
                 E%MyFunction='Type5CIO' ; E%TStep=0 ; E%Prov=k; E%MyCall='DemandCIO'
                call typefiveExpCIO(Model,E,lv_annual,vPeakmonth,tfe)
                ! --------------------------------------------------------------------
              ! 
              ! Written to a common memory block
              do j = 1,12,1
                 do i = 1,2,1
                  vState_CandO_demand_monthly(k,j,i)=nint(tfe(j,i)*lvf_TresponseP(j))
                 end do
              end do
               !
               ! -----        
           end do ! end do provider (k) =1,gvi_Providers,1
            ! -------------------------------------------------------------------------------
            !
           endif
13 format(I4,1x,I2,1x,I2,1x,F4.1,1x,F4.2,1x,I5,1x,F10.2,1x,I5,1x,F10.2)
        end subroutine calcDemand
        !---------------------------
     !
End Module lms_ProviderPopandDemand
!
  subroutine sUnmetDemand(T,gvi_order,lvl_flag,lvl_Interrupt)
   use gm_Global
    use gm_ModelControl
     use gm_TypeCOntrol
      use lms_ProviderPopandDemand
        !
        integer :: i
        integer(1) :: gvi_order
        logical :: lvl_Interrupt
        logical :: lvl_flag(gvi_maxProV)
        real :: code=12

        ! ================
        type(runTime)T
        ! ===============
          !
          ! ==================================================
          ! Unmark these if I once again use feedback loops
!          if(lvl_Interrupt)goto 1
           lvl_Interrupt=.false.
          do i = 1,gvi_Providers,1
            gvf_WaterDemand_AF(i,gvi_order,6)=code
          end do
          !
          do i = 1,gvi_Providers,1
            lvl_flag(i)=.false.
            gvl_parm_shortage(i)=.false.
              !
              ! Deficit year or situation.
              if(0 < gvf_WaterDemand_AF(i,gvi_order,1))then
!                lvl_flag(i)=.true.
!                lvl_Interrupt=.true.
!                gvl_parm_shortage(i)=.true.
              else
                lvl_flag(i)=.false.
                gvl_parm_shortage(i)=.false.
              endif
              !
              call sParameterControl_tstep(T,i)
              !
            end do
            !
            if(lvl_Interrupt)then
!              call sClearDemand(T,lvl_flag(i))
            endif  
            goto 10
1          continue    
            lvl_Interrupt=.false.
10         continue
        !
        ! ==================================================
       !
        return
        
  end subroutine sUnmetDemand
  !
  subroutine sDemand(T,gvi_order)
   use gm_Global
    use gm_ModelControl
      use lms_ProviderPopandDemand
        !
        integer :: i
        integer(1) :: gvi_order
        real :: code=1
        ! ================
        type(runTime)T
        ! ===============
        !
        ! ==================================================
        do i = 1,gvi_Providers,1
           !
             gvf_WaterDemand_AF(i,gvi_order,1)=  gvf_WaterDemand_AF(i,1,1) 
             gvf_WaterDemand_AF(i,gvi_order,2)=  gvf_WaterDemand_AF(i,1,2)
             gvf_WaterDemand_AF(i,gvi_order,3)=  gvf_WaterDemand_AF(i,1,3) 
           !
            gvf_WaterDemand_AF(i,gvi_order+1,1)=  gvf_WaterDemand_AF(i,1,1) 
            gvf_WaterDemand_AF(i,gvi_order+1,2)=  gvf_WaterDemand_AF(i,1,2)
            gvf_WaterDemand_AF(i,gvi_order+1,3)=   gvf_WaterDemand_AF(i,1,3)
           !
           gvf_WaterDemand_AF(i,gvi_order,6)=code
           !
        end do
        !
        gvi_order=gvi_order+1
       !
       ! ==================================================
      !
  end subroutine sDemand

  subroutine globalDemand(T)
   use gm_Global
    use gm_ModelControl
     use gm_TypeCOntrol
      use lms_ProviderPopandDemand
        !
        integer :: i,j,k
        ! ================
        type(runTime)T
        ! ===============
          ! 
          ! 15 Defined but only 12 used at the monent
         if(gpl_DemandDriven)then
            do i = 1,gvi_Providers,1
              do j = 1,15,1
                do k = 1,6,1
                  gvf_WaterDemand_AF(i,j,k)=0
                end do
              end do
            end do
          endif
          !
          call calcDemand(T)
          !
  end subroutine globalDemand
  ! ----------------------------------------------------------------------------
  !
  ! Utilities 
  ! ------------------------
  subroutine sClearDemand(T)
   use gm_Global
    use gm_ModelControl
     use gm_TypeCOntrol
      use lms_ProviderPopandDemand
        !
        integer :: i,j,k

        type(runTime)T
        ! ===============
          !
          if(gpl_DemandDriven)then
            do i = 1,gvi_Providers,1
                do j = 1,12,1
                 if(1 < j)then
                   do k = 1,6,1
                    if(3 < k)then
                     gvf_WaterDemand_AF(i,j,k)=0
                    endif
                   end do
                 endif
                end do
            end do
          endif
          !
  end subroutine sClearDemand
  ! -------------------------

        ! ------------------------------------
        subroutine ProviderArea2012(vArea2012)
            use lms_ProviderPopandDemand
            integer :: i
            real,parameter :: lvc_AcresToSqMeters=4046.8564224
            real :: vArea2012(gvi_maxProV) ! m2
            !
            do i = 1,gvi_Providers,1
              vArea2012(i)=0
             vArea2012(i)=lvc_AcresToSqMeters* (lid_providerAcres(i,1) + lid_providerAcres(i,2)) 
            end do  
        end subroutine ProviderArea2012
        ! ------------------------------------

       ! ------------------------------------
        subroutine ProviderArea2012i(i,Relative)
            use lms_ProviderPopandDemand
            integer :: i
            real,parameter :: lvc_AcresToSqMeters=4046.8564224
            real :: vArea2012(gvi_maxProV) ! m2
            real :: Relative(gvi_maxProV)
            !
              vArea2012(i)=0
             vArea2012(i)=lvc_AcresToSqMeters* (lid_providerAcres(i,1) + lid_providerAcres(i,2)) 
            !
             Relative(i)=0
            if(0 < gvf_providerAreaTotal_m2)Relative(i)=vArea2012(i)/gvf_providerAreaTotal_m2
          return
        end subroutine ProviderArea2012i
        ! ------------------------------------


! =================================================================================================
! E.O.F.