!
! File is WaterDemand_county.f90
!
! This file simulates the Maricopa County-level water demand
!
! Global OUTPUTS:
!           
!
! Local OUTPUTS:

! Local INPUTS:
!             
!---------------------------------------------------
!            
! created on 11.18.09
!
! david arthur sampson
! last write was: 02.10.12
! -------------------------------------------------------------------------------------------------
!
Module lm_GPdemand
 use gm_GlobalData

    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'

 contains
     subroutine initGP()
       call openFiles_gp()
       call readParms_gp()
       call readFiles_gp()
       call initState_gp()
      end subroutine initGP
      ! ----------------------
        subroutine openFiles_gp()
          !
          character(len=200) :: lvc_dataPath='App_Data\WaterSim_4_0\'
          if(gpl_release)lvc_dataPath=trim(gvc_DPath)
          !
           LU=26
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\countyPopulationGRate.txt'),exist=lexist)
          if(lexist)then
            open(26,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\countyPopulationGRate.txt'),status='unknown')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_GPdemand missing(or corrupted): countyPopulationGRate.txt", "Logical Unit = ", LU 
            endif
          endif
           LU=27
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\countyResidentialdemand.txt'),exist=lexist)
          if(lexist)then
            open(27,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\countyResidentialdemand.txt'),status='old')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_GPdemand missing(or corrupted): countyResidentialdemand.txt", "Logical Unit = ", LU 
            endif
          endif
           LU=28
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Data\countyCommandotherdemand.txt'),exist=lexist)
          if(lexist)then
            open(28,FILE=trim(trim(lvc_dataPath)//'App_Data\Data\countyCommandotherdemand.txt'),status='old')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_GPdemand missing(or corrupted): countyCommandotherdemand.txt", "Logical Unit = ", LU 
            endif
          endif
           LU=32
          inquire(FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_D.dat'),exist=lexist)
          if(lexist)then
            open(32,FILE=trim(trim(lvc_dataPath)//'App_Data\Parameters\parm_D.dat'),status='old')
          else
            if(gvl_WriteToDisk)then
             write(7,*)"Data in module lm_GPdemand missing(or corrupted): parm_D.dat", "Logical Unit = ", LU 
            endif
          endif
          !
        end subroutine openFiles_gp
       ! -----------------------
        subroutine readParms_gp()
            !
            read(32,*)li_acresAgMaricopa 
            read(32,*)li_ag_switch
            read(32,*)gv_agretirementyear
            read(32,*)li_baselinecommdemand
            read(32,*)li_baselineresdemand
            read(32,*)li_mesicproportion
            read(32,*)li_poolsproportion
            read(32,*)gv_popgrowthfactor
            read(32,*)gv_resdensitypath
            !
            close(32)
            ! initialize these FOR Debug - be careful
            gv_WaterPolicyStartYear=2006
            lv_residentialGPCD=172
            gv_totalGPCD=210
            gv_waterPolicy=2
            gv_PropPools=0.13
            gv_PropMesic=0.13
            gv_shortagepolicy=1
            !
         end subroutine readParms_gp
         subroutine readFiles_gp()
            integer :: i,j,ios,iyear
            integer :: LU
            !  
            real :: vInitpop_2006=3692786   ! ppl in 2006 Maricopa Co.
            real :: vInitpop_2000=3072168   ! ppl in 2000 Maricopa Co.
            real :: vInitpop_2001=3175604   ! ppl in 2001 Maricopa Co.
            real :: vInitpop_2002=3279040   ! ppl in 2002 Maricopa Co.
            real :: vInitpop_2003=3382476   ! ppl in 2003 Maricopa Co.
            real :: vInitpop_2004=3485912   ! ppl in 2004 Maricopa Co.
            real :: vInitpop_2005=3589348   ! ppl in 2005 Maricopa Co.
            !
            ! Read unit 20; Maricopa Co. population growth rates
            !-----------------------------------------------------
            !  
            LU=26 
            do i = 2000, gpi_uBY,1
             read(LU,*,err=11,iostat=ios)iyear,li_popgrorateMaricopa(i)
             if(i == 2000)li_staticpopMaricopa(i)=vInitpop_2000
             if(i == 2001)li_staticpopMaricopa(i)=vInitpop_2001
             if(i == 2002)li_staticpopMaricopa(i)=vInitpop_2002
             if(i == 2003)li_staticpopMaricopa(i)=vInitpop_2003
             if(i == 2004)li_staticpopMaricopa(i)=vInitpop_2004
             if(i == 2005)li_staticpopMaricopa(i)=vInitpop_2005
             if(i == 2006)li_staticpopMaricopa(i)=vInitpop_2006
             iyear=iyear*1 ! place holder
            end do
            do i = 2001, gpi_uBY,1
             li_staticpopMaricopa(i)=li_staticpopMaricopa(i-1)*(1+li_popgrorateMaricopa(i-1))
            end do
11          continue
            close(LU)
            if(ios >0)then
            LU=20
            goto 1000
            endif
            !   
            ! Residential and commercial-industrial-other water demand
            !--------------------------------------------------------------------
            read(27,*,err=12,iostat=ios)((li_resDemand(i,j),j=1,3),i=2000, gpi_uBY)  
            read(28,*,err=13,iostat=ios)((li_cioDemand(i,j),j=1,7),i=2000, gpi_uBY)                             ! maf a-1
            !
12          continue
            close(27)
            if(ios >0)then
            LU=27
            goto 1000
            endif
13          continue
            close(28)
            if(ios >0)then
            LU=28
            goto 1000
            endif
        !
 121        format(3(F12.10,1x))
 122        format(7(F12.10,1x))
        !
         return
          1000 continue
           if(gvl_WriteToDisk)&
            write(7,*)" Error reading file input: line 162- WaterDemand_county.f90- logical unit is:", LU
        end subroutine readFiles_gp
       ! -----------------------        
        subroutine initState_gp()
            !
            real(8) :: vInitpop_2006=3692786              ! ppl in 2006 Maricopa Co.
            gv_PopMaricopa=vInitpop_2006
            !
        end subroutine initState_gp
       !
end Module lm_GPdemand
! ====================
Module lms_GPdemand
  use gm_ModelControl
   use gm_GlobalData
    use gm_TypeControl
     use gm_Euler

    include 'C:\WaterSim\WaterSimTesting\WaterSimTesting\bin\Debug\App_Data\WaterSim_4_0\App_Data\Include\WaterSimDCDC.txt'
    !
    type SurfWater
        real(8) :: lv_AgUseWithShortagePolicy(gpi_lBY:gpi_uBY)
        real(8) :: lv_ResUseWithShortagePolicy(gpi_lBY:gpi_uBY)
        real(8) :: lv_CIOUseWithShortagePolicy(gpi_lBY:gpi_uBY)
    end type SurfWater
    !
  contains
 !=================================================================================================

        ! ----------------------------------------
        subroutine aAgriculture(T,vRetirementrate)
        
           real(8) :: vRetirementrate
           real(8) :: vAg_acres(gpi_lBY:gpi_uBY)
           real :: vAcresGWaBuildout = 65346          ! acres
           real :: vAg_waterduty=2.88                 ! acres*ft / acres
           type(runTime)T
           !==============
            !
            if(T%year == T%startyear)then
             vAg_acres(T%year)=li_acresAgMaricopa
             lv_ag_acres(T%year)=vAg_acres(T%year)
            endif
            vRetirementrate=0.
            if(li_acresAgMaricopa >= vAcresGWaBuildout)then
             ! State variable Lag in PowerSim. To match values, I must lag vRetirementrate by one year
             if(T%year == T%startyear)then
              vRetirementrate=0.
             else
              vRetirementrate=(li_acresAgMaricopa-vAcresGWaBuildout) * (1./(gv_agretirementyear-T%startyear))
             endif
            endif
            !
             lv_ag_acres(T%year)=lv_ag_acres(T%year)-vRetirementrate
            vState_Ag_demand(T%year)=lv_ag_acres(T%year)*vAg_waterduty*gpd_acftTomaf
            vAg_acres(T%year)=lv_ag_acres(T%year)
            !
         end subroutine aAgriculture
        !---------------------------

        ! ------------------------
        subroutine aResidential(T)
    
            integer :: vRes_switch=2      
            real(8) :: vPopminusDESpop
            real(8) :: vAddpopResidential
            real(8), parameter :: vSfmult=3.96 !2/3.
            real(8), parameter  :: vPoolconst=0.00000005785,vMesicconst=0.0000000001997      ! not sure yet what this number is
            real(8) :: vSfhouseholds,vAddpoolResidential,vAddmesicResidential
            real(8) :: vPools, vMesic
            real :: lv_baselineGPCD=170
            type(runTime)T
           !==============
            !
            vProppools=gv_PropPools
            vPropmesic=gv_PropMesic
            !
            vState_PopMaricopa(T%year)=li_staticpopMaricopa(T%year)
            ! 
            ! 
            if(T%year == 2000 .or. T%year == 2006)then
             vState_PopMaricopa(T%year)=vState_PopMaricopa(T%year)
            else
              vState_PopMaricopa(T%year)=vState_PopMaricopa(T%year-1)+  &
              (li_staticpopMaricopa(T%year)-li_staticpopMaricopa(T%year-1))*gv_popgrowthfactor
            endif
             !
            if(vState_PopMaricopa(T%year) <=0)goto 100
            ! delta pop
            vPopminusDESpop=vState_PopMaricopa(T%year)- li_staticpopMaricopa(T%year)
            ! delta GPCD 
!             vBaselineres=gv_residentialGPCD
             ! maf
             vAddpopResidential=0
             vAddpopResidential=((lv_baselineGPCD*T%days) * (1./gpd_galperacft))*vPopminusDESpop *gpd_acftTomaf
            !
            vSfhouseholds=vState_PopMaricopa(T%year) * (1./vSfmult)
            vPools=0.
            vMesic=0.
             vPools= vProppools-li_poolsproportion
             vMesic=vPropmesic-li_mesicproportion
            !
            vAddpoolResidential=0
            vAddmesicResidential=0
            vAddpoolResidential=vPoolconst*vSfhouseholds*vPools
            vAddmesicResidential=vMesicconst*vSfhouseholds*vMesic
            !
            if(vRes_switch==1)then
             vState_Res_demand(T%year)=li_resDemand(T%year,gv_resdensitypath) 
            else
             vState_Res_demand(T%year)=li_resDemand(T%year,gv_resdensitypath)+vAddpoolResidential + &
                vAddmesicResidential+vAddpopResidential
            endif
             !
         return
         100 continue
           if(gvl_WriteToDisk)&
            write(7,*) " Population at zero. line 279 in WaterDemand_county.f90"
        end subroutine aResidential
        !---------------------------

        !--------------------------
        subroutine aCommandother(T)

            integer :: k
            integer :: vComm_switch=2
            real(8) :: vPopminusDESpop,vAddpopcommandother
            real :: lv_baselineGPCD=170

            type(runTime)T
           !==============
            !
            li_cioDemand(T%year,8)=0.
            do k=1,7
             li_cioDemand(T%year,8)=li_cioDemand(T%year,8)+li_cioDemand(T%year,k)
            end do
            !
            vAddpopcommandother=0.
            vPopminusDESpop=vState_PopMaricopa(T%year)- li_staticpopMaricopa(T%year)
            vAddpopcommandother=(((1.33*lv_baselineGPCD-lv_baselineGPCD)*T%days) * (1./gpd_galperacft))*vPopminusDESpop *gpd_acftTomaf
            !
            if(vComm_switch==1)then
             vState_CandO_demand(T%year)=li_cioDemand(T%year,8) 
            else
             vState_CandO_demand(T%year)=li_cioDemand(T%year,8)+vAddpopcommandother
            endif
            !
          end subroutine aCommandother
          !---------------------------

        ! --------------------------------
        subroutine choosepolicy(T,GWO,MSW)

            integer :: fLogicalToInteger
            real(8) :: vRout,vCOout
            real(8) :: MSW
            logical :: GWO

            type(runTime)T
            type(SurfWater)W
           !================
            !
            if(fLogicalToInteger(GWO) == 1)gv_waterPolicy=1
            !
              ! Default- satisfy demand
              ! ----------------------------
              ! ---------------------------------------
!                P%ag_waterUse_monthly=vRAg_monthly
!                P%res_waterUse_monthly=vRres_monthly
!                P%cio_waterUse_monthly=vRCandO_monthly
              ! ---------------------------------------
            !
            select case(gv_waterPolicy)
            case(1)
             !
             ! No overdraft
             ! ------------------------------
             !
              call sustainable(T,MSW,GWO,W)
              ! ----------------------------
                vState_Ag_demand(T%year)   =W%lv_AgUseWithShortagePolicy(T%year)
                vState_Res_demand(T%year)  =W%lv_ResUseWithShortagePolicy(T%year)
                vState_CandO_demand(T%year)=W%lv_CIOUseWithShortagePolicy(T%year)
              ! -----------------------------------------------------------------
             !
            case(2)
            !
            ! Meet (satisfy demand) 
            !
            case(3)
            !
            ! Achieve no overdraft within "SlideYrs" years
            ! --------------------------------------------------------
             !
              !
                call sustainable(T,MSW,GWO,W)
                call slidingaverage(T,W,vRout,vCOout)
              !
              if(T%year >= gv_WaterPolicyStartYear+2)then
               vState_Ag_demand(T%year)=W%lv_AgUseWithShortagePolicy(T%year)
               vState_Res_demand(T%year)=vRout
               vState_CandO_demand(T%year)=vCOout
              !
              endif
            !
            case(4)
            ! 
            ! --------------------------------------------------------
            !
             if(T%year >= gv_WaterPolicyStartYear+1)then
              if(gv_residentialGPCD /= 0)lv_residentialGPCD=gv_residentialGPCD
!             vState_Ag_demand(T%year)
              vState_Res_demand(T%year)= &
                ((lv_residentialGPCD*T%days)/gpd_galperacft)*vState_PopMaricopa(T%year) *gpd_acftTomaf
              vState_CandO_demand(T%year)= (((gv_totalGPCD-lv_residentialGPCD)*T%days) &
                /gpd_galperacft)*vState_PopMaricopa(T%year) *gpd_acftTomaf

             endif
            !
             ! catch exception
             case default
                if(gvl_WriteToDisk)&
                write(7,*) " Water Policy not entered as 1-4: line 389 in WaterDemand_county.f90"
                goto 100
            end select

            ! This needs refinement
            go_residentialGPCD= nint(vState_Res_demand(T%year) &
              *1./gpd_acftTomaf * 1/T%days *gpd_galperacft *1./vState_PopMaricopa(T%year))
            !
         return
        100 stop
        end subroutine choosepolicy
        ! -------------------------

        ! ------------------------------------
        subroutine sustainable(T,MSW,GWOride,W)

               integer :: fLogicalToInteger,i
               real(8) :: vTotdemand,vPctResandCIOdemand,vShortage,vPctShortage
               real(8) :: MSW,vRAg,vRres,vRCandO
               logical, intent(in) :: GWOride

                type(runTime)T
                type(SurfWater)W
               !=================
                !
                if(T%year == T%startyear)then
                 do i = 2000,2050,1
                  W%lv_AgUseWithShortagePolicy(i)=0
                  W%lv_ResUseWithShortagePolicy(i)=0
                  W%lv_CIOUseWithShortagePolicy(i)=0
                 end do
                endif
                !
                vRAg=vState_Ag_demand(T%year)
                vRres=vState_Res_demand(T%year)
                vRCandO= vState_CandO_demand(T%year) !1.33*vRres - vRres !vState_CandO_demand(T%year)
                !
                 vTotdemand=0.
                vTotdemand=vRAg+vRres+vRCandO
                 vPctResandCIOdemand=0.
                vPctResandCIOdemand=vRres * (1./(vRres+vRCandO))
                 vShortage=0.
                vShortage=max(0.,vTotdemand-MSW)
                 vPctShortage=0.
                vPctShortage=vShortage * (1./vTotdemand)
                !
                !
                if(fLogicalToInteger(GWOride) == 0)then
                    if(T%year >= gv_WaterPolicyStartYear+1)then
                        if(gv_shortagepolicy == 1)then
                        ! proportional sharing in shortages
                        !
                         W%lv_AgUseWithShortagePolicy(T%year)=(1.-vPctShortage)*vRAg
                         W%lv_ResUseWithShortagePolicy(T%year)=(1.-vPctShortage)*vRres
                         W%lv_CIOUseWithShortagePolicy(T%year)=(1.-vPctShortage)*vRCandO
                         !
                        else
                         ! Agriculture takes the first hit on a shortage
                         W%lv_AgUseWithShortagePolicy(T%year)=max(0.,vRAg-vShortage)
                         W%lv_ResUseWithShortagePolicy(T%year)=vRres-max(0.,vShortage  -vRAg)*vPctResandCIOdemand
                         W%lv_CIOUseWithShortagePolicy(T%year)=vRCandO-max(0.,vShortage-vRAg)*(1.-vPctResandCIOdemand)
                         !
                        endif
                    else
                         !
                         W%lv_AgUseWithShortagePolicy(T%year)=vRAg
                         W%lv_ResUseWithShortagePolicy(T%year)=vRres
                         W%lv_CIOUseWithShortagePolicy(T%year)=vRCandO
                         !
                    endif
                 !
                else
                    if(gv_shortagepolicy == 1)then
                      !
                      W%lv_AgUseWithShortagePolicy(T%year)=(1.-vPctShortage)*vRAg
                      W%lv_ResUseWithShortagePolicy(T%year)=(1.-vPctShortage)*vRres
                      W%lv_CIOUseWithShortagePolicy(T%year)=(1.-vPctShortage)*vRCandO
                      !
                    else
                      !
                      W%lv_AgUseWithShortagePolicy(T%year)=max(0.,vRAg-vShortage)
                      W%lv_ResUseWithShortagePolicy(T%year)=vRres-(max(0.,vShortage-vRAg)*vPctResandCIOdemand)
                      W%lv_CIOUseWithShortagePolicy(T%year)=vRCandO-(max(0.,vShortage-vRAg)*(1.-vPctResandCIOdemand))
                      !
                    endif
                endif
                !
            end subroutine sustainable
            ! -------------------------

            ! -----------------------------------------
            subroutine slidingaverage(T,W,vRout,vCOout)

                real(8) :: vRout,vResidential,vCOout,vCother
                integer :: i
                integer :: lv_slideYrs=5

                type(runTime)T
                type(SurfWater)W
               !================
                !
                vRout=0 ;vResidential=0. ; vCOout=0. ;vCother=0.
                !
                if(T%year == T%startyear)then
                 do i = gpi_minPVY,gpi_maxPVY,1
                  lv_ResSA(i)=0.
                  lv_CandOSA(i)=0.
                 end do
                endif
                !
                ! This will need testing 02.10.12
                if(T%year == T%startyear)then
                    if(2000 + lv_slideYrs < T%year)then
                        do i = lv_slideYrs,1,-1
                         lv_ResSA(T%year-i)  = W%lv_ResUseWithShortagePolicy(T%year)
                         lv_CandOSA(T%year-i)= W%lv_CIOUseWithShortagePolicy(T%year)
                        end do
                         lv_ResSA(T%year)  =W%lv_ResUseWithShortagePolicy(T%year)
                         lv_CandOSA(T%year)= W%lv_CIOUseWithShortagePolicy(T%year)
                    else
                        lv_ResSA(T%year)  =W%lv_ResUseWithShortagePolicy(T%year)
                        lv_CandOSA(T%year)= W%lv_CIOUseWithShortagePolicy(T%year)
                    endif
                else
                 lv_ResSA(T%year)  =W%lv_ResUseWithShortagePolicy(T%year)
                 lv_CandOSA(T%year)= W%lv_CIOUseWithShortagePolicy(T%year)
                end if
                !
                if(2000 + lv_slideYrs < T%year)then
                    do i = lv_slideYrs,1,-1
                     vResidential=vResidential+lv_ResSA(T%year-i)
                     vCother=vCother+lv_CandOSA(T%year-i)
                    end do
                else
                    vResidential=vResidential+lv_ResSA(T%year)
                    vCother=vCother+lv_CandOSA(T%year)
                endif
                !
                 if(0 < lv_slideYrs)then
                  vRout=vResidential * (1./lv_slideYrs)
                  vCOout=vCother * (1./lv_slideYrs)
                 else
                  vRout=W%lv_ResUseWithShortagePolicy(T%year)
                  vCOout=W%lv_CIOUseWithShortagePolicy(T%year)
                 endif
                !
            end subroutine slidingaverage
            ! -------------------------------

        ! ----------------------------->>>>>>>
        subroutine outinitialD(T)

            integer :: j
            real(8) :: cioDemand,agDemand

            type(runTime)T
           !=======================
            !
           if(T%year /= T%startyear)then
           else
            if(gvl_WriteToDisk)then
            agDemand=421859*2.88 ! for 2006 only "quick code" acres in ag x ag water duty
            ! ---------------------------------------------------------------------------------------
            write(9,*) ""
            write(9,*) "                           Water Demand Variables                           "
            write(9,*) "----------------------------------------------------------------------------"
            write(9,*) "Acres in Agriculture- Maricopa Co.(acres):     ",li_acresAgMaricopa
            write(9,*) "Agriculture retirement year:                   ",gv_agretirementyear
            write(9,*) "Population Maticopa Co. (ppl):                 ",li_staticpopMaricopa(T%year),"-",T%year
           
            write(9,*) "Population growth factor (proportion):         ",gv_popgrowthfactor
            
            write(9,*) "Residential density path:                      ",gv_resdensitypath
            write(9,*) " "
            write(9,*) "Residential water demand (maf):                ",li_resDemand(T%year,gv_resdensitypath)
            cioDemand=0
            do j = 1,7
            cioDemand=cioDemand+li_cioDemand(T%year,j)  ! SUM intrinsic works for one DIM arrays
            end do

            write(9,*) "Commercial, industrial, other demand (maf):    ",cioDemand
            if(T%year == 2006)then
            write(9,*) "Agriculture Demand                             ",agDemand * (1./1e6)
            endif
            write(9,*) "Total Maricopa Water Demand ():                ",li_resDemand(T%year,gv_resdensitypath) &
                                                                         + (cioDemand+agDemand) * (1./1e6)
            write(9,*) ""
            write(9,*) "Proportion of homes with pools:                ",li_poolsproportion
            write(9,*) "Proportion of homes with mesic landscapes:     ",li_mesicproportion
            write(9,*) ""
            write(9,*) "       Some water demand constants used in the model"
            write(9,*) " =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  =  = = = =  =  = = "
            write(9,*) "Baseline residential water demand(maf a-1):    ",li_mesicproportion
            write(9,*) "Baseline comm and Indust water demand(maf a-1):",li_mesicproportion
            write(9,*) "Ag switch:                                     ",li_ag_switch
            write(9,*) "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - "
            endif
            !
          endif
        end subroutine outinitialD
       !---------------------------
        subroutine updateGP(T,D,pop)

            integer, intent(out) :: pop
            type(runTime)T
            type(Demand)D
           !=======================
            !
            lv_ag_acres(T%year+1)=lv_ag_acres(T%year)
            D%dag_demand(T%year)=vState_Ag_demand(T%year)
            D%dres_demand(T%year)=vState_Res_demand(T%year)
            D%dcio_demand(T%year)=vState_CandO_demand(T%year)
            !
            pop=NINT(vState_PopMaricopa(T%year))
            D%dpopGrowthFactor=gv_popgrowthfactor
            !
        end subroutine updateGP
       !---------------------------
        subroutine outputs(T,D,pop)

            integer :: pop
            type(runTime)T
            type(Demand)D
           !=======================
            !
            go_maricopaWaterDemand=NINT((D%dag_demand(T%year)+D%dres_demand(T%year)+D%dcio_demand(T%year))* (1./gpd_acftTomaf))
            gv_PopMaricopa=pop
            !
            if(T%year == T%startyear)then
             if(gvl_WriteToDisk)then
              if(.not. gvl_Interrupt)write(7,*)"  County Demand: "
             endif
            endif
            !
        end subroutine outputs
       !---------------------------
End Module lms_GPdemand
    !  
    subroutine sGPdemand(T,D,pop,GWOride,Sin)
     use gm_ModelControl
      use gm_TypeControl
       use lms_GPdemand

        integer :: pop
        real(8) :: vRetire,MSW
        logical, intent(in) :: GWOride

        type(runTime)T
        type(Demand)D
        type(Surfacewater)Sin
        !=======================
         !
         MSW=Sin%sMaricopaSWS_maf
         call aAgriculture(T,vRetire)
         call aResidential(T)
         call aCommandother(T)
         !
         call choosepolicy(T,GWOride,MSW)
         !
         call updateGP(T,D,pop)
         call outinitialD(T) 
         call outputs(T,D,pop)
         !
    end subroutine sGPdemand
    ! -----------------------
! =================================================================================================
! E.O.F.